	INCLUDE '($JPIDEF)'
	INCLUDE '($SYIDEF)'
	INTEGER*4 N_NODES
	PARAMETER (N_NODES=3)
	CHARACTER*6 NODES(N_NODES)
	DATA NODES/'ANLCMT','ANCMT1','ANCMT2'/
	STRUCTURE /JPI_DATA/
	   UNION
	      MAP
	         INTEGER*4 STAT
	         INTEGER*4 PID
	         INTEGER*2 L_PRCNAM
	         CHARACTER*16 PRCNAM
	         INTEGER*4 STS
	         INTEGER*4 PRI
	         INTEGER*4 DIO
	         INTEGER*4 BIO
	         INTEGER*4 CPUTIM
	         INTEGER*4 PGFLTS
	         INTEGER*4 PHMEM
	         INTEGER*4 TYPE
	         INTEGER*4 OWNER
	         INTEGER*4 UIC
	      END MAP
	      MAP
	         CHARACTER*66 STR
	      END MAP
	   END UNION
	END STRUCTURE
	RECORD /JPI_DATA/ BUF(512)
	INTEGER*2 NL
	INTEGER*2 JPI_REQ(26)
	DATA JPI_REQ/2, JPI$_PID,4, JPI$_PRCNAM,-16, JPI$_STATE,4, JPI$_PRI,4,
	1 JPI$_DIRIO,4, JPI$_BUFIO,4, JPI$_CPUTIM,4, JPI$_PAGEFLTS,4,
	2 JPI$_PPGCNT,4, JPI$_MODE,4, JPI$_OWNER,4, JPI$_UIC,4, 0/
	INTEGER*2 SYI_REQ(6)
	DATA SYI_REQ/3, SYI$_VERSION,8, SYI$_BOOTTIME,8, 0/
	STRUCTURE /SYI_DATA/
	   UNION
	      MAP
	         INTEGER*4 STAT
	         CHARACTER*8 VERSION
	         INTEGER*4 BOOTTIME(2)
	      END MAP
	      MAP
	         CHARACTER*20 STR
	      END MAP
	   END UNION
	END STRUCTURE
	STRUCTURE /TIM_DATA/
	   UNION
	      MAP
	         INTEGER*4 STAT
	         INTEGER*4 CURTIME(2)
	      END MAP
	      MAP
	         CHARACTER*12 STR
	      END MAP
	   END UNION
	END STRUCTURE
	RECORD /TIM_DATA/ TBUF
	INTEGER*4 UPTIME(2)
	RECORD /SYI_DATA/ SBUF
	CHARACTER*132 LINE
	INTEGER*2 L,LL
	INTEGER*2 LVERS
	INTEGER*4 CPUD,CPUH,CPUM,CPUS,CPUC,IOC
	CHARACTER*5 STATES(14)
	DATA STATES/'COLPG','MWAIT','CEF','PFW','LEF','LEFO','HIB','HIBO',
	1 'SUSP','SUSPO','FPG','COM','COMO','CUR'/
	CHARACTER*1 MODES(-1:3)
	DATA MODES/'S',' ','N','B',' '/
	CHARACTER*1 MODESEL(-1:3)
	DATA MODESEL/'S','O','N','B','I'/
	CHARACTER*6 SEL
	INTEGER*2 LSEL
	CHARACTER*23 DATIME
	INTEGER*2 LDT
	LOGICAL*1 DOFULL,FIRST
	CALL PROCESS_COMMAND(SEL,LSEL)
	DOFULL=INDEX(SEL(1:LSEL),'F').NE.0
	DO I=1,N_NODES
	   FIRST=.TRUE.
	   OPEN(UNIT=1,NAME=NODES(I)//'::"0=GETSERVER"',TYPE='NEW',ERR=90)
	   WRITE(1,2,ERR=91)1,0
	   READ(1,4,END=92,ERR=92)TBUF.STR
	   READ(1,4,END=92,ERR=92)
	   WRITE(1,2,ERR=91)SYI_REQ
	   READ(1,4,END=92,ERR=92)SBUF.STR
	   READ(1,4,END=92,ERR=92)
	   DO LVERS=8,1,-1
	      IF(SBUF.VERSION(LVERS:LVERS).GT.' ')GOTO13
	   ENDDO
13	   CALL LIB$SUBX(SBUF.BOOTTIME,TBUF.CURTIME,UPTIME)
	   CALL SYS$FAO('!%D',LDT,DATIME,UPTIME)
	   LDT=INDEX(DATIME(1:LDT),'.')-1
	   CALL SYS$FAO('VAX/VMS !AS  on node !AS !%D   Uptime !AS',
	1   L,LINE,SBUF.VERSION(1:LVERS),NODES(I),TBUF.CURTIME,
	2   DATIME(1:LDT))
	   CALL LIB$PUT_OUTPUT(LINE(1:L))
	   WRITE(1,2,ERR=91)JPI_REQ
2	   FORMAT(40A2)
	   NL=0
3	   NL=NL+1
	   READ(1,4,END=5,ERR=92)BUF(NL).STR
4	   FORMAT(A)
	   IF(BUF(NL).STAT.NE.-1)GOTO3
	   WRITE(1,2,ERR=91)0
5	   NL=NL-1
	   DO J=1,NL
	      IF(BUF(J).OWNER.NE.0)BUF(J).TYPE=-1
	      IF(INDEX(SEL(1:LSEL),MODESEL(BUF(J).TYPE)).EQ.0)GOTO7
	      IOC=BUF(J).DIO+BUF(J).BIO
	      CPUD=BUF(J).CPUTIM/8640000
	      BUF(J).CPUTIM=BUF(J).CPUTIM-(CPUD*8640000)
	      CPUH=BUF(J).CPUTIM/360000         
	      BUF(J).CPUTIM=BUF(J).CPUTIM-(CPUH*360000)
	      CPUM=BUF(J).CPUTIM/6000
	      BUF(J).CPUTIM=BUF(J).CPUTIM-(CPUM*6000)
	      CPUS=BUF(J).CPUTIM/100
	      CPUC=MOD(BUF(J).CPUTIM,100)
	      CALL SYS$FAO('!8XL !15AS !5AS   !2UL !8UL !3UL '//
	1      '!2ZL:!2ZL:!2ZL.!2ZL !9UL !6UL  !AS',L,LINE,
	2      %VAL(BUF(J).PID),BUF(J).PRCNAM(1:BUF(J).L_PRCNAM),
	1      STATES(BUF(J).STS),%VAL(BUF(J).PRI),%VAL(IOC),%VAL(CPUD),
	2      %VAL(CPUH),%VAL(CPUM),%VAL(CPUS),%VAL(CPUC),
	3      %VAL(BUF(J).PGFLTS),%VAL(BUF(J).PHMEM),MODES(BUF(J).TYPE))
	      IF(DOFULL)THEN
	         CALL SYS$FAO('!/         !%I',LL,LINE(L+1:),
	1         %VAL(BUF(J).UIC))
	         L=L+LL
	      ENDIF
	      IF(FIRST)THEN
	         FIRST=.FALSE.
	         CALL LIB$PUT_OUTPUT('  Pid    Process Name    State  Pri  '//
	1         '    I/O       CPU       Page flts Ph.Mem')
	      ENDIF
	      CALL LIB$PUT_OUTPUT(LINE(1:L))
7	      CONTINUE
	   ENDDO
8	   CLOSE(UNIT=1)
9	   CALL LIB$PUT_OUTPUT(' ')
	ENDDO
	CALL SYS$EXIT(%VAL(1))
90	CALL LIB$PUT_OUTPUT('Node '//NODES(I)//' is not accessible.')
	GOTO9
91	CALL LIB$PUT_OUTPUT('Write error on link to node '//NODES(I))
	GOTO8
92	CALL LIB$PUT_OUTPUT('Read error on link to node '//NODES(I))
	GOTO8
	END
C
	SUBROUTINE PROCESS_COMMAND(STR,LSTR)
	INCLUDE '($LNMDEF)'
	INCLUDE '($PSLDEF)'
	INCLUDE 'SYS_CMTLIB:ITEMDEF.INC'
	RECORD /ITEM/ LIST(2)
	INTEGER*4 CLI$GET_VALUE,CLI$PRESENT
	EXTERNAL CLI$_PRESENT
	INTEGER*4 CLI_PRESENT
	CHARACTER*256 OUTFILE
	INTEGER*2 L_OF
	CHARACTER*(*) STR
	INTEGER*2 LSTR
	LSTR=0
C
C	Initialize CLI status values
C
	CLI_PRESENT=%LOC(CLI$_PRESENT)
C
	IF(CLI$PRESENT('SUBPROCESS').EQ.CLI_PRESENT)THEN
	   LSTR=LSTR+1
	   STR(LSTR:LSTR)='S'
	ENDIF
	IF(CLI$PRESENT('BATCH').EQ.CLI_PRESENT)THEN
	   LSTR=LSTR+1
	   STR(LSTR:LSTR)='B'
	ENDIF
	IF(CLI$PRESENT('NETWORK').EQ.CLI_PRESENT)THEN
	   LSTR=LSTR+1
	   STR(LSTR:LSTR)='N'
	ENDIF
	IF(LSTR.EQ.0)THEN
	   LSTR=5
	   STR(1:LSTR)='BISON'
	ENDIF
	IF(CLI$PRESENT('FULL').EQ.CLI_PRESENT)THEN
	   LSTR=LSTR+1
	   STR(LSTR:LSTR)='F'
	ENDIF
	IF(CLI$PRESENT('OUTPUT').EQ.CLI_PRESENT)THEN
	   IF(CLI$GET_VALUE('OUTPUT',OUTFILE,L_OF).EQ.1)THEN
	      LIST(1).ITEMCODE=LNM$_STRING
	      LIST(1).BUFADR=%LOC(OUTFILE)
	      LIST(1).BUFLEN=L_OF
	      LIST(1).RETLENADR=0
	      LIST(2).TERMINATOR=0
	      CALL SYS$CRELNM(,'LNM$PROCESS_TABLE','SYS$OUTPUT',
	1      %REF(PSL$C_USER),LIST)
	   ENDIF
	ENDIF
	RETURN
	END
