100 declare DOUBLE CF(100),ACF,NPV,W_I
120 print "Internal Rate of Return"
122 print
124 input "Estimated Rate of Return      (%)  - ";ER
126 if ER<.01 then ER=10 \ print "Defaulting to 10% Estimated Rate of Return"
128 OER = ER
130 input "Permitted Approximation Error ($)  - ";AE
135 if AE<.01 then AE=.01 \ print "Defaulting to $0.01 Approximation Error"
140 print
150 ON ERROR GOTO 3100
160 input "Initial Investment          - ";P
180 input "Number of Cash Flow Periods - ";F
190 print
200 input "Are Cash Flows for All Periods Equal (Y or N) - ";X$
220 if X$="y" or X$="Y" or X$="" then goto 500
240 for N=1 to F
260	print "Enter Cash Flow for Period (";str$(N);") - ";
280	input CF(N)
300 next N
320 goto 700
500 input "Enter Cash Flow Amount - ";CF
520 for N=1 to F
540	CF(N)=CF
560 next N
700 I=ER \ W_I=ER \ HIGH_HIT=0 \ LOW_HIT=0
710 P=int(P*100+.5)/100 \ OPV=0
750 NPV=0
800 for N=1 to F
810	ACF=CF(N)/((1+I)^N)
820	NPV=NPV+ACF
830 next N
900 NPV=int(NPV*100+.5)/100
905 ! print "P=";P;" NPV=";NPV;" I=";I;" ER=";ER
910 if (NPV > (P-AE)) and (NPV < (P+AE)) then goto 1000
915 if abs(OPV-NPV)<.01 then goto 3000
916 if NPV > (P-AE) then HIGH_HIT=HIGH_HIT+1 else LOW_HIT=LOW_HIT+1
918 OPV=NPV
920 W_I=W_I/2
930 if NPV>P then I=I+W_I
940 if NPV<P then I=I-W_I
950 goto 750
1000 print
1020 print "Internal Rate of Return = ";I;" %"
1040 print
1060 input "Another Calculation (Y or N) - ";X$
1080 if X$="Y" then goto 120
1100 if X$<>"N" then goto 1060
1120 goto 32000
3000 if HIGH_HIT=0 then ER=I \ goto 3070
3010 if LOW_HIT=0 then ER=ER*10 \ goto 3070
3050 if HIGH_HIT>LOW_HIT then ER=(ER/2)+(ER/4) else ER=ER+(ER/4)
3070 LOOP=LOOP+1 \ if LOOP<128 then goto 700
3080 print "Reasonable Results NOT Attainable - Cannot Calculate Result "
3090 goto 140
3100 resume 3110
3110 on error goto 3100
3190 goto 3050
32000 end
