$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
$ !	Name:		color241.com
$ !
$ !	Author:		Fred Bassett
$ !
$ !	Description:	select from programmed colors for VT241 display
$ !			optionally store these color assignments in MCCOLOR.COM
$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
$	ON ERROR THEN EXIT
$	AP = "'"
$ 	ENTREG = "P1p"
$ 	EXREG  = "\"
$ !
$ COLOR_START:
$	WRITE SYS$OUTPUT "COLOR SELECTION PROGRAM FOR VT241'S"
$ 	WRITE SYS$OUTPUT ""
$ TERM_SET:
$ 	WRITE SYS$OUTPUT "Enter Terminal color setup (default=MC) ? "
$ 	WRITE SYS$OUTPUT "(MC)=Mono-Color setup (red/blue default display)"
$ 	WRITE SYS$OUTPUT "(C)=Color setup (green default display)"
$ 	INQUIRE/NOPUNCTUATION TERM "TERMINAL-SETUP> "
$ 	WRITE SYS$OUTPUT ""
$ 	IF "''TERM'" .EQS. "C" THEN GOTO COLOR_PAR
$ 	IF "''TERM'" .EQS. "" .OR. "''TERM'" .EQS. "MC" THEN GOTO MCOLOR_PAR
$ 	WRITE SYS$OUTPUT "Invalid setup, try again..."
$ 	GOTO TERM_SET
$ MCOLOR_PAR:
$ 	WRITE SYS$OUTPUT "Enter Parameter (<CR>=END) ? "
$ 	WRITE SYS$OUTPUT "(B)=backround"
$ 	WRITE SYS$OUTPUT "(T)=text/reverse characters"
$ 	WRITE SYS$OUTPUT "(C)=cursor"
$ 	WRITE SYS$OUTPUT "(H)=bold/blink"
$ 	INQUIRE/NOPUNCTUATION PAR "PARAMETER> "
$ 	IF "''PAR'" .EQS. ""  THEN GOTO SAVE_FILE
$ 	IF "''PAR'" .EQS. "B" THEN PARM = "m0"
$ 	IF "''PAR'" .EQS. "C" THEN PARM = "m1"
$ 	IF "''PAR'" .EQS. "T" THEN PARM = "m2"
$ 	IF "''PAR'" .EQS. "H" THEN PARM = "m3"
$ 	IF "''PAR'" .EQS. "B" .OR. -
	   "''PAR'" .EQS. "T" .OR. -
	   "''PAR'" .EQS. "C" .OR. -
	   "''PAR'" .EQS. "H" THEN GOTO MCOLOR_SEL
$ 	WRITE SYS$OUTPUT "Invalid parameter, try again..."
$ 	GOTO MCOLOR_PAR
$ MCOLOR_SEL:
$ 	WRITE SYS$OUTPUT ""
$ 	WRITE SYS$OUTPUT "Enter Color ? "
$ 	WRITE SYS$OUTPUT "(RED)=red"
$ 	WRITE SYS$OUTPUT "(BLA)=black"
$ 	WRITE SYS$OUTPUT "(BLU)=blue"
$ 	WRITE SYS$OUTPUT "(GOL)=gold/amber"
$ 	WRITE SYS$OUTPUT "(GRE)=green"
$ 	WRITE SYS$OUTPUT "(WHI)=white"
$ 	WRITE SYS$OUTPUT "(LBL)=light blue"
$ 	WRITE SYS$OUTPUT "(DGR)=dark green"
$ 	WRITE SYS$OUTPUT "(CYN)=cyan"
$ 	WRITE SYS$OUTPUT "(MAG)=magenta"
$ 	WRITE SYS$OUTPUT "(YEL)=yellow"
$ 	WRITE SYS$OUTPUT "(BRO)=brown"
$ 	WRITE SYS$OUTPUT "(GRA)=gray"
$ 	INQUIRE/NOPUNCTUATION COL "COLOR> "
$ 	IF "''COL'" .EQS. "RED" THEN COLOR = "(ah120l45s67)"
$ 	IF "''COL'" .EQS. "BLA" THEN COLOR = "(ah0l0s1)"
$ 	IF "''COL'" .EQS. "BLU" THEN COLOR = "(ah300l30s67)"
$ 	IF "''COL'" .EQS. "GOL" THEN COLOR = "(ah140l45s34)"
$ 	IF "''COL'" .EQS. "GRE" THEN COLOR = "(ah240l30s67)"
$ 	IF "''COL'" .EQS. "WHI" THEN COLOR = "(ah0l90s1)"
$ 	IF "''COL'" .EQS. "LBL" THEN COLOR = "(ah300l45s67)"
$ 	IF "''COL'" .EQS. "DGR" THEN COLOR = "(ah240l15s67)"
$ 	IF "''COL'" .EQS. "CYN" THEN COLOR = "(ah300l60s67)"
$ 	IF "''COL'" .EQS. "MAG" THEN COLOR = "(ah60l45s67)"
$ 	IF "''COL'" .EQS. "YEL" THEN COLOR = "(ah180l60s67)"
$ 	IF "''COL'" .EQS. "BRO" THEN COLOR = "(ah170l30s67)"
$ 	IF "''COL'" .EQS. "GRA" THEN COLOR = "(ah0l30s0)"
$ 	IF "''COL'" .EQS. "RED" .OR. -
	   "''COL'" .EQS. "BLA" .OR. -
	   "''COL'" .EQS. "BLU" .OR. -
	   "''COL'" .EQS. "GOL" .OR. -
	   "''COL'" .EQS. "GRE" .OR. -
	   "''COL'" .EQS. "WHI" THEN GOTO DO_MCOLOR
$	IF "''COL'" .EQS. "LBL" .OR. -
	   "''COL'" .EQS. "DGR" .OR. -
	   "''COL'" .EQS. "CYN" .OR. -
	   "''COL'" .EQS. "MAG" .OR. -
	   "''COL'" .EQS. "YEL" .OR. -
	   "''COL'" .EQS. "BRO" .OR. -
	   "''COL'" .EQS. "GRA" THEN GOTO DO_MCOLOR
$ 	WRITE SYS$OUTPUT "Invalid color, try again..."
$ 	GOTO MCOLOR_SEL
$ DO_MCOLOR:
$	COLORSELT = "s(''PARM'''COLOR')"
$ 	IF "''PAR'" .EQS. "B" THEN COLOR_B = "''COLORSELT'"
$ 	IF "''PAR'" .EQS. "C" THEN COLOR_C = "''COLORSELT'"
$ 	IF "''PAR'" .EQS. "T" THEN COLOR_T = "''COLORSELT'"
$ 	IF "''PAR'" .EQS. "H" THEN COLOR_H = "''COLORSELT'"
$ 	WRITE SYS$OUTPUT "''ENTREG'"
$ 	WRITE SYS$OUTPUT "''COLORSELT'"
$ 	WRITE SYS$OUTPUT "S(T60)"
$ 	WRITE SYS$OUTPUT "''EXREG'"
$	GOTO MCOLOR_PAR
$ COLOR_PAR:
$ 	WRITE SYS$OUTPUT "Enter Parameter (CR=END) ? "
$ 	WRITE SYS$OUTPUT "(B)=backround"
$ 	WRITE SYS$OUTPUT "(T)=text/cursor characters"
$ 	WRITE SYS$OUTPUT "(H)=bold/blink"
$ 	INQUIRE/NOPUNCTUATION PAR "PARAMETER> "
$ 	IF "''PAR'" .EQS. ""  THEN GOTO SAVE_FILE
$ 	IF "''PAR'" .EQS. "B" THEN PARM = "m0"
$ 	IF "''PAR'" .EQS. "H" THEN PARM = "m2"
$ 	IF "''PAR'" .EQS. "T" THEN PARM = "m3"
$ 	IF "''PAR'" .EQS. "B" .OR. -
	   "''PAR'" .EQS. "T" .OR. -
	   "''PAR'" .EQS. "H" THEN GOTO COLOR_SEL
$ 	WRITE SYS$OUTPUT "Invalid parameter, try again..."
$ 	GOTO COLOR_PAR
$ COLOR_SEL:
$ 	WRITE SYS$OUTPUT ""
$ 	WRITE SYS$OUTPUT "Enter Color ? "
$ 	WRITE SYS$OUTPUT "(RED)=red"
$ 	WRITE SYS$OUTPUT "(BLA)=black"
$ 	WRITE SYS$OUTPUT "(BLU)=blue"
$ 	WRITE SYS$OUTPUT "(GOL)=gold/amber"
$ 	WRITE SYS$OUTPUT "(GRE)=green"
$ 	WRITE SYS$OUTPUT "(WHI)=white"
$ 	WRITE SYS$OUTPUT "(LBL)=light blue"
$ 	WRITE SYS$OUTPUT "(DGR)=dark green"
$ 	WRITE SYS$OUTPUT "(CYN)=cyan"
$ 	WRITE SYS$OUTPUT "(MAG)=magenta"
$ 	WRITE SYS$OUTPUT "(YEL)=yellow"
$ 	WRITE SYS$OUTPUT "(BRO)=brown"
$ 	INQUIRE/NOPUNCTUATION COL "COLOR> "
$ 	IF "''COL'" .EQS. "RED" THEN COLOR = "(ah120l45s67)"
$ 	IF "''COL'" .EQS. "BLA" THEN COLOR = "(ah0l0s1)"
$ 	IF "''COL'" .EQS. "BLU" THEN COLOR = "(ah300l30s67)"
$ 	IF "''COL'" .EQS. "GOL" THEN COLOR = "(ah140l45s34)"
$ 	IF "''COL'" .EQS. "GRE" THEN COLOR = "(ah240l30s67)"
$ 	IF "''COL'" .EQS. "WHI" THEN COLOR = "(ah0l90s1)"
$ 	IF "''COL'" .EQS. "LBL" THEN COLOR = "(ah300l45s67)"
$ 	IF "''COL'" .EQS. "DGR" THEN COLOR = "(ah240l15s67)"
$ 	IF "''COL'" .EQS. "CYN" THEN COLOR = "(ah300l60s67)"
$ 	IF "''COL'" .EQS. "MAG" THEN COLOR = "(ah60l45s67)"
$ 	IF "''COL'" .EQS. "YEL" THEN COLOR = "(ah180l60s67)"
$ 	IF "''COL'" .EQS. "BRO" THEN COLOR = "(ah170l30s67)"
$ 	IF "''COL'" .EQS. "RED" .OR. -
	   "''COL'" .EQS. "BLA" .OR. -
	   "''COL'" .EQS. "BLU" .OR. -
	   "''COL'" .EQS. "GOL" .OR. -
	   "''COL'" .EQS. "GRE" .OR. -
	   "''COL'" .EQS. "WHI" .OR. -
	   "''COL'" .EQS. "LBL" .OR. -
	   "''COL'" .EQS. "DGR" .OR. -
	   "''COL'" .EQS. "CYN" .OR. -
	   "''COL'" .EQS. "MAG" .OR. -
	   "''COL'" .EQS. "YEL" .OR. -
	   "''COL'" .EQS. "BRO" THEN GOTO DO_COLOR
$ 	WRITE SYS$OUTPUT "Invalid color, try again..."
$ 	GOTO COLOR_SEL
$ DO_COLOR:
$	COLORSELT = "s(''PARM'''COLOR')"
$ 	IF "''PAR'" .EQS. "B" THEN COLOR_B = "''COLORSELT'"
$ 	IF "''PAR'" .EQS. "H" THEN COLOR_C = "''COLORSELT'"
$ 	IF "''PAR'" .EQS. "T" THEN COLOR_T = "''COLORSELT'"
$ 	IF "''PAR'" .EQS. "H" THEN COLOR_H = "''COLORSELT'"
$ 	WRITE SYS$OUTPUT "''ENTREG'"
$ 	WRITE SYS$OUTPUT "''COLORSELT'"
$ 	WRITE SYS$OUTPUT "S(T60)"
$ 	WRITE SYS$OUTPUT "''EXREG'"
$	GOTO COLOR_PAR
$ SAVE_FILE:
$ 	WRITE SYS$OUTPUT ""
$ 	WRITE SYS$OUTPUT "Do you want to save these color selections "
$	WRITE SYS$OUTPUT "for use at login (Y/N,default=Y) ? "
$ 	INQUIRE/NOPUNCTUATION SAVE "SAVE> "
$	IF "''SAVE'" .EQS. "N" THEN GOTO EXIT
$ 	IF "''SAVE'" .EQS. "" .OR. "''SAVE'" .EQS. "Y" THEN GOTO WRITE_FILE
$ 	WRITE SYS$OUTPUT "Invalid save entry, try again..."
$ 	GOTO SAVE_FILE
$ WRITE_FILE:
$	OPEN/WRITE COM SYS$LOGIN:MCCOLOR.COM
$	WRITE COM "$ ENTREG = "" P1p""
$	WRITE COM "$ ENTREG[0,8] = %X1B"
$	WRITE COM "$ EXTREG = "" \""
$	WRITE COM "$ EXTREG[0,8] = %X1B"
$	WRITE COM "$ WRITE SYS$OUTPUT ''AP' ''AP'ENTREG''AP'"
$ 	WRITE COM "$ WRITE SYS$OUTPUT ""''COLOR_B'""
$ 	WRITE COM "$ WRITE SYS$OUTPUT ""''COLOR_C'""
$ 	WRITE COM "$ WRITE SYS$OUTPUT ""''COLOR_T'""
$ 	WRITE COM "$ WRITE SYS$OUTPUT ""''COLOR_H'""
$ 	WRITE COM "$ WRITE SYS$OUTPUT ""S(T60)""
$ 	WRITE COM "$ WRITE SYS$OUTPUT ''AP' ''AP'EXTREG''AP'"
$	CLOSE COM
$	PURGE SYS$LOGIN:MCCOLOR.COM
$ EXIT:
$	EXIT
$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
