$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$!	print by number procedure
$!
$!	Logical name "node_printers" must be defined to point to a
$!	text file containing a list of valid printers with their
$!	device names
$!
$!	Logical name "node_forms" must be defined to point to a
$!	text file containing a list of valid form types 
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$	gosub init
$	gosub select_directory
$	gosub controller
$	goto exit
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ init:
$	set control_y
$ 	on control_y then goto exit
$ 	on error then goto exit
$ 	esc[0,8]==%x1b
$ 	top_dbl_width		:= 	"''esc'#6"
$ 	scroll_loc		:= 	"''esc'[1;12r''esc'[1;1H"
$ 	scroll_frm		:= 	"''esc'[1;13r''esc'[1;1H"
$ 	scroll_def 		:= 	"''esc'[1;19r''esc'[1;1H"
$ 	scroll_inq 		:= 	"''esc'[21;23r''esc'[21;1H"
$ 	scroll_ctl 		:= 	"''esc'[11;9r''esc'[12;1H"
$ 	scroll_sel 		:= 	"''esc'[13;7r''esc'[13;1H"
$ 	scroll_cho 		:= 	"''esc'[14;6r''esc'[14;1H"
$ 	scroll_dir 		:= 	"''esc'[1;10r''esc'[1;1H"
$ 	clear_screen 		:=	"''esc'[2J"
$ 	clear_inq 		:= 	"''esc'[21;1H''esc'[0J''esc[21;1H"
$ 	cursor_home 		:= 	"''esc'[1;1H"
$ 	cursor_loc	 	:= 	"''esc'[1;1H"
$ 	cursor_frm_start 	:= 	"''esc'[3;1H"
$ 	cursor_frm	 	:= 	"''esc'[1;1H"
$ 	cursor_loc_start 	:= 	"''esc'[3;1H"
$ 	cursor_inq	 	:= 	"''esc'[21;1H"
$ 	cursor_ctl	 	:= 	"''esc'[11;1H"
$ 	cursor_sel	 	:= 	"''esc'[13;1H"
$ 	cursor_cho	 	:= 	"''esc'[14;1H"
$ 	cursor_dir	 	:= 	"''esc'[1;1H"
$ 	cursor_dir_start 	:= 	"''esc'[3;1H"
$ 	cursor_def	 	:= 	"''esc'[1;1H"
$ 	back_to_normal 		:= 	"''esc'[2J''esc'[0m''esc'[1;24r''esc'[1;1H"
$	reverse_video		:=	"''esc'[7m"
$	bold_video		:=	"''esc'[1m"
$	blink_video		:= 	"''esc'[5m"
$	underline_video		:= 	"''esc'[4m"
$	end_video		:=	"''esc'[0m"
$	select_dir 		= 	""
$	select_file 		= 	""
$	select_type 		= 	""
$	prev_loc 		= 	""
$	prev_opt 		= 	""
$	default_type		=	".lis"
$ 	space 			= 	"                                                  "
$	stream 			= 	1
$	open_file 		= 	0
$ 	wo 			:= 	write sys$output
$	this_node 		= 	"''f$trnlnm("sys$node")'"
$	wo clear_screen
$	wo cursor_home
$	wo "''top_dbl_width'         ''reverse_video'  Print By Number  ''end_video'"
$	wo ""
$	wo ""
$	wo ""
$	wait 00:00:03
$	return
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ select_directory:                              
$	if "''p1'" .nes. "" then select_dir = "''p1'"
$	if "''select_dir'" .nes. "" then goto select_check
$ select_loop:
$	wo "Enter the directory specification to be searched for files"
$	inquire/nopunc select_dir "(default=sys$login): "
$	if "''f$edit(f$extract(0,1,select_dir),"upcase")'" .eqs. "E" then goto exit
$ select_check:
$	if "''select_dir'" .eqs. "" then select_dir = "''f$trnlnm("sys$login")'"
$	if "''f$trnlnm(select_dir)'" .nes. "" then select_dir = "''f$trnlnm(select_dir)'"
$	select_dir = "''f$parse(select_dir,,,,"SYNTAX_ONLY")'"
$	select_length = 'f$locate(".;",select_dir)'
$	select_dir = "''f$extract(0,select_length,select_dir)'"
$	if "''f$parse(select_dir)'" .eqs. "" then goto select_error
$	goto select_end
$ select_error:
$	wo "''blink_video'''bold_video'Selected directory does not exist, try again...''end_video'"
$	goto select_loop
$ select_end:
$	return
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ controller:
$ 	on control_y then goto exit
$	wo back_to_normal
$	wo clear_screen
$	wo cursor_home
$	wo scroll_dir
$	wo scroll_ctl
$ 	wo scroll_inq
$	wo cursor_dir
$	opt_displayed = ""
$	wo "''reverse_video'                         Report files                                           ''end_video'"
$	wo " ''underline_video'File number''end_video'            ''underline_video'Print file name''end_video'                           ''underline_video'Creation date''end_video'"
$ dir_create:
$	if "''select_file'" .eqs. "" then goto dir_end
$ 	file_tab = "|"
$	file_count = 0
$ dir_read:
$	search_for = "''select_dir'''select_file'''select_type';*"
$	dir_record = "''f$search(search_for,stream)'"
$	if "''dir_record'" .eqs. "" then goto dir_finish 
$	save_file = "''dir_record'"
$	file_count = file_count + 1
$ dir_strip:        
$	dir_start = 'f$locate("]",dir_record)'
$	dir_length = 'f$length(dir_record)'
$	if 'dir_start' .eq. 'dir_length' then goto dir_done_strip
$	dir_length = dir_length - dir_start
$	dir_start = dir_start + 1
$	file_desc = "''f$extract(dir_start,dir_length,dir_record)'"
$	dir_record = "''file_desc'"
$	goto dir_strip
$ dir_done_strip:
$	file_name = "''f$edit(file_desc,"TRIM")'"
$	file_tab = "''file_tab'''file_name'|"
$	file_length = 'f$length(file_name)'
$	dir_record = "''f$file_attributes(save_file,"CDT")'"
$	file_date = "''f$edit(dir_record,"TRIM")'"
$	date_end = 'f$locate(" ",file_date)'
$	file_date = "''f$extract(0,date_end,file_date)'"
$	date_length = 'f$length(file_date)'
$	space_length = ((63 - file_length) - date_length)
$	file_space = "''f$extract(0,space_length,space)'"
$	wo "      ''file_count'          ''file_name'''file_space'''file_date'"
$	if 'file_count' .lt. 8 then goto dir_read
$	goto dir_end
$ dir_finish:
$	if 'file_count' .eq. 0 then file_count = 1
$	temp_count = 'file_count'
$ dir_clear_loop:
$	temp_count = temp_count + 1
$	wo "                                                                                "
$	if 'temp_count' .lt. 8 then goto dir_clear_loop
$ dir_end:
$	if "''select_file'" .eqs. "" then goto ctl_select
$	if "''opt_displayed'" .eqs. "Y" then goto ctl_opt
$	wo cursor_ctl
$	wo "''reverse_video'                    Print selection options                                     ''end_video'"
$	wo "     ''underline_video'Function''end_video'          ''underline_video'Description''end_video'"
$	wo "         B             Show report display from begining"
$	wo "         S             Scroll report display"
$	wo "         P             Print report"
$	wo "         M             Manually enter file specification to print"
$	wo "         T             Type report to terminal"
$	wo "         D             Select report display parameter"
$	wo "         E             Exit (abort print procedure)"
$	opt_displayed = "Y"
$ ctl_opt:
$	wo cursor_inq
$ ctl_loop:
$	inquire/nopunc what "Enter selection function letter: "
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "B" then goto ctl_start
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "S" then goto ctl_scroll
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "P" then goto ctl_print
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "M" then goto ctl_manual
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "T" then goto ctl_type
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "D" then goto ctl_select
$	if "''f$edit(f$extract(0,1,what),"upcase")'" .eqs. "E" then goto exit
$	if "''f$type(what)'" .eqs. "INTEGER" then goto skip_ctl_print
$ ctl_error:
$	wo "''blink_video'Selection function code letter in error, please choose from list...''end_video'"
$ 	goto ctl_loop
$ ctl_start:
$	stream = stream + 1
$	wo clear_inq
$ 	file_tab = "|"
$	file_count = 0
$	wo cursor_dir_start
$	goto dir_read
$ ctl_scroll:
$ 	file_tab = "|"
$	file_count = 0    
$	wo clear_inq
$	wo cursor_dir_start        
$	goto dir_read
$ ctl_print:
$	wo clear_inq                                                 
$	wo cursor_inq
$	what = 0
$ skip_ctl_print:
$	stream = stream + 1
$	gosub which_file
$	gosub parameters
$	print/queue='out_device''prt_opts' 'select_dir''out_file'
$	inquire/nopunc cont "Press <Return>/<Enter> to continue..."
$	goto controller
$ ctl_manual:
$	wo clear_inq
$	wo cursor_inq
$	stream = stream + 1
$	gosub manual_file
$	gosub parameters
$	print/queue='out_device''prt_opts' 'select_dir''out_file'
$	inquire/nopunc cont "Press <Return>/<Enter> to continue..."
$	goto controller
$ ctl_type:
$ 	on control_y then goto end_type
$	wo clear_inq
$	wo cursor_inq
$	stream = stream + 1
$	what = 0
$	gosub which_file
$	wo back_to_normal
$	set terminal/width=132
$	type 'select_dir''out_file'
$	inquire/nopunc cont "Press <Return>/<Enter> to continue..."
$ end_type:
$	set terminal/width=80
$	goto controller
$ ctl_select:
$	wo clear_inq
$	wo cursor_inq
$ ctl_select_loop:
$	select_type = "''default_type'"
$	inquire/nopunc select_file "Enter search file selection string: "
$	if "''select_file'" .eqs. "" then select_file = "*.*"
$	sel_file_length = 'f$locate(".",select_file)'
$	sel_length = 'f$length(select_file)'
$	if 'sel_file_length' .eq. 'sel_length' then goto ctl_select_end
$	sel_type_length = 'sel_length' - 'sel_file_length'
$	entered_file = "''select_file'"
$	select_type = "''f$extract(sel_file_length,sel_type_length,entered_file)'"
$	sel_file_length = sel_file_length
$	select_file = "''f$extract(0,sel_file_length,entered_file)'"
$ ctl_select_end:
$	stream = stream + 1
$	open_file = 0
$	wo clear_inq
$	wo cursor_dir_start
$	wo "                                                                                "
$	wo cursor_dir_start
$	goto dir_create
$!
$ which_file:
$	if what .eq. 0 then inquire/nopunc what "Enter print file number: "
$	if "''f$type(what)'" .nes. "INTEGER" then goto which_error
$	if 'what' .gt. 'file_count' .or. 'what' .lt. 1 then goto which_error
$	goto got_which
$ which_error:
$	wo "''blink_video'Print file number in error, please choose from list...''end_video'"
$	what = 0
$	goto which_file
$ got_which:
$	out_file = "''f$element(what,"|",file_tab)'"
$	return
$!
$ manual_file:
$	inquire/nopunc out_file "Enter file specification to print, format file.ext: "
$	test_name = "''select_dir'''out_file'"
$	if "''f$search(test_name)'" .eqs. "" then goto manual_error
$	goto got_manual
$ manual_error:
$	if "''f$edit(f$extract(0,1,out_file),"upcase")'" .eqs. "E" then goto exit
$	wo "''blink_video'Manually entered file does not exist, please select_again...''end_video'"
$	goto manual_file
$ got_manual:
$	return
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ parameters:
$	wo back_to_normal
$	wo clear_screen
$	wo cursor_home
$ load_loc:
$	wo scroll_loc
$	wo scroll_sel
$ 	wo scroll_inq
$	wo cursor_loc
$	sel_displayed = ""
$	number_space = 32 - 'f$length(this_node)'
$	detail_space = "''f$extract(0,number_space,space)'"
$	wo "''reverse_video'                    Available printers for Node ''this_node'''detail_space'''end_video'"
$	wo "     ''underline_video'Loc_Code''end_video'          ''underline_video'Location''end_video'"
$ loc_start:
$	open loc_file node_printers
$	open_file = 2
$ 	dev_tab = "|"
$	loc_count = 0
$ loc_read:
$	read/end=loc_finish loc_file loc_record
$	loc_count = loc_count + 1
$	loc_desc = "''f$element(0,"|",loc_record)'"
$	loc_device = "''f$element(1,"|",loc_record)'"
$	dev_tab = "''dev_tab'''loc_device'|"
$	number_space = 9 - 'f$length(loc_count)'
$	loc_space = "''f$extract(0,number_space,space)'"
$	wo "''loc_space'''loc_count'             ''loc_desc'"
$	if 'loc_count' .lt. 10 then goto loc_read
$	goto loc_end
$ loc_finish:
$	temp_count = 'loc_count'
$ loc_clear_loop:
$	temp_count = temp_count + 1
$	wo "                                                                                "
$	if 'temp_count' .lt. 10 then goto loc_clear_loop
$ loc_end:
$	if "''sel_displayed'" .eqs. "Y" then goto sel_opt
$	wo cursor_sel
$	wo "''reverse_video'                    Location selection options                                  ''end_video'"
$	wo "       ''underline_video'Function''end_video'          ''underline_video'Description''end_video'"
$	wo "           B             Show location display from begining"
$	wo "           S             Scroll location display"
$	wo "           L             Select a location code"
$	wo "           P             Use previous Location selection"
$	wo "           E             Exit (abort print procedure)"
$	sel_displayed = "Y"
$ sel_opt:
$	wo cursor_inq
$ loc_loop:
$    	inquire/nopunc where "Enter location function letter: "
$	if "''f$edit(f$extract(0,1,where),"upcase")'" .eqs. "B" then goto sel_start
$	if "''f$edit(f$extract(0,1,where),"upcase")'" .eqs. "S" then goto sel_scroll
$	if "''f$edit(f$extract(0,1,where),"upcase")'" .eqs. "L" then goto sel_a_loc
$	if "''f$edit(f$extract(0,1,where),"upcase")'" .eqs. "P" then goto sel_prev_loc
$	if "''f$edit(f$extract(0,1,where),"upcase")'" .eqs. "E" then goto exit
$	if "''f$type(where)'" .eqs. "INTEGER" then goto sel_loc_loop
$ loc_error:
$	wo "''blink_video'Location function letter in error, please choose from list...''end_video'"
$	goto loc_loop
$ sel_prev_loc:
$	if "''prev_loc'" .eqs. "" then goto prev_loc_error
$	out_device = "''prev_loc'"
$	goto use_prev_loc
$ prev_loc_error:
$	wo "''blink_video'No previous Location selected, please select a location...''end_video'"
$	goto loc_loop
$ sel_start:
$ 	close loc_file
$	wo clear_inq
$	open loc_file node_printers
$	open_file = 2
$ 	dev_tab = "|"
$	loc_count = 0
$	wo cursor_loc_start
$	goto loc_read    
$ sel_scroll:
$ 	dev_tab = "|"
$	loc_count = 0
$	wo clear_inq
$	wo cursor_loc_start
$	goto loc_read
$ sel_a_loc:
$ 	wo clear_inq
$	wo cursor_inq
$	where = 0
$ sel_loc_loop:
$    	if where .eq. 0 then inquire/nopunc where "Enter printer location code: "
$	if "''f$type(where)'" .nes. "INTEGER" then goto sel_loc_error
$	if 'where' .gt. 'loc_count' .or. 'where' .lt. 1 then goto sel_loc_error
$	goto got_loc
$ sel_loc_error:                                          
$	if "''f$edit(f$extract(0,1,where),"upcase")'" .eqs. "E" then goto exit
$	wo "''blink_video'Print location code in error, please choose from list...''end_video'"
$	where = 0
$	goto sel_loc_loop
$ got_loc:
$	out_device = "''f$element(where,"|",dev_tab)'"
$	prev_loc = "''out_device'"
$ use_prev_loc:
$ 	if "''open_file'" .eqs. "2" then close loc_file
$	open_file = 0
$	loc_displayed = ""
$	wo back_to_normal
$	wo clear_screen
$	wo cursor_home
$ 	wo scroll_def
$ 	wo scroll_inq
$	wo cursor_def
$	wo "''reverse_video'                         Available report print options                         ''end_video'"
$	wo "          ''underline_video'Code''end_video'               ''underline_video'Option''end_video'              ''underline_video'Defaults''end_video'"
$	wo "           F                 /nofeed             /feed"
$	wo "           M                 /form=?             /form=default"
$	wo "           S                 /setup=?            default ''bold_video'(for Laser only)''end_video'"
$	wo "           G                 /noflag             /flag"
$	wo "           C                 /copies=?           /copies=1"
$	wo "           N                 /notify             /nonotify"
$	wo "           D                 /delete             /nodelete"
$	wo "           P                 use previous selected options"
$	wo "           E                 Exit (abort print procedure)"
$	wo cursor_inq
$	loc_displayed = "Y"
$ def_loop:
$	inquire/nopunc how "Enter print options code(s): "
$	def_f = ""
$	def_s = ""
$	def_m = ""
$	def_g = ""
$	def_c = ""
$	def_n = ""
$	def_d = ""                       
$	if "''how'" .eqs. "" then goto def_end
$	def_count = 0                             
$ extract_loop:
$	prt_opt = "''f$extract(def_count,1,how)'"
$	if "''prt_opt'" .eqs. "" then goto def_end
$	def_count = def_count + 1
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "F" then goto do_f
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "G" then goto do_g
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "C" then goto do_c
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "N" then goto do_n
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "M" then goto do_m
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "S" then goto do_s
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "D" then goto do_d
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "P" then goto do_p
$	if "''f$edit(prt_opt,"upcase")'" .eqs. "E" then goto exit
$	if "''loc_displayed'" .eqs. "Y" then goto skip_display
$	wo back_to_normal
$	wo clear_screen
$	wo cursor_home
$ 	wo scroll_def
$ 	wo scroll_inq
$	wo cursor_def
$	wo "''reverse_video'                         Available report print options                         ''end_video'"
$	wo "          ''underline_video'Code''end_video'               ''underline_video'Option''end_video'              ''underline_video'Defaults''end_video'"
$	wo "           F                 /nofeed             /feed"
$	wo "           M                 /form=?             /form=default"
$	wo "           S                 /setup=?            default ''bold_video'(for Laser only)''end_video'"
$	wo "           G                 /noflag             /flag"
$	wo "           C                 /copies=?           /copies=1"
$	wo "           N                 /notify             /nonotify"
$	wo "           D                 /delete             /nodelete"
$	wo "           E                 Exit (abort print procedure)"
$	wo cursor_inq
$	loc_displayed = "Y"
$ skip_display:
$	wo "''blink_video'Print option code(s) number in error, please choose from list...''end_video'"
$	goto def_loop
$ do_p:
$	if "''prev_opt'" .eqs. "" then goto prev_opt_error
$ 	prt_opts = "''prev_opt'"
$	goto use_prev_opt
$ prev_opt_error:
$	wo "''blink_video'No previous print options selected, please select options...''end_video'"
$	goto def_loop
$ do_f:
$	def_f = "/nofeed"
$	goto extract_loop
$ do_d:
$	def_d = "/delete"
$	goto extract_loop
$ do_g:
$	def_g = "/noflag"
$	goto extract_loop
$ do_c:                                                  
$	wo clear_inq
$	wo cursor_inq
$ copy_loop:
$	inquire/nopunc many "Enter number of copies: "
$	if "''f$type(many)'" .nes. "INTEGER" then goto copy_error
$	def_c = "/copies=''many'"
$	wo clear_inq
$	wo cursor_inq
$	goto extract_loop
$ copy_error:
$	wo "''blink_video'Number of copies option in error, please enter a number...''end_video'"
$	goto copy_loop
$ do_s:
$	wo clear_inq
$	wo cursor_inq
$ setup_loop:
$	inquire/nopunc set_up "Enter setup specification for laser printer: "
$	def_s = "/setup=''set_up'"
$	wo clear_inq
$	wo cursor_inq
$	goto extract_loop
$ do_m:
$	wo back_to_normal
$	wo clear_screen
$	wo cursor_home
$	wo scroll_frm
$	wo scroll_cho
$ 	wo scroll_inq
$	wo cursor_frm
$	loc_displayed = ""
$	cho_displayed = ""
$	number_space = 25 - 'f$length(this_node)'
$	detail_space = "''f$extract(0,number_space,space)'"
$	wo "''reverse_video'             Available form types for printers on Node ''this_node'''detail_space'''end_video'"
$	wo "     ''underline_video'Form_code''end_video'     ''underline_video'Form_type''end_video'          ''underline_video'Description''end_video'"
$ frm_start:
$	open frm_file node_forms
$	open_file = 1
$ 	frm_tab = "|"
$	frm_count = 0
$ frm_read:
$	read/end=frm_finish frm_file frm_record
$	frm_count = frm_count + 1
$	frm_num = "''f$element(0,"|",frm_record)'"
$	frm_desc = "''f$element(1,"|",frm_record)'"
$	frm_tab = "''frm_tab'''frm_num'|"
$	number_space = 10 - 'f$length(frm_count)'
$	frm_space = "''f$extract(0,number_space,space)'"
$	wo "''frm_space'''frm_count'           ''frm_num'              ''frm_desc'"
$	if 'frm_count' .lt. 11 then goto frm_read
$	goto frm_end
$ frm_finish:
$	temp_count = 'frm_count'   
$ frm_clear_loop:
$	temp_count = temp_count + 1
$	wo "                                                                                "
$	if 'temp_count' .lt. 11 then goto frm_clear_loop
$ frm_end:                      
$	if "''cho_displayed'" .eqs. "Y" then goto cho_opt
$	wo cursor_cho
$	wo "''reverse_video'                    Form type selection options                                 ''end_video'"
$	wo "       ''underline_video'Function''end_video'          ''underline_video'Description''end_video'"
$	wo "           B             Show Form types display from begining"
$	wo "           S             Scroll Form types display"
$	wo "           F             Select a Form type code"
$	wo "           E             Exit (abort print procedure)"
$	cho_displayed = "Y"                      
$ cho_opt:
$	wo cursor_inq
$ frm_loop:
$    	inquire/nopunc form "Enter form function letter: "
$	if "''f$edit(f$extract(0,1,form),"upcase")'" .eqs. "B" then goto cho_start
$	if "''f$edit(f$extract(0,1,form),"upcase")'" .eqs. "S" then goto cho_scroll
$	if "''f$edit(f$extract(0,1,form),"upcase")'" .eqs. "F" then goto cho_a_frm
$	if "''f$edit(f$extract(0,1,form),"upcase")'" .eqs. "E" then goto exit
$	if "''f$type(form)'" .eqs. "INTEGER" then goto cho_frm_loop
$ frm_error:
$	wo "''blink_video'Form function in error, please choose from list...''end_video'"
$	goto frm_loop
$ cho_start:    
$ 	close frm_file
$	wo clear_inq
$	open frm_file node_forms
$	open_file = 1
$ 	frm_tab = "|"
$	frm_count = 0
$	wo cursor_frm_start
$	goto frm_read
$ cho_scroll:
$ 	frm_tab = "|"
$	frm_count = 0
$	wo clear_inq
$	wo cursor_frm_start
$	goto frm_read                                              
$ cho_a_frm:
$ 	wo clear_inq
$	wo cursor_inq
$	form = 0
$ cho_frm_loop:
$	if form .eq. 0 then inquire/nopunc form "Enter form code: "
$	if "''f$type(form)'" .nes. "INTEGER" then goto cho_frm_error
$	if 'form' .gt. 'frm_count' .or. 'form' .lt. 1 then goto cho_frm_error
$	goto got_frm
$ cho_frm_error:
$	if "''f$edit(f$extract(0,1,form),"upcase")'" .eqs. "E" then goto exit
$	wo "''blink_video'Form code in error, please enter a number...''end_video'"
$	form = 0
$	goto cho_frm_loop
$ got_frm:
$ 	if "''open_file'" .eqs. "1" then close frm_file
$	open_file = 0
$	f_num = "''f$element(form,"|",frm_tab)'"
$	def_m = "/form=''f_num'"
$	goto extract_loop
$ do_n:
$	def_n = "/nonotify"
$	goto extract_loop
$ def_end:
$	prt_opts = "''def_f'''def_g'''def_c'''def_n'''def_m'''def_s'''def_d'"
$ use_prev_opt:
$	wo back_to_normal
$	wo clear_screen
$	wo cursor_home
$	wo "''top_dbl_width'         ''reverse_video'  Print By Number  ''end_video'"
$	wo ""
$	wo ""
$	wo ""
$	prev_opt = "''prt_opts'"
$	return
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$ exit:
$	wo back_to_normal
$ 	if "''open_file'" .eqs. "2" then close loc_file
$ 	if "''open_file'" .eqs. "1" then close frm_file
$	if f$search("dir.tmp") .nes. "" then $delete dir.tmp;*
$	exit $status
