C+
C   Get_Process_NAME	Subroutine to return the Process name of the 
C			current process.
C
C	CALL Get_Process_NAME(Cprocess_Name,Ilength)
C	Where:
C		Cuser_Name  Character*15   User name string
C		Ilength	    I*4		   Length of name string
C
C	Written by:	James G. Downward
C			KMS Fusion, Inc.
C			P.O. Box 1567
C			Ann Arbor, Mich 48104
C			(313)-769-8500
C
C			
C-
C
	SUBROUTINE Get_Process_NAME(Cprocess_Name,Ilength)
	CHARACTER*15 Cprocess_name			!
	INTEGER*2 JPI_Code,JPI_Length,JPI_Header(2)	! For GETJPI setup
	INTEGER*4 LIST(3)				!
	INTEGER*4 Istatus,Ilength			!
	EXTERNAL JPI$_PRCNAM

	EQUIVALENCE (JPI_Header(1),JPI_Length)
	EQUIVALENCE (JPI_Header(2),JPI_Code)
	EQUIVALENCE (JPI_Header(1),LIST(1))


C
C -- Find out the User_Name of the current process
C
	JPI_Code=%LOC(JPI$_PRCNAM)			! Get Process name
	JPI_Length = 12					! 4 bytes long
	LIST (2) = %LOC(Cprocess_name)			! Set up GETJPI
	LIST (3) = %LOC(Ilength)			! Length of name strng
	ISTATUS=SYS$GETJPI(,,,LIST,,,)			!
	END
