	program newscreat

	parameter NEWSTEXT  = 'NEWS$DIR:NEWSTEXT'
	parameter NEWSUSERS = 'NEWS$DIR:NEWSUSERS'
	parameter RESOURCE  = 'RIT_NEWSUSERS_LCK'
	parameter RESOURCE2 = 'RIT_NEWSTEXT_LCK'

	include 'LCKDEF.INC'
	integer lksb(2), lksb2(2)

	integer count
	integer*2 key, init/0/
	character*72 text /'This line should never appear!'/
	character*12 textmax_key /'DEFAULT'/
	character*80 response


	write (*,20)
	call lib$get_input(response,'Continue (Y,N)? ',)
	if (response .ne. 'Y' .and. response(1:1) .ne. 'y') then
	    print *,'News initiaization aborted.'
	    call exit
	end if



	call sys$enqw(,%val(LCK$K_EXMODE),lksb,%val(LCK$M_SYSTEM),
     *                RESOURCE,,,,,,)
	call sys$enqw(,%val(LCK$K_EXMODE),lksb2,%val(LCK$M_SYSTEM),
     *                RESOURCE2,,,,,,)

	print *,'Creating NEWS$DIR:NEWSUSERS.DAT'
	call lib$spawn('$ create/fdl=newsusers')
	print *,'Creating NEWS$DIR:NEWSTEXT.DAT'
	call lib$spawn('$ create/fdl=newstext')

	print *,'Initializing files.'
	open (unit=100, file=NEWSTEXT, status='old', form='unformatted',
     *        access='keyed', 
     *        carriagecontrol='none', organization='indexed')

	open (unit=101, file=NEWSUSERS, status='old', form='formatted',
     *	access='keyed', key=(1:12:character), recordtype='variable',
     *	carriagecontrol='none', organization='indexed')


	key = 0
	write (100) key,init

	key = 9999
	write (100) key,text

	write (101,10) textmax_key,init


	close (unit=100)
	close (unit=101)

	call sys$deq(%val(lksb(2)),,,)
	print *,'Initialization complete.'

10	format (a12,i4)
20	format ('0WARNING!!!  This command will create new news system'
     *         ,' files.  All current',/,' news will become inactive,'
     *         ,' although the old versions of NEWSUSERS.DAT and',/
     *         ,' NEWSUSERS.DAT will still exist.',/)
	end
