$!
$!  This procedure performs a test of the BAT$CHANGE_TO_IMAGE_UIC
$!  and BAT$RESTORE_PROCESS_UIC system services.
$!
$ CURRENT_DEVDIR = F$TRNLNM ("SYS$DISK") + F$DIRECTORY ()
$ TAB[0,8] = 9
$ CREATE EXAMPLE.DAT		! Create a sample data file.
Test line 1  ------------------------
Test line 2  ************************
Test line 3  ------------------------
$ SET FILE/PROT=W EXAMPLE.DAT
$ CREATE EXAMPLE.FOR
	PROGRAM EXAMPLE
	INTEGER*4 BAT$CHANGE_TO_IMAGE_UIC
	INTEGER*4 BAT$RESTORE_PROCESS_UIC
	CHARACTER REC*60

	I = BAT$CHANGE_TO_IMAGE_UIC ()
	IF (.NOT. I) CALL SYS$EXIT (%VAL (I))
	OPEN (UNIT=1, STATUS='OLD',
$!
$! Construct a Fortran OPEN statement that "knows" the full file-spec
$! of the data file.
$!
$ OPEN/APPEND FORTRAN_EXAMPLE EXAMPLE.FOR
$ WRITE FORTRAN_EXAMPLE TAB, "2 FILE='", CURRENT_DEVDIR, "EXAMPLE.DAT')"
$ CLOSE FORTRAN_EXAMPLE
$ CREATE APPEND.FOR
	I = BAT$RESTORE_PROCESS_UIC ()
	IF (.NOT. I) CALL SYS$EXIT (%VAL (I))

	OPEN (UNIT=2, FILE='LOG.DAT', STATUS='NEW')

30	READ  (UNIT=1, FMT='(A)', END=60) REC
	WRITE (UNIT=6, FMT='(1X, A)') REC
	WRITE (UNIT=2, FMT='(1X, A)') REC
	GOTO 30

60	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	END
$!
$! Now, sew everything together.
$!
$ APPEND APPEND.FOR EXAMPLE.FOR
$ SET PROT=O:REWD APPEND.FOR
$ DELETE APPEND.FOR;0
$ FORTRAN EXAMPLE
$ LINK    EXAMPLE,SYS$INPUT/OPTION
BATUSS/SHARE
$ SET FILE/PROT=W:RE EXAMPLE.EXE
$!
$! At this point the protection on EXAMPLE.EXE is world read/execute.
$! EXAMPLE.DAT denys all world access. To test this program from another
$! account, the other account must have at least execute access on this
$! directory/subdirectory and any directories/subdirectories "above" it.
$!
$ EXIT
