/* PSI definitions.  Created from the PSI Macro definition by
			B. Z. Lederman 01-Dec-1987
			ITT World Communications
			67 Broad St. 28th Floor
			New York, NY. 10004-2464 */

#define PSI$C_NCB_NULL 0
#define PSI$C_NCB_REMDTE 1
#define PSI$C_NCB_REMSUBADR 2
#define PSI$C_NCB_LOCDTE 3
#define PSI$C_NCB_LOCSUBADR 4
#define PSI$C_NCB_USERDATA 5
#define PSI$C_NCB_RESPDATA 6
#define PSI$C_NCB_OBJNAME 7
#define PSI$C_NCB_ENDTOEND 8
#define PSI$C_NCB_ENDTOENDR 9
#define PSI$C_NCB_GATEWAY 10
#define PSI$C_NCB_ICI 11
#define PSI$C_NCB_REVCHG 12
#define PSI$C_NCB_LOCFACR 13
#define PSI$C_NCB_FSEL 14
#define PSI$C_NCB_FSEL_RES 15
#define PSI$C_NCB_THRUCLS 16
#define PSI$C_NCB_CUG 17
#define PSI$C_NCB_DIAGCODE 18
#define PSI$C_NCB_CAUSE 19
#define PSI$C_NCB_REASON 20
#define PSI$C_NCB_PKTSIZE 21
#define PSI$C_NCB_WINSIZE 22
#define PSI$C_NCB_LOCFAC 23
#define PSI$C_NCB_PVCNAM 24
#define PSI$C_NCB_PVCSET 26
#define PSI$C_NCB_LCN 27
#define PSI$C_NCB_CUGN 28
#define PSI$C_NCB_CUGNB 29
#define PSI$C_NCB_LOCNET 30
#define PSI$C_NCB_NETWORK 30
#define PSI$C_NCB_USERID 31
#define PSI$C_NCB_PASSWORD 32
#define PSI$C_NCB_ACCOUNT 33
#define PSI$C_NCB_PRIDST 34
#define PSI$C_NCB_PRIRED 35
#define PSI$C_NCB_RCV_QUOTA 36
#define PSI$C_NCB_NET_USER_ID 37
#define PSI$C_NCB_CHARGING_INFO 38
#define PSI$C_NCB_CHARGE_MON 39
#define PSI$C_NCB_CHARGE_SEG 40
#define PSI$C_NCB_CHARGE_TIME 41
#define PSI$C_NCB_RPOA 42
#define PSI$C_NCB_ADDR_MOD_RSN 43
#define PSI$C_NCB_CALL_REDIR_RSN 44
#define PSI$C_NCB_CALL_REDIR_ORIG 45
#define PSI$C_NCB_TRANSIT_DELAY 46
#define PSI$C_NCB_CALLING_EXTENSION 47
#define PSI$C_NCB_CALLED_EXTENSION 48
#define PSI$C_NCB_MIN_THRUCLS 49
#define PSI$C_NCB_EXPEDITE 50
#define PSI$C_NCB_CUM_TRST_DLY 51
#define PSI$C_NCB_CUM_TRST_DLY_R 52
#define PSI$C_NCB_ETE_TRST_DLY 53
#define PSI$C_NCB_MAX_TRST_DLY 54
#define PSI$C_NCB_INCOMING_DTE 55
#define PSI$C_NTD_ACCLVL 1
#define PSI$C_NTD_SALO 2
#define PSI$C_NTD_SAHI 3
#define PSI$C_NTD_REMDTE 4
#define PSI$C_NTD_USRGRP 5
#define PSI$C_NTD_USRDATA 6
#define PSI$C_NTD_DATMSK 7
#define PSI$C_NTD_PRIORITY 8
#define PSI$C_NTD_REDRSN 9
#define PSI$C_NTD_NETWORK 10
#define PSI$C_NTD_RCVDTE 11
#define PSI$C_NTD_CALLED_DTE 12
#define PSI$C_NTD_INCDTE 13
#define PSI$C_NTD_EXTMSK 14
#define PSI$C_NTD_EXTVAL 15
#define PSI$C_REDRSN_BUSY 0
#define PSI$C_REDRSN_OUT_OF_ORDER 1
#define PSI$C_REDRSN_SYSTEMATIC 2
#define PSI$C_L3_LOCAL 1
#define PSI$C_L3_NETWRK 2
#define PSI$C_L3_NETERR 3
#define PSI$C_L3_LOCERR 4
#define PSI$C_L3_LNKRST 5
#define PSI$C_L3_LNKDWN 6
#define PSI$C_L3_LNKUP 7
#define PSI$C_L3_LNKRRT 8
#define PSI$C_L3_LOCMGT 9
#define PSI$C_L3_CALCOL 10
#define PSI$C_L3_NETTIM 11
#define PSI$C_L3_GATDISC 12
#define PSI$C_L3_NETDISC 13
#define PSI$M_MOREDATA 1
#define PSI$M_QUALIFIED 2
#define PSI$M_STS_PVC 1
#define PSI$M_STS_LOCDTELNG 2
#define PSI$M_STS_REMDTELNG 4
#define PSI$M_STS_USERLNG 8
#define PSI$M_STS_WINBAD 16
#define PSI$M_STS_PKTBAD 32
#define PSI$M_STS_THRBAD 64
#define PSI$M_STS_RPOALNG 128
#define PSI$M_STS_WORDBAD 256
#define PSI$V_MOREDATA 0
#define PSI$V_QUALIFIED 1
#define PSI$V_STS_PVC 0
#define PSI$V_STS_LOCDTELNG 1
#define PSI$V_STS_REMDTELNG 2
#define PSI$V_STS_USERLNG 3
#define PSI$V_STS_WINBAD 4
#define PSI$V_STS_PKTBAD 5
#define PSI$V_STS_THRBAD 6
#define PSI$V_STS_RPOALNG 7
#define PSI$V_STS_WORDBAD 8
#define PSI$C_ERR_UNKNOWN 0
#define PSI$C_ERR_FACLNG 1
#define PSI$C_ERR_INVITEM 2
#define PSI$C_ERR_CONFLICT 3
#define PSI$C_ERR_BADPARM 4
#define PSI$C_ERR_NOTRANS 5
#define PSI$C_ERR_RECURLMT 6
#define PSI$C_ERR_INVNUM 7
#define PSI$C_ERR_NOICI 8
#define PSI$C_ERR_MANYICI 9
#define PSI$C_ERR_NOTIMP 10
#define PSI$C_ERR_NODTES 11
#define PSI$C_ERR_NOSUCHDTE 12
#define PSI$C_ERR_NOSUCHPVC 13
#define PSI$C_ERR_NOSUCHNET 14
#define PSI$C_ERR_NOLOCAL 15
#define PSI$C_ERR_NONONPAG 16
#define PSI$C_ERR_NOL3 17
#define PSI$C_ERR_BADNAME 18
#define PSI$C_ERR_L3ERR 19
#define PSI$C_ERR_PVCALRACC 20
#define PSI$C_ERR_BAD_PVCNAME 21
#define PSI$C_ERR_NOSUCHGROUP 22
#define PSI$C_ERR_INVEXP 23
#define PSI$C_ERR_INVTRSTDLY 24
#define PSI$C_ERR_NOLINES 11
#define PSI$C_ERR_NOSUCHLINE 12
#define PSI$C_INTERRUPT 1
#define PSI$K_INTERRUPT 1
#define PSI$C_INTACK 2
#define PSI$K_INTACK 2
#define PSI$C_RESET 3
#define PSI$K_RESET 3
#define PSI$C_RESTART 7
#define PSI$K_RESTART 7
#define PSI$C_X29_SET 8
#define PSI$K_X29_SET 8
#define PSI$C_X29_READ 9
#define PSI$K_X29_READ 9
#define PSI$C_X29_READ_SPECIFIC 10
#define PSI$K_X29_READ_SPECIFIC 10
#define PSI$K_X29_TEMP_NOHANG 1
#define PSI$K_X29_PAD_PARAMS 2
#define PSI$K_X29_INT_ACTION 3
#define PSI$K_X29_BREAK_ACTION 4
#define PSI$K_X29_HOLD_TIMER 5
#define PSI$K_X29_HOST_ECHO_PARAMS 6
#define PSI$K_X29_LOCAL_ECHO_PARAMS 7
#define PSI$K_X29_HANGUP_PARAMS 8
#define PSI$M_X29_CALCULATED 1
#define PSI$M_X29_ADD_VALUE 2
#define PSI$M_X29_USER_VALUE 4
#define PSI$M_X29_IF_CHANGED 8
#define PSI$C_X29_PARAM_LENGTH 8
#define PSI$K_X29_PARAM_LENGTH 8
#define PSI$S_PSI$_X29_PARAM 8
#define PSI$_X29_PARAM 0
#define PSI$W_X29_PARAM_REF 0
#define PSI$S_X29_PARAM_FLAGS 2
#define PSI$W_X29_PARAM_FLAGS 2
#define PSI$V_X29_CALCULATED 0
#define PSI$V_X29_ADD_VALUE 1
#define PSI$V_X29_USER_VALUE 2
#define PSI$V_X29_IF_CHANGED 3
#define PSI$S_X29_FILL_2 12
#define PSI$V_X29_FILL_2 4
#define PSI$B_X29_PARAM_VALUE 4
#define PSI$S_X29_FILL_1 24
#define PSI$V_X29_FILL_1 40
#define PSI$M_X29_ACTION_RESET 1
#define PSI$M_X29_ACTION_PURGE 2
#define PSI$M_X29_ACTION_CLEAR 4
#define PSI$C_X29_ACTION_LENGTH 20
#define PSI$K_X29_ACTION_LENGTH 20
#define PSI$S_PSI$_X29_FLAGS 20
#define PSI$_X29_FLAGS 0
#define PSI$S_X29_ACTION_FLAGS 4
#define PSI$L_X29_ACTION_FLAGS 0
#define PSI$V_X29_ACTION_RESET 0
#define PSI$V_X29_ACTION_PURGE 1
#define PSI$V_X29_ACTION_CLEAR 2
#define PSI$S_X29_ACTION_STRING 16
#define PSI$T_X29_ACTION_STRING 4
#define PSI$K_X29_PAR_ESCAPE 1
#define PSI$K_X29_PAR_ECHO 2
#define PSI$K_X29_PAR_FORWARD 3
#define PSI$K_X29_PAR_TIMEOUT 4
#define PSI$K_X29_PAR_HOSTSYNC 5
#define PSI$K_X29_PAR_MESSAGES 6
#define PSI$K_X29_PAR_BREAK 7
#define PSI$K_X29_PAR_DISCARD 8
#define PSI$K_X29_PAR_CRFILL 9
#define PSI$K_X29_PAR_WRAP 10
#define PSI$K_X29_PAR_SPEED 11
#define PSI$K_X29_PAR_TTSYNC 12
#define PSI$K_X29_PAR_NEW_LINE 13
#define PSI$K_X29_PAR_LFFILL 14
#define PSI$K_X29_PAR_EDIT 15
#define PSI$K_X29_PAR_DELETE 16
#define PSI$K_X29_PAR_LINE_DELETE 17
#define PSI$K_X29_PAR_REDISPLAY 18
#define PSI$K_X29_PAR_DISPLAY_EDIT 19
#define PSI$K_X29_PAR_RESTRICT_ECHO 20
#define PSI$K_X29_PAR_PARITY 21
#define PSI$K_X29_PAR_PAGE_WAIT 22
#define PSI$K_X29_LAST_1980_X3_PARAM 18
#define PSI$K_X29_LAST_1984_X3_PARAM 22
#define ACR$K_PSI 15
#define ACR$K_PSI_VCT 1
#define ACR$M_PSI_OUT 1
#define ACR$M_PSI_PVC 2
#define ACR$M_PSI_X29 4
#define ACR$M_PSI_ACCESS 8
#define ACR$M_PSI_GATEWAY 16
#define ACR$M_PSI_FAIL 32
#define ACR$M_PSI_REVCHG 1
#define ACR$M_PSI_FAST 2
#define ACR$M_PSI_CUG 4
#define ACR$M_PSI_BCUG 8
#define ACR$S_PSI$_ACR_VCT 88
#define PSI$_ACR_VCT 0
#define ACR$S_PSI_START_TIME 8
#define ACR$Q_PSI_START_TIME 4
#define ACR$L_PSI_BYTES_TX 12
#define ACR$L_PSI_BYTES_RX 16
#define ACR$L_PSI_SEGMENTS_TX 20
#define ACR$L_PSI_SEGMENTS_RX 24
#define ACR$L_PSI_PACKETS_TX 28
#define ACR$L_PSI_PACKETS_RX 32
#define ACR$L_PSI_MESSAGES_TX 36
#define ACR$L_PSI_MESSAGES_RX 40
#define ACR$W_PSI_DESTINATION 44
#define ACR$W_PSI_PVC_NAME 46
#define ACR$W_PSI_RDTE 48
#define ACR$W_PSI_LDTE 50
#define ACR$W_PSI_NETWORK 52
#define ACR$W_PSI_UNIT 54
#define ACR$W_PSI_PROTOCOL 56
#define ACR$W_PSI_CLEAR_FACS 58
#define ACR$W_PSI_CALL_FACS 60
#define ACR$W_PSI_ACCEPT_FACS 62
#define ACR$W_PSI_LCN 64
#define ACR$S_PSI_VCTYPE 2
#define ACR$W_PSI_VCTYPE 66
#define ACR$V_PSI_OUT 0
#define ACR$V_PSI_PVC 1
#define ACR$V_PSI_X29 2
#define ACR$V_PSI_ACCESS 3
#define ACR$V_PSI_GATEWAY 4
#define ACR$V_PSI_FAIL 5
#define ACR$W_PSI_INC_THRU 68
#define ACR$W_PSI_OUT_THRU 70
#define ACR$W_PSI_INC_WINDOW 72
#define ACR$W_PSI_OUT_WINDOW 74
#define ACR$W_PSI_INC_PSIZE 76
#define ACR$W_PSI_OUT_PSIZE 78
#define ACR$S_PSI_FAC_REQ 2
#define ACR$W_PSI_FAC_REQ 80
#define ACR$V_PSI_REVCHG 0
#define ACR$V_PSI_FAST 1
#define ACR$V_PSI_CUG 2
#define ACR$V_PSI_BCUG 3
#define ACR$W_PSI_CUG_NUMBER 82
#define ACR$B_PSI_REASON 84
#define ACR$B_PSI_CAUSE 85
#define ACR$B_PSI_DIAG 86
#define ACR$B_PSI_VCT_FILL_2 87
#define ACR$K_PSI_VCT_VAR 88
