$ v = f$verify (0)
$ ! VAXIN.COM - command file to read (multiple backup sets from a) VAX SIG tape.
$ !
$ ! Calling Sequence:
$ !	@VAXIN yrt disk
$ !
$ ! Where:
$ !	yrt - name of tape (eg, 85A)
$ !	disk - disk on which to put the stuff (default disk$scratch)
$ !
$ if f$length (p2) .eq. 0 then $ p2 = "disk$scratch"
$ assign disk$scratch disk
$ if "" .eqs. f$search ("disk:[0,0]sigtapes.dir") then $ cr/d disk:[sigtapes]
$ cr/d disk:[sigtapes]
$ !
$ ! get names of backup sets on tape in backup_set_name1, backup_set_name2, ...
$ !
$ comment = """Mount VAX sig tape "+p1+" for reading."""
$ mou mu:/over=id/comment='comment'/nowrite/cache=tape_data
$ dir mu:/out=vaxtape.directory/noheader/notrailer/columns=1
$ dism mu:/nounload
$ open/read tape_dir vaxtape.directory
$ bac_set = 1
$loop:
$ read/end_of_input=no_more_sets tape_dir backup_set_name'bac_set'
$ start = f$locate ("VAX", backup_set_name'bac_set')
$ length = f$locate (".", backup_set_name'bac_set') - start
$ backup_set_name'bac_set' = f$extract (start, length, backup_set_name'bac_set')
$ bac_set = bac_set + 1
$ goto loop
$no_more_sets:
$ number_of_bac_set = bac_set - 1
$ close tape_dir
$ delete vaxtape.directory;
$ !
$ ! read backup sets from tape
$ !
$ sd disk:[sigtapes]
$ bac_set = 1
$ mou mu:/for/comment='comment'/nowrite/cache=tape_data
$next_set:
$ vax000 = "VAX000" .eqs. backup_set_name'bac_set'
$ if vax000 then $ if "" .nes. f$search ("[-]vax000'p1'.dir") then $ goto abort
$ if vax000 then $ if "" .nes. f$search ("[]vax000'p1'.dir") then $ goto abort
$ if "" .nes. f$search ("[-]"+backup_set_name'bac_set'+".dir") then $ goto abort
$ if "" .nes. f$search ("[]"+backup_set_name'bac_set'+".dir") then $ goto abort
$ backup mu:&backup_set_name'bac_set' disk:[*...]
$ set file [&backup_set_name'bac_set'...]*.*;*/prot=s:rwed/backup
$ rename [-]&backup_set_name'bac_set'.dir []
$ if vax000 then $ rename []vax000.dir []vax000'p1'.dir
$ bac_set = bac_set + 1
$ if bac_set .le. number_of_bac_set then $ goto next_set
$ dism mu:
$ deass disk
$ v = f$verify (v)
$ exit
$ !
$ ! abort reading to avoid colliding with a directory already present
$ !
$abort:
$ write sys$output "aborting readin of tape "+p1+", directory already present."
$ v = f$verify (v)
$ exit
