$!..FREE.COM -- Report free space on disks.
$! P1 can be any portion of a disk name or logical name,
$! or "." to select current default device, or omitted to select all disks
$
$	IF "''TYPO'" .EQS. "" THEN @USR$DISK1:[MAUS.COM]TYPO
$	TYPO T$LF, "		", F$TIME()
$
$	IF F$TRNLNM ("ALL") .EQS. "" THEN @USR$DISK1:[MAUS.COM]ALLDISK
$
$!process P1 (selection parameter)
$	P1 = P1 -":"
$	IF (P1 .EQS. "")   .OR.  (F$LOCATE (P1, "CSA1") .GE. 4) THEN GOTO NOTCS
$		SELECT = "CSA1"
$		GOTO SELECT_DONE
$NOTCS:
$	SELECT = P1
$!translate logical name
$	SELLNM = "FALSE"
$	LNM = "?"
$	IF SELECT .EQS. "." THEN SELECT = F$PARSE ("",,, "DEVICE") -":"
$	IF SELECT .EQS. "" THEN GOTO LNM_DONE
$		LNM1 = SELECT
$LNM_LOOP:		!loop thru xlations to last
$		LNM1 = F$TRNLNM (LNM1)
$		LNM1 = F$ELEMENT (0, ":", LNM1)		!only take dev portion
$		IF LNM1 .EQS. "" THEN GOTO LNM_DONE	!xlate till it quits
$		LNM = LNM1				!remember the last one
$		GOTO LNM_LOOP				!repeat
$LNM_DONE:
$	IF LNM .EQS. "?"   .OR.   LNM .EQS. "" THEN GOTO SELECT_DONE
$		IF F$LOCATE (":", LNM) .GE. F$LENGTH (LNM) THEN LNM = LNM +":"
$		SELECT = F$PARSE (LNM,,, "DEVICE") -":"
$		SELECT = F$GETDVI ("''SELECT'", "DEVNAM") -"_"
$		SELLNM = "TRUE"
$SELECT_DONE:
$
$!display intro and heading
$	TYPO "	Current disk space measured in blocks from ", -
		F$GETSYI ("NODENAME")
$	IF SELECT .EQS. "" THEN GOTO NOSELECT
$	SLINE = " 		select: ""''P1'"""
$	IF P1 .NES. SELECT THEN SLINE = SLINE +"=""''SELECT'"""
$	TYPO SLINE
$NOSELECT:
$	TYPO "Device               Max      Used   %       Free   %" -
		+"    Logical-name"
$	FMT  = " !13AS!2(10SL) !3SL !10SL !3SL     !AS"
$	FMTA = " !13AS!2(10AS) !3AS !10AS !3AS     !AS"
$
$	NOTMNT = ""	!device not mounted flag
$	N_NOTMNT = 0	!count of not mounted disks
$	N_MNT = 0	!count of mounted disks
$	N_SEL = 0	!count of disks selected
$	N_DISK = 0	!count of existing disks
$	TOT_MAX = 0	!sum of MAX-blocks for all sected disks
$	TOT_USED = 0	!sum of USED-blocks for all sected disks
$	TOT_FREE = 0	!sum of FREE-blocks for all sected disks
$DISK_LOOP:
$	DEV = F$TRNLNM ("ALL",, N_DISK)
$	N_DISK = N_DISK +1
$	IF DEV .EQS. "" THEN GOTO DISK_DONE
$		DEV = F$GETDVI ("''DEV'", "DEVNAM") -"_"
$		IF .NOT. F$GETDVI (DEV, "MNT") THEN GOTO DEV_NOTMNT
$		N_MNT = N_MNT +1
$		DEV_MATCH = F$LOCATE (SELECT, DEV) .LT. F$LENGTH (DEV)
$		LNM = F$GETDVI(DEV, "LOGVOLNAM")
$		LNM_MATCH = F$LOCATE (SELECT, LNM) .LT. F$LENGTH (LNM)
$		IF .NOT. (DEV_MATCH   .OR.   LNM_MATCH) THEN GOTO DISK_LOOP
$SELLOOP:
$		N_SEL = N_SEL +1
$		GOSUB DEV_GETDVI
$		IF .NOT. SELLNM THEN GOTO DISK_LOOP
$		  VOLCNT = F$GETDVI (DEV, "VOLCOUNT") -1
$		  IF VOLCNT .LT. 1 THEN GOTO DISK_LOOP
$		    ROOTDONE = "FALSE"
$		    ROOTDEV = F$GETDVI (DEV, "ROOTDEVNAM") -"_"
$		    IF ROOTDEV .EQS. DEV THEN ROOTDONE = "TRUE"
$		    IF ROOTDONE THEN GOTO NEXTVOL
$		      DEV = ROOTDEV
$		      GOSUB DEV_GETDVI
$		      ROOTDONE = "TRUE"
$		      N_SEL = N_SEL +1
$		      VOLCNT = VOLCNT -1
$		      IF VOLCNT .LT. 1 THEN GOTO DISK_LOOP
$NEXTVOL:
$		    DEV = F$GETDVI (DEV, "NEXTDEVNAM") -"_"
$		    IF DEV .EQS. "" THEN GOTO DISK_LOOP
$		      GOSUB DEV_GETDVI
$		      N_SEL = N_SEL +1
$		      VOLCNT = VOLCNT -1
$		      GOTO NEXTVOL
$
$DEV_NOTMNT:
$	N_NOTMNT = N_NOTMNT +1
$	NOTMNT = NOTMNT +", " +DEV
$	GOTO DISK_LOOP
$
$DEV_GETDVI:	!gosubroutine
$	MAX = F$GETDVI(DEV, "MAXBLOCK")
$	FREE = F$GETDVI(DEV, "FREEBLOCKS")
$	LNM = F$GETDVI(DEV, "LOGVOLNAM")
$	USED = MAX -FREE
$	XMAX = (MAX +500) /1000
$	PCT_U = (USED /XMAX +5) /10
$	PCT_F = (FREE /XMAX +5) /10
$	TYPO F$FAO (FMT, DEV, MAX, USED, PCT_U, FREE, PCT_F, LNM)
$
$	TOT_MAX = TOT_MAX +MAX
$	TOT_USED = TOT_USED +USED
$	TOT_FREE = TOT_FREE +FREE
$	RETURN	!DEV_GETDVI
$
$DISK_DONE:
$	IF N_SEL .GT. 0 THEN GOTO DISP_TOTALS
$	IF .NOT. F$GETDVI (SELECT, "EXISTS") THEN GOTO BAD_DEV
$	IF .NOT. F$GETDVI (SELECT, "MNT") THEN GOTO BAD_DEV
$	DEV = SELECT
$	GOSUB DEV_GETDVI
$	N_SEL = 1
$	GOTO DISP_COUNTS
$
$DISP_TOTALS:
$	IF N_SEL .LT. 2 THEN GOTO DISP_COUNTS
$	TYPO F$FAO (FMTA, ""," ---------", " ---------", "", -
			" ---------", "", "")
$	XMAX = (TOT_MAX +500) /1000
$	PCT_U = (TOT_USED /XMAX +5) /10
$	PCT_F = (TOT_FREE /XMAX +5) /10
$	TYPO F$FAO (FMT, "Total", TOT_MAX, TOT_USED, PCT_U, -
		TOT_FREE, PCT_F, " ")
$
$DISP_COUNTS:
$	IF N_SEL .LT. N_MNT THEN TYPO F$FAO ("!_!_!SB disk!%S selected", N_SEL)
$	NOTMNT = NOTMNT -", "
$	TYPO F$FAO (" !SB disk!%S, !SB mounted, !SB not mounted:!/ !AS", -
			N_DISK, N_MNT, N_NOTMNT, NOTMNT)
$	GOTO DONE
$
$BAD_DEV:
$	TYPO "%FREE-E-NOSUCH, disk """, SELECT, -
		""" does not exist or is not mounted"
$
$DONE:
$ EXIT !--FREE.COM
------------------------------------------------------------------------------
revision history

10/84 D.J.Maus
8/85  DJM	loop thru disks; CSA1 conditioned on MNT=TRUE
8/85  DJM	use FAO
10/85 DJM	BYTES OR BLOCKS
11/85 DJM	detect CSA1 mounted /FOREIGN
2/87  DJM	count disks mounted and not, display disks not mounted
3/87  DJM	CSA1 shown only if P1 = "CS"
3/87  DJM	invoke ALLDISK.COM if logical name ALL is not assigned
3/87  DJM	allow selection by substring of device or logical names
6/87  DJM	allow logical name as P1
------------------------------------------------------------------------------

@FREE [parameter]
where the optional parameter may be omitted or a string to be used to select a
particular disk or group of disks.  If omitted, all disks ($SHOW DEVICE D) are
selected.  If the string is ".", only the current default device will be
selected.  Any other string will be compared to every device name and logical
name, and all disks that have the given string as part of the device name or
logical name, will be selected. 
	$ @FREE			!selects all disks
	$ @FREE .		!selects the current default device
	$ @FREE K3		!selects USR$DISK3
	$ @FREE DJA		!selects all $1$DJA* devices

[End of FREE.COM]
