$!..IMAGE_COUNT.COM -- report count of processes running each image currently
$	@MCOM:TYPO
$	TYPO "Image counts on ", F$GETSYI("NODENAME"), ":: ", F$TIME()
$
$	INMS = ""	!string of all found image names
$	LEN = 0		!beginning length
$	LOCN = ""	!string of LOCATE numbers
$	PRCNT = 0	!total process count
$LOOP1:		!loop thru current processes
$	PID = F$PID (CONTEXT)			!get a PID
$	IF PID .EQS. "" THEN GOTO DONE		!no more?
$	IMAGE = F$GETJPI (PID, "IMAGNAME")	!get image for PID
$	IMAGE = F$PARSE (IMAGE,,, "NAME")	!all we want is the name
$	IF IMAGE .EQS. "" THEN IMAGE = "(DCL)"
$	PRCNT = PRCNT +1
$	LOC = F$LOCATE (IMAGE, INMS)		!do we already have this image?
$	IF LOC .GE. LEN THEN GOTO NEW_ONE	!--yes
$		C'LOC' = C'LOC' +1		!increment count for this image
$		GOTO LOOP1
$	NEW_ONE:				!--no
$		INMS = INMS +" " +IMAGE		!put this image name in list
$		LAST_IMAGE = IMAGE		!remember the last (this) one
$		LOC = LEN +1			!calc it's location in string
$		LEN = F$LENGTH (INMS)		!get new length
$		C'LOC' = 1			!init the counter for this image
$		LOCN = LOCN +" ''LOC'"		!put its location in list
$		GOTO LOOP1
$ DONE:			!here when no more processes
$	TYPO " "		!output blank line
$	FMT = "!4SB !15AS"	!"nnnn 1ima5gen10ame15"
$	ENUM = 1		!element number in name and location strings
$	COL = 0			!init output (LINE) columns
$	LINE = ""
$ LOOP2:
$	LOC = F$ELEMENT (ENUM, " ", LOCN)	!get a location in INMS
$	IMAGE = F$ELEMENT (ENUM, " ", INMS)	!get an image name
$	ENUM = ENUM +1				!incr element number
$	COL = COL +1				!incr (LINE) columns
$	IF COL .LE. 4 THEN GOTO NEXT_IMAGE	!four columns per LINE
$		TYPO LINE	!output one line
$		COL = 1		!reset column count
$		LINE = ""	!clear the LINE
$	NEXT_IMAGE:
$	LINE = LINE +F$FAO (FMT, C'LOC', IMAGE)	!put count and name in LINE
$	IF IMAGE .NES. LAST_IMAGE THEN GOTO LOOP2	!did we do the last one?
$	IF LINE .NES. "" THEN TYPO LINE		!output the last line (if any)
$
$	TYPO T$LF, F$FAO(FMT, PRCNT, "Total")
$ EXIT
