$!..MSUBMIT.COM -- if interactive mode, provide submit
$!  P1=com_proc_spec, P2=queue_name [ADCALC_BATCH], P3=log_file [cur default]
$!  P4=other qualifiers
$
$	IF F$MODE() .EQS. "BATCH" THEN GOTO CONTINUE
$	IF F$MODE() .NES. "INTERACTIVE" THEN GOTO DISCONTINUE
$	ON WARNING THEN GOTO DISCONTINUE
$	TYPO := WRITE SYS$OUTPUT
$TOP:
$	IF P1 .NES. "" THEN GOTO P1OK
$		READ  SYS$COMMAND  P1 /END=CTLZ -
			/PROMPT="Command procedure spec to submit> "
$		GOTO TOP
$P1OK:
$	WRITE SYS$OUTPUT "[", P1, " ", F$TIME(), " ]  [MSUBMIT.COM]"
$	WRITE SYS$OUTPUT " "
$	IF P2 .EQS. "" THEN P2 = "ADCALC_BATCH"
$	IF P3 .EQS. "" THEN P3 = F$ENVIRONMENT ("DEFAULT")
$	CMD :=	SUBMIT  'P1' -
		/QUEUE='P2' -
		/LOG_FILE='P3' /NOPRINT -
		/NOTIFY -
		'P4'
$	SHOW SYMBOL/LOCAL CMD
$	TYPO "	Stop if <CR> or N, submit if Y, run interactively if I"
$	READ  SYS$COMMAND  OK  /END=CTLZ/PROMPT="OK to submit? ([N], Y, or I)>"
$	OK1 = F$EXTRACT (0,1, F$EDIT (OK, "TRIM,UPCASE"))
$	IF OK1 .EQS. ""  .OR.  OK1 .EQS. "N" THEN GOTO DISCONTINUE
$	IF OK1 .EQS. "I" THEN GOTO CONTINUE	!run interactively this time
$	IF OK1 .EQS. "Y" THEN GOTO SUBMITIT
$	TYPO "%MSUBMIT-E-BADRESP, unknown response """, OK, """"
$	GOTO TOP
$SUBMITIT:
$	'CMD'
$	TYPO "%MSUBMIT-S-SUBM, procedure submitted."
$	STOP !MSUBMIT, do not continue after submit
$CTLZ:
$DISCONTINUE:
$	TYPO "%MSUBMIT-I-STOP, procedure discontinued."
$	STOP !MSUBMIT, do not continue
$
$CONTINUE:
$EXIT !MSUBMIT and continue

 3-SEP-1987
