$!..QPURGE.COM -- Question PURGE -- which files will be purged?
$	ON WARNING THEN GOTO ER1
$	ON CONTROL_Y THEN GOTO CTLY
$	@MCOM:TYPO
$	TYPO F$TIME(), "	@QPURGE", P1, T$LF
$
$	NDEL = 0
$	NFND = 0
$	LOG = "FALSE"
$	WILPURG = "%QPURGE-I-WILPURG, will purge: !AS (!SL block!%S)"
$	TOKEN_FIL = ""
$	PARAM_FIL = ""
$	QUALS = ""
$	KEEP = 1
$	TOT_ALQ = 0
$
$	CMDLIN = F$EDIT (P1, "TRIM,UPCASE,COMPRESS") +" "
$
$TOKENLOOP:
$	CMDLIN = F$EDIT (CMDLIN, "TRIM")
$	T1 = F$EXTRACT (0,1, CMDLIN)
$	IF T1 .EQS. "/" THEN CMDLIN = CMDLIN -"/"
$	CLEN = F$LENGTH (CMDLIN)
$	IF CLEN .LE. 1 THEN GOTO TOKENDONE
$	SLASH = F$LOCATE ("/", CMDLIN)
$	SPACE = F$LOCATE (" ", CMDLIN)
$	IF SLASH .LE. SPACE THEN TEND = SLASH
$	IF SLASH .GT. SPACE THEN TEND = SPACE
$	TOKEN = F$EXTRACT (0, TEND, CMDLIN)
$	CMDLIN = F$EXTRACT (TEND, CLEN, CMDLIN)
$
$	IF T1 .EQS. "/" THEN GOTO QUAL
$	TOKEN_FIL = TOKEN
$	PARAM_FIL = TOKEN
$	GOTO TOKENLOOP
$
$QUAL:
$	QUAL  = F$ELEMENT (0, "=", TOKEN)
$	VALUE = F$ELEMENT (1, "=", TOKEN)
$	QLEN = F$LENGTH (QUAL)
$
$	KEEP = F$EXTRACT (0, QLEN, "KEEP")
$	IF QUAL .EQS. KEEP THEN GOTO KEEPQUAL
$	LOG = F$EXTRACT (0, QLEN, "LOG")
$	IF QUAL .EQS. LOG THEN GOTO LOGQUAL
$
$	TYPO "QPURGE-E-BADQUAL, unknown qualifier ""/", QUAL, """"
$	GOTO ER1
$KEEPQUAL:
$	KEEP = F$INTEGER (VALUE)
$	GOTO TOKENLOOP
$LOGQUAL:
$	LOG = "TRUE"
$	GOTO TOKENLOOP
$TOKENDONE:
$	KEEP = F$INTEGER (KEEP)
$	IF KEEP .LT. 1 THEN KEEP = 1
$
$	DEV = F$PARSE (TOKEN_FIL,,, "DEVICE")
$	DIR = F$PARSE (TOKEN_FIL,,, "DIRECTORY")
$	NAM = F$PARSE (TOKEN_FIL,,, "NAME")
$	TYP = F$PARSE (TOKEN_FIL,,, "TYPE")
$	VER = F$PARSE (TOKEN_FIL,,, "VERSION")
$	IF NAM .NES. "" THEN GOTO NAM_PRESENT
$		NAM = "*"
$		TYP = ".*"
$NAM_PRESENT:
$	IF VER .EQS. ";" THEN GOTO VER_NOT_PRESENT
$		TYPO "%QPURGE-W-VERIGN, version present.  Ignored."
$		PARAM_FIL = PARAM_FIL -VER
$VER_NOT_PRESENT:
$	FIL = DEV +DIR +NAM +TYP +";*"
$	IF F$SEARCH (FIL, 1) .NES. "" THEN GOTO FILDONE
$		TYPO "%QPURGE-E-BADFIL, file not found /", PARAM_FIL, "/"
$		GOTO ER1
$FILDONE:
$
$	PREV1 = ""
$LOOP1:
$	FIL1 = F$SEARCH (FIL, 2)
$	IF FIL1 .EQS. "" THEN GOTO NOMORE
$	NFND = NFND +1
$	FIL1X = FIL1 -F$PARSE (FIL1,,, "VERSION")
$	IF FIL1X .EQS. PREV1 THEN GOTO LOOP1
$	PREV1 = FIL1X
$	PREV2 = ""
$	NF2 = 0
$LOOP2:
$	FIL2 = F$SEARCH (FIL1X +";*", 3)
$	IF FIL2 .EQS. "" THEN GOTO LOOP1
$	IF FIL2 .EQS. PREV2 THEN GOTO LOOP1
$	PREV2 = FIL2
$	NF2 = NF2 +1
$	IF NF2 .LE. KEEP THEN GOTO LOOP2
$	NDEL = NDEL +1
$	ALQ = F$FILE_ATTRIBUTE (FIL2, "ALQ")
$	TOT_ALQ = TOT_ALQ +ALQ
$	IF .NOT. LOG THEN GOTO LOOP2
$		TYPO F$FAO (WILPURG, FIL2, ALQ)
$		GOTO LOOP2
$
$NOMORE:
$	IF NDEL .GE. 1 THEN GOTO SOMEDEL
$		TYPO "%QPURGE-I-NOFILPURG, no files will be deleted"
$		GOTO WITHCMD
$SOMEDEL:
$	TYPO F$FAO ("%QPURGE-I-TOTAL, !SL file!%S (!SL block!%S)" -
			+" will be deleted", NDEL, TOT_ALQ)
$WITHCMD:
$	KQUAL = ""
$	IF KEEP .GT. 1 THEN KQUAL = F$FAO ("/KEEP=!SL", KEEP)
$	TYPO "		with $PURGE ", PARAM_FIL, KQUAL
$ER1:
$CTLY:
$EXIT !QPURGE.COM
==============================================================================
Question-PURGE: find out how many and which files will be be deleted with a
$PURGE command.  Format:

	@QPURGE  [file-spec][/qualifiers]
				/LOG		default is no /LOG
				/KEEP[=n]	default is /KEEP=1

[End of QPURGE.COM]
