$! DECALC_V3NAME.COM	! CONVERT GLOBAL V3_GRID_NAME TO V3 FORMAT
$! 
$! THIS IS CALLED BY DECALCON.COM AND CONVERTER.COM.
$	
$! This procedure convertS v2 grid name to v3 format.
$! 
$! The global SPEC_CHAR_CNT returns the number of "$" substitutions for
$! special characters.
$	
$	SAVED_VERIFY=F$VERIFY(0) ! THIS TURNS IT OFF AND RETURNS 1 IF IT WAS ON
$
$	V3_GRID_NAME == F$EDIT(V3_GRID_NAME, "TRIM,COMPRESS,UPCASE")
$
$!	V3_GRID_NAME == F$EDIT("TEST_-#abcdefghijklmnopqrs___1234567890",-
$!				"TRIM,COMPRESS,UPCASE") 
$	
$	T_POS = 0
$	
$	T_LEN = F$LENGTH(V3_GRID_NAME)
$	
$	T_NAME = ""
$	
$ LOOP:
$	
$	T_CHAR = F$EXTRACT(T_POS,1,V3_GRID_NAME)
$	
$	IF T_CHAR .EQS. " " THEN T_CHAR = "_"
$	
$	IF F$LOCATE(T_CHAR,"ABDECFGHIJKLMNOPQRSTUVWXYZ1234567890$-_") .NE. -
				39 THEN GOTO NOT_SPEC
$
$	T_CHAR = "$"
$	
$	SPEC_CHAR_CNT == SPEC_CHAR_CNT + 1
$	
$ NOT_SPEC:
$
$	T_NAME = T_NAME + T_CHAR
$	
$	T_POS = T_POS + 1
$	
$	IF T_POS .LT. T_LEN THEN GOTO LOOP
$	
$	V3_GRID_NAME == F$EXTRACT(0,39,T_NAME)
$	
$	IF SAVED_VERIFY THEN SET VERIFY
$
$	EXIT 1
