$! DISK_REO_DATA_CHECK.COM	TEST DATA FILE SPLIT FOR DISK REORGANIZATION.
$	
$
$!	SAVED_VERIFY=F$VERIFY(0) ! THIS TURNS IT OFF AND RETURNS 1 IF IT WAS ON
$	
$	WTO ""
$	WTO "THIS PROCEDURE WILL HELP DETERMINE IF THE ZONE DATA SEQUENCE"
$	WTO "FILE SPECIFICATIONS WILL RESULT WITH A BALANCE OF DATA ON BOTH"
$	WTO "SIDES OF THE INDEXF.SYS."
$	WTO ""
$	WTO "	P1	INPUT DISK. MUST HAVE COLON."
$	WTO "	P2	DATA DIRECTORIES ON THE INPUT DISK: DATA1/DGCDAT1/"
$	WTO "	P3	OPTIONS: ALL	DO NOT COMPUTE HALF POINT LIST ALL FILES"
$	WTO "			 NODIR	USE THE LAST DIRECTORY CREATED (FASTER)"
$	WTO ""
$	
$	ON ERROR THEN GOTO BOMBER
$
$	DEF/LOG REO_IN "''P1'"	! DEFINE INPUT DISK ADDRSS
$	
$	VOL_LAB = F$GETDVI("REO_IN:", "VOLNAM") ! GET INPUT VOL LABEL FOR OUTPUT
$
$	WTO " **** RUN ZONE ANALYSIS PROGRAM FOR DIRECTORIES: ''P1'(''P2')"
$
$	!    1.	OUTPUT FILES: WITH FILE SPEC, ALLOCATED SIZE AND MODIFY DATE:
$	! 
$	! 	A. ZONE 2 - FOR .LIS TYPE FILES TO BE PLACED IN THE MIDDLE.
$	! 
$	! 	B. ZONE 3 - FOR .COB TYPE FILES TO BE PLACED ON THE OUTSIDE.
$	! 
$	!    2. OUTPUT GLOBAL SYMBOLS FOR FILE TYPE COUNTS AND SIZE
$
$	! SET MOST RECENT USED FILE SYMBOL:
$
$	T_DATE = F$CVTIME("TODAY-7-00")
$
$	S_RECENT_DATE ==	F$EXTRACT( 2,2,T_DATE) + 	-
				F$EXTRACT( 5,2,T_DATE) + 	-
				F$EXTRACT( 8,2,T_DATE) 
$
$	S_DATA_DIR == P2
$
$	DEF/NOLOG ZONE_DIR DRO_INPUT.DIRECT
$
$	DEF/NOLOG ZONE2_COM NL:
$
$	DEF/NOLOG ZONE_DATA ZONE_DATA_'VOL_LAB'.DAT
$
$	DEF/NOLOG ZONE_DATA_SEQ 'VOL_LAB'.DAT
$
$	DEF/NOLOG ZONE_SYS NL:
$	
$	IF F$LOCATE("NODIR",P3) .NE. F$LENGTH(P3) THEN GOTO RUN_ZONE
$	
$	T_SPEC = "REO_IN:"
$	
$	CNT = 0
$	
$	T = P2
$	
$ SPEC_LOOP:
$	
$	POS = F$LOCATE("/",T)
$
$	IF POS .EQ. F$LENGTH(T) THEN GOTO SPEC_END
$
$	CNT = CNT + 1
$
$	IF CNT .GT. 1 THEN T_SPEC = T_SPEC + ","
$
$	T_SPEC = T_SPEC + "[" + F$EXTRACT(0, POS, T) + "...]"
$
$	T = F$EXTRACT(POS + 1, 255, T)
$
$	GOTO SPEC_LOOP
$	
$ SPEC_END:
$	
$ 	DIR/SIZ=ALL/DAT=MOD/OUT=ZONE_DIR 'T_SPEC'
$	
$	PURGE ZONE_DIR
$	
$ RUN_ZONE:
$	
$	RUN ZONE
$
$	! SORT ZONE DATA COMMAND FILE BY EXTENSION:
$
$	SORT/KEY=(POS=1,SIZ=9) ZONE_DATA ZONE_DATA_'VOL_LAB'.DAT
$
$	PURGE ZONE_DATA
$
$	! FIND OUT WHERE THE DATA FILES WILL DIVIDE EVENLY:
$	
$	! ADD LOGIC FOR NO DATA FILE <---<<<
$	
$	T_HALF = S_TOT_DATA_SIZE / 2
$	
$	IF F$LOCATE("ALL",P3) .NE. F$LENGTH(P3) THEN T_HALF = 891072
$	
$	OPEN/READ Z_DATA ZONE_DATA	! ACCESS LIST OF FILES TO COPY
$
$	T_HALF_TEST = 0
$	
$	SET NOVER
$	
$	WTO ""
$	WTO "SEQ TOT BLK                              FILE                              SIZE"
$	WTO ""
$	
$	CNT = 0
$	
$ READ_ZDAT:
$	
$	READ/END=CLOSE_ZD Z_DATA ZD_REC
$
$	CNT = CNT + 1
$	
$	FILE = F$EDIT(F$EXTRACT(9, 80, ZD_REC), "TRIM")
$
$	FILE = F$EXTRACT(0, F$LOCATE(" ", FILE), FILE)
$
$ 	F_SIZE = F$INTEGER( F$EXTRACT( 117, 7, ZD_REC))
$	
$	T_HALF_TEST = T_HALF_TEST + F_SIZE
$	
$	WTO F$FAO("!3UL !7UL !60AS !7UL", CNT, T_HALF_TEST, FILE, F_SIZE)
$	
$	IF T_HALF_TEST .LT. T_HALF THEN GOTO READ_ZDAT
$	
$!	IF SAVED_VERIFY THEN SET VERIFY
$	
$ CLOSE_ZD:
$	
$	CLOSE Z_DATA
$	
$	WTO ""
$
$	IF F$LOCATE("ALL",P3) .NE. F$LENGTH(P3) THEN GOTO EOJ
$
$	WTO "FILE SIZE OVER 1/2 TOTAL DATA SIZE (''T_HALF'): ''F_SIZE'"
$
$	WTO ""
$
$	IF T_HALF_TEST .GT. T_HALF THEN T_HALF_TEST = T_HALF_TEST - F_SIZE
$	
$	T_HALF_H = S_TOT_DATA_SIZE - T_HALF_TEST
$	
$	WTO "FINAL 1/2 DATA SIZE: LOW:  ''F$FAO("!7UL ",T_HALF_TEST)'"
$	WTO "                     HIGH: ''F$FAO("!7UL ",T_HALF_H)'"
$
$ EOJ:
$	
$	EXIT 1
$
$ BOMBER:
$
$	SHO TIME
$
$!	IF SAVED_VERIFY THEN SET VERIFY
$
$ 	WRITE SYS$OUTPUT ""
$ 	WRITE SYS$OUTPUT "DISK REORGANIZATION DATA SPLIT TEST FAILED"
$ 	WRITE SYS$OUTPUT ""
$
$ 	GOTO EOJ
