$	type/page sys$input

BUILDING THE EXECUTABLE:

    If you have mms then all you have to do is use the following command
to build the executable: $ MMS/DESCRIPTION=DOWN

    If you do not have mms or some compatible make utility then you should
use the procedure called BUILD-DOWN.COM.  Do not use this if you have mms
or some other compatible make utility.

BUILDING THE HELP LIBRARY:

    To build the help library you can simply execute the command procedure
called BUILD-HELP.COM.  This procedure will create a help library in the
SYS$HELP common directory and sets the protection so that the world has
read and execute access to it.
$
$ Build_executable:
$	write sys$output ""
$	write sys$output "If you choose to build the executable now it will be"
$	write sys$output "built in your current default directory which is"
$	write sys$output f$environment("default")
$	write sys$output "as DOWN.EXE and will inherit your default protection."
$	write sys$output ""
$	read/prompt="Do you wish to build the executable now? (Y/N) [N]: " -
	    sys$command build_it
$	if .not. build_it then goto build_help_library
$
$	read/prompt="Use MMS to build the executable? (Y/N) [N]: " -
	    sys$command use_mms
$	if .not. use_mms then goto use_com_procedure
$
$	write sys$output "Using MMS to build the executable..."
$	mms/description=down
$	goto build_help_library
$
$ Use_com_procedure:
$	write sys$output "Using the supplied command procedure to build exe..."
$	@build-down
$
$ Build_help_library:
$	write sys$output ""
$	write sys$output "If you choose to build the help library now it will"
$	write sys$output "be created in the SYS$HELP: directory specifically "
$	write sys$output "the SYS$COMMON:[SYSHLP] directory so it will be"
$	write sys$output "available to all nodes that share a common system"
$	write sys$output "disk.  It will be created as DOWN.HLB with a "
$	write sys$output "protection code of (RWED,RWED,RE,RE)."
$	write sys$output ""
$	write sys$output "If it is undesireable to have the help file in the"
$	write sys$output "SYS$HELP directory then it can be accessed from any"
$	write sys$output "directory if you define the logical name TTU_HELP:"
$	write sys$output "to point to the directory in which it is contained."
$	write sys$output "Example: $ DEFINE TTU_HELP disk:[directory]"
$	write sys$output ""
$	read/prompt="Do you wish to build the help library now? (Y/N) [N]: " -
	    sys$command build_it
$	if build_it then @build-help
$
$ End_it:
$	exit
