$! Build the down utility from the ground up.
$! Use this procedure only if you don't have mms or some type
$! of make utility that can parse the makefile (down.mms) that
$! was provided.
$
$	save_verify = f$verify(1)
$! Compile all the basic modules.
$	basic/nocheck/nodebug down	      ! Main program
$	basic/nocheck/nodebug find_dirs       ! The workhorse
$	basic/nocheck/nodebug set_cursor_abs  ! Get/output direct cursor address
$	basic/nocheck/nodebug fancy_selection ! Full screen routine
$	basic/nocheck/nodebug read_dirs       ! Reads directories
$	basic/nocheck/nodebug display_dirs    ! Display directories-full screen
$	basic/nocheck/nodebug output          ! Get & output terminal sequence
$	basic/nocheck/nodebug find_last       ! Find last occurance of string
$	basic/nocheck/nodebug set_dir         ! Set default directory
$	basic/nocheck/nodebug set_prompt      ! Set DCL prompt
$	basic/nocheck/nodebug split           ! Separate device and directory
$	basic/nocheck/nodebug help            ! Output help
$	basic/nocheck/nodebug errou           ! Error routine to establish
$	basic/nocheck/nodebug get_input       ! Input routine for help
$	basic/nocheck/nodebug put_output      ! Output routine for help
$
$! Create the command definition object.
$	set command/object=downcld.obj down.cld
$
$! Compile the macro file that globalizes some needed symbols.
$	macro downdefs
$
$! Compile the message file.
$	message downmsg
$
$! Link it all together.
$	link/notrace down, find_dirs, set_cursor_abs, read_dirs, display_dirs, -
	    output, get_input, put_output, find_last, set_dir, set_prompt, -
	    split, help, errou, downcld, downdefs, fancy_selection, downmsg
$
$! All done.
$	save_verify = 'f$verify(save_verify)'
$	exit
