# include	<jpidef.h>
# include	<ssdef.h>
# include	<ctype.h>
	/* constant definitions */
# define	TRUE		1	/* boolean true			*/
# define	FALSE		0	/* boolean false		*/
# define	EFN		1	/* which event flag to use	*/
# define	NBRITEMS	10	/* number of getjpi items req.	*/

# define	SCH$C_HIB	7
# define	SCH$C_HIBO	8

	/* macros */
# define	SIGNAL(status)						\
			if (1&status != 1)				\
				lib$stop(status);
main(argc,argv)
int argc;
char *argv[];
{
char	img[128];		/* image name				*/
int	owner;			/* owner if subprocess			*/
int	pid;			/* process identification		*/
int	jobtype;		/* type of job				*/
char	processname[15];	/* name of process			*/
char	terminal[7];		/* terminal of process			*/
char	username[15];		/* user name				*/
int	pri;			/* current priority			*/
int	prib;			/* base priority			*/
int	state;			/* process state			*/

int	pidcontext;		/* process id context for getjpi call	*/
int	save_context;		/* last process id context 		*/
int	getjpi_status;		/* getjpi returned status variable	*/
int	sys$getjpiw();		/* getjpi system service returns an int	*/
int	bool_status;		/* boolean program status		*/
char	image[128];		/* image name after device removal	*/
int	sleepytime;		/* number of seconds to sleep		*/
int	user_flag;		/* 0=normal 1=show users 		*/
int	print_flag;		/* 0=detached 1=sub 2=batch 3=inter 	*/
int	index;			/* general purpose index		*/
char	says_job_user[5];	/* says job or user			*/
char	hibernate_ind[2];	/* contains '*' if proc is hibernating	*/

struct
{
	short	io_s;
	short	len;
	int	info;
} iosb;


struct	ITEM
{
	short	len;		/* buffer length			*/
	short	item_code;	/* information item requested		*/
	char	*buf;		/* return buffer			*/
	int	*rlen;		/* return length			*/
};

struct
{
	struct	ITEM items[1];
	int	endoflist;
} itemlist_img				=
					{
		/* imagename	*/	128,JPI$_IMAGNAME,img	,0
					};

struct
{
	struct	ITEM items[NBRITEMS];
	int	endoflist;
} itemlist				=
					{
		/* owner	*/	4 , JPI$_OWNER	,&owner ,0
		/* state	*/	,4 ,JPI$_STATE	,&state	,0
		/* pid		*/	,4 ,JPI$_PID	,&pid	,0
		/* job type	*/	,4 ,JPI$_JOBTYPE,&jobtype,0
		/* processname	*/	,15,JPI$_PRCNAM	,processname,0
		/* terminal	*/	,7 ,JPI$_TERMINAL,terminal,0
		/* user name	*/	,12,JPI$_USERNAME,username,0
		/* curr. prior  */	,4 ,JPI$_PRI	,&pri	,0
		/* base priority*/	,4 ,JPI$_PRIB	,&prib	,0
		/* try to get img*/	,4 ,JPI$_CHAIN	,&itemlist_img,0
					};


user_flag = 0;
argv++;
strncpy(says_job_user," Job\0",5);
if (argc == 1)
	sleepytime=0;
    else if ((*argv[0] == 'u') || (*argv[0] == 'U'))
	{
	user_flag = 1;
	sleepytime = 0;
	strncpy(says_job_user,"User\0",5);
	}
    else if ((*argv[0] == 'h') || (*argv[0] == 'H'))
	{
	lib$erase_page(&1,&1);
	printf ("Instructions for program SYSTAT\n\n");
	printf ("	SYS		GIVES PID,PRIORITY,PROCNAME,TERMINAL");
		printf (",IMAGE NAME\n\n");
	printf ("	SYS n		SAME AS ABOVE REPEATED EVERY n ");
		printf ("SECONDS\n\n");
	printf ("	SYS U		GIVES PID,PRIORITY,USERNAME");
		printf (",TERMINAL,IMAGE NAME\n\n");
	printf ("	SYS H		THIS HELP MESSAGE\n\n");
	exit(SS$_NORMAL);
	}
    else
	sscanf(*argv,"%d",&sleepytime);

itemlist.endoflist = itemlist_img.endoflist = 0;
for(;;)
    {
    lib$erase_page(&1,&1);
    printf("  Pid     Pri  %s Name        Term                 Image Name",
	says_job_user);
    bool_status = TRUE;
    for (pidcontext = -1;bool_status == TRUE;)
	{
	save_context = pidcontext;
	getjpi_status = sys$getjpiw(EFN,&pidcontext,0,&itemlist,&iosb,0,0);
	if ((getjpi_status == SS$_NORMAL) || (getjpi_status == SS$_SUSPENDED))
		{
		print_flag = 0;
		if (terminal[0] != '\0')
			print_flag = 3;
	   	    else if (jobtype == JPI$K_BATCH)
			{
			print_flag = 2;
			if (owner != 0)
				strncpy(terminal,"BSUB \0",6);
			    else
				strncpy(terminal,"BATCH\0",6);
			}
		    else if(jobtype != JPI$K_DETACHED)
			{
			print_flag = 1;
			strncpy(terminal,"SUB  \0",6);
			}
		if (print_flag != 0)
			{
			image[0] = '\0';
			if (getjpi_status == SS$_SUSPENDED)
			    strcpy(image,"<<<<<<<<<< SUSPENDED JOB >>>>>>>>>>");
			  else
			    if (img[0] != '\0')
				{
				for (index=13;index <= 127;index++)
					{
					if (img[index] == ';')
						{
						img[index-4] = '\0';
						break;
						}
					}
				strcpy(image,strchr(img,'['));
				}
			if ((state == SCH$C_HIB) || (state == SCH$C_HIBO))
				strcpy (hibernate_ind,"*");
			    else
				strcpy (hibernate_ind," ");
			if (user_flag == 0)
				{
				printf("\n%08X%s%2d/%2d %-15s%6s %s",
			    	    pid,hibernate_ind,pri,prib,processname,
					terminal,image);
				}
			    else
				{
				printf("\n%08X%s%2d/%2d %-12s    %6s %s",
			    	    pid,hibernate_ind,pri,prib,username,
				    	terminal,image);
				}
			}
		}
	    else if (getjpi_status == SS$_NOMOREPROC)
		bool_status = FALSE;
	    else if (getjpi_status == SS$_NOPRIV)
		{
		printf("\n<<<<<<<<< WORLD PRIVILEGE REQUIRED >>>>>>>>>");
		sleepytime = 0;
		bool_status = FALSE;
		}
	    else
		{
		SIGNAL(getjpi_status);
		SIGNAL(iosb.io_s);
		SIGNAL(getjpi_status);
		sleepytime=0;
		bool_status = FALSE;
		}
	}
    if (sleepytime == 0)
	break;
    sleep(sleepytime);
    }	
}	
