$!	Time of Day Continuous Display
$ SAVERIFY = F$VERIFY(0)
$ TELL = "WRITE SYS$OUTPUT"
$!
$ IF F$GETDVI("TT:","TT_DECCRT") THEN GOTO BEGIN
$ TELL "Sorry, but DATIME will only work with VT100 or VT200 series terminals."
$ SAVERIFY = F$VERIFY(SAVERIFY)
$ EXIT
$!
$ BEGIN:
$!
$ ESC[0,8] = 27
$ TOP = ESC + "[H"
$ CLEAR = ESC + "[J"
$ DWID = ESC + "#6"
$ UDHI = ESC + "#3"
$ LDHI = ESC + "#4"
$ ERAEOL = ESC + "[K"
$ BELL[0,8] = 7
$!
$ TIMENOW = F$EXTRACT(12,5,F$TIME())
$ TELL "Time: ''TIMENOW'    " +-
	"(Enter +hh:mm to indicate a delta time)"
$ IF P1 .EQS. "" THEN GOTO ASKTIME
$ WHEN = P1
$ GOTO WHENEND
$ ASKTIME:
$ INQUIRE WHEN "Time to end"
$ IF WHEN .EQS. "" THEN GOTO DATIMEXIT
$ WHENEND:
$ TIMENOW = F$EXTRACT(12,5,F$TIME())
$ ENDTIME = F$EXTRACT(0,5,F$CVTIME(WHEN,"COMPARISON","TIME"))
$ IF ENDTIME .LES. TIMENOW THEN ENDTIME = TIMENOW
$ TELL "Procedure will terminate at ''ENDTIME'"
$ INQUIRE WHEN "Hit return if okay, enter new time to try again"
$ IF WHEN .NES. "" THEN GOTO WHENEND
$!
$ TERMINAL = F$EDIT(F$GETJPI("","TERMINAL"),"TRIM")
$ TERMLEN = F$LENGTH(TERMINAL)
$ USERNAME = F$EDIT(F$GETJPI("","USERNAME"),"TRIM")
$ NAMELEN = F$LENGTH(USERNAME)
$ NAMEFILLEN = (41 - NAMELEN)/2
$ NAMEFILL = F$FAO("!''NAMEFILLEN'AS","")
$ UIC = F$EDIT(F$GETJPI("","UIC"),"TRIM")
$ UICLEN = F$LENGTH(UIC)
$ TERUICFILLEN = 30 - (TERMLEN + UICLEN)
$ TERUICFILL = F$FAO("!''TERUICFILLEN'AS","")
$ DAY_OF_WEEK = F$EDIT(F$CVTIME(,,"WEEKDAY"),"TRIM")
$ DAYLEN = F$LENGTH(DAY_OF_WEEK)
$ DAYFILLEN = (41 - DAYLEN)/2
$ DAYFILL = F$FAO("!''DAYFILLEN'AS","")
$ DATE = F$EDIT(F$EXTRACT(0,11,F$TIME()),"TRIM")
$!
$ TELL "''TOP'''CLEAR'"
$ ON CONTROL_Y THEN GOTO DATIMEXIT
$ TELL "''ESC'[21;24r"
$!
$ GETIME:
$ TIME = F$EXTRACT(12,5,F$TIME())
$ MIN = F$EXTRACT(3,2,TIME)
$ CHIME = ""
$ IF MIN .EQS. "30" THEN CHIME = BELL
$ IF MIN .EQS. "00" THEN CHIME = BELL + BELL
$ TELL "''TOP'''ERAEOL'"
$ TELL "''DWID'Terminal: ''TERMINAL'''TERUICFILL'''UIC'"
$ TELL "''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL "''UDHI'''DAYFILL'''DAY_OF_WEEK'''ERAEOL'"
$ TELL "''LDHI'''DAYFILL'''DAY_OF_WEEK'''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL F$FAO("!15AS","") + "''UDHI'''DATE'''ERAEOL'"
$ TELL F$FAO("!15AS","") + "''LDHI'''DATE'''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL F$FAO("!18AS","") + "''UDHI'''TIME'''ERAEOL'"
$ TELL F$FAO("!18AS","") + "''LDHI'''TIME'''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL "''ERAEOL'"
$ TELL "''NAMEFILL'''NAMEFILL'''USERNAME'''USERNAME'''ERAEOL'"
$ TELL "''UDHI'''NAMEFILL'''USERNAME'''ERAEOL'"
$ TELL "''LDHI'''NAMEFILL'''USERNAME'''ERAEOL'"
$ TELL "''NAMEFILL'''NAMEFILL'''USERNAME'''USERNAME'''ERAEOL'"
$ TELL "''CHIME'"
$ TIMENOW = F$EXTRACT(0,5,F$CVTIME("","COMPARISON","TIME"))
$ IF TIMENOW .GES. ENDTIME THEN GOTO DATIMEXIT
$ WAITIME = 59 - F$INTEGER(F$CVTIME(,,"SECOND"))
$ WAIT 00:00:'WAITIME'.99
$ GOTO GETIME
$ DATIMEXIT:
$ TELL "''ESC'[1;24r"
$ TELL "''TOP'''CLEAR'''BELL'"
$ SAVERIFY = F$VERIFY(SAVERIFY)
$ EXIT
