$!
$!			Go down the directory tree
$!
$!		Down may be invoked the following ways:
$!	$ DOWN
$!	$ DOWN n	! Where n is the number of the subdirectory
$!	$ DOWN dir	! Where dir is the name of the subdirectory
$!
$ SAVERIFY = F$VERIFY(0)		! Save and turn off verification
$ DEFDIR = F$ENVIRONMENT("DEFAULT")	! Get current default directory
$ DIRCOUNT = 0
$ TELL = "WRITE SYS$OUTPUT"
$!
$ DIRNUM = -1
$ IF P1 .NES. "" THEN DIRNUM = F$INTEGER("0" + "''P1'")
$ IF DIRNUM .EQ. 0 THEN GOTO NAMEDIR	! DIRNUM is zero if P1 isn't an integer
$!					(maybe they passed us a directory name)
$!
$!	Find all of the subdirectories to this directory
$ FINDIR:
$ DIRCOUNT = DIRCOUNT + 1
$ FINDIR2:
$ DIR'DIRCOUNT' = F$SEARCH("*.DIR;1",1)
$ IF DIR'DIRCOUNT' .EQS. "" THEN GOTO NOMORE
$ IF .NOT. F$FILE_ATTRIBUTES(DIR'DIRCOUNT',"CTG") THEN GOTO FINDIR2
$ DIR'DIRCOUNT' = F$PARSE(DIR'DIRCOUNT',,,"NAME","SYNTAX_ONLY")
$ GOTO FINDIR
$!
$ NOMORE:
$!	DIRCOUNT is the number of subdirectories plus one
$ IF DIRCOUNT .GT. 2 THEN GOTO ASKDIR	! Ask which directory
$ IF DIRCOUNT .EQ. 2 THEN GOTO ONEDIR	! Only 1 subdirectory, so don't ask
$ TELL "%DOWN-F-NOSUBDIR, ''DEFDIR' has no subdirectories"
$ GOTO EXIT
$!
$ ONEDIR:				! Only one subdirectory, so
$ DIRNUM = 1				!  don't try to list or ask
$ GOTO CHANGEDIR			!  which one, just do it.
$!
$ ASKDIR:
$ IF P1 .NES. "" THEN GOTO CHECKDIR	! Passed us a number, see if it's valid
$!
$!	Display subdirectory choices
$ TELL ""
$ TELL "Directory   Directory"
$ TELL "Number      Name"
$ TELL "---------   ---------------------------------------"
$ DIRCNT = 1
$ SHOWDIR:
$ DIRNUMSTRING = F$FAO("!2UB",DIRCNT)
$ TELL "   ''DIRNUMSTRING'       " + DIR'DIRCNT'
$ DIRCNT = DIRCNT + 1
$ IF DIRCNT .LT. DIRCOUNT THEN GOTO SHOWDIR
$!	Ask which one they want
$ WHICHDIR:
$ TELL ""
$ INQUIRE DIRNUM "Directory number to set default to"
$ TELL ""
$!	Check to make sure there is a directory with that number
$ CHECKDIR:
$ IF DIRNUM .EQ. 0 THEN GOTO EXIT
$ IF (DIRNUM .LT. 1) .OR. (DIRNUM .GE. DIRCOUNT) THEN GOTO WHICHDIR
$ GOTO CHANGEDIR
$!	They may have passed us a directory name
$ NAMEDIR:
$ NEWDIR = P1
$ P1 = ""
$ NEWDIR = NEWDIR - "[" - "." - "]"
$ DIRCHECK = F$SEARCH("''NEWDIR'.DIR")	! Does this directory exist?
$ IF DIRCHECK .EQS. "" THEN GOTO FINDIR	! If not, go ask for one.
$ GOTO NAMED
$!	Finally get around to changing the directory
$ CHANGEDIR:
$ NEWDIR = DIR'DIRNUM'
$ NAMED:				! Entry point if a name was given
$ SET DEFAULT [.'NEWDIR']		! Set default to the subdirectory
$ TELL	"Old directory: ''DEFDIR'" + F$FAO("!/") +-
	"New directory: " + F$ENVIRONMENT("DEFAULT")
$ EXIT:
$ SAVERIFY = F$VERIFY(SAVERIFY)		! Restore verification
$ EXIT
