$!	RESTORE.COM - Restore a file from a backup saveset
$!
$!	P1	Files to be restored
$!	P2	Target directory
$!	P3	Tape drive to use
$!	P4	Saveset name if not first on tape
$!
$ IF P1 .EQS. "" THEN WRITE SYS$OUTPUT -
 "You must not include the original disk name in the file specification."
$ IF P1 .EQS. "" THEN INQUIRE P1 "File(s) to be restored from saveset"
$ IF P1 .EQS. "" THEN EXIT
$ IF P2 .EQS. "" THEN WRITE SYS$OUTPUT -
  "Remember to include the disk name in the target directory specification."
$ IF P2 .EQS. "" THEN INQUIRE P2 "Target directory"
$ IF P2 .EQS. "" THEN EXIT
$ IF P3 .EQS. "" THEN INQUIRE P3 "Tape drive"
$ IF P3 .EQS. "" THEN EXIT
$ P3 = P3 - ":" + ":"	! Make sure we have the device colon for tape drive
$ IF P4 .EQS. "" THEN INQUIRE P4 -
	"Saveset name (only required if not the first one on the tape)"
$ SAVERIFY = F$VERIFY(1)
$ ALLOCATE 'P3'
$ MOUNT/FOREIGN 'P3'
$ DEFINE/USER_MODE SYS$INPUT SYS$COMMAND
$ BACKUP/LOG/BUFF=5 'P3''P4'/SELECT=('P1') -
	'P2'/OWNER=PARENT
$ DISMOUNT 'P3'
$ DEALLOCATE 'P3'
$ SAVERIFY = F$VERIFY(SAVERIFY)
