100	option size=integer long
	record quad
		long	high_long
		long	low_long
	end record quad
	map (play_rec)				&
		string	H_player = 10%,		&
		quad	H_play_time,		&
		byte	H_winner,		&
		byte	H_15(4%),		&
		byte	H_pairs(4%),		&
		byte	H_3runs(4%),		&
		byte	H_4runs(4%),		&
		byte	H_5runs(4%),		&
		byte	H_nobs(4%),		&
		byte	H_flushes(4%),		&
		byte	H_hands(4%),		&
		byte	H_skunks(2%),		&
		byte	H_pegpoints(2%)

	map (play_rec)  ! Key map.  We need this since BASIC 2.4 can't have &
			! QUAD in the key.	&
		string	key_0 = 10%,		&
		string	key_1 = 4%

200	open "games:play_history.dat" as file #2%	&
		, indexed fixed	   	&
		, map play_rec		&
		, allow modify	    	&
		, access read
	declare integer total_wins, total_games, total_my_skunks,	&
		       	total_your_skunks,				&
			grand_wins, grand_games, grand_my_skunks,	&
		       	grand_your_skunks,				&
		string	save_name

300	restore #2%, key #0%

400	on error goto 19000
	total_games = 1%

500	get #2
	goto 600 if save_name<>H_player
550 	save_name = H_player
	total_games = total_games+1%
	total_wins = total_wins+1% if H_winner=2%
	total_my_skunks = total_my_skunks+H_skunks(2%) if H_skunks(2%)=1%
	total_your_skunks = total_your_skunks+H_skunks(1%) if H_skunks(1%)=1%
	goto 500

600	print save_name;":"
 	print "Out of";total_games;", you have won";total_wins;	&
		" for a percentage of";(real(total_wins)/total_games)*100;"."
	print "You have skunked me";total_my_skunks;".  I have skunked you";&
		total_your_skunks
	print
	grand_wins = grand_wins+total_wins
	grand_games = grand_games+total_games
	grand_my_skunks = grand_my_skunks+total_my_skunks
	grand_your_skunks = grand_your_skunks+total_your_skunks
	total_wins, total_games, total_my_skunks,	&
		total_your_skunks = 0
	goto 550 if err<>11
	goto 32767

700	close #2%

18999	goto 32767

19000	if err=11 and erl=500 then
		resume 600
	end if

32767	print "Grand totals:"
 	print "Out of";grand_games;", you have won";grand_wins;	&
		" for a percentage of";(real(grand_wins)/grand_games)*100;"."
	print "You have skunked me";grand_my_skunks;".  I have skunked you";&
		grand_your_skunks

	end
