$!
$!	This program was developed by William J. Baker, Jr.
$!	While under contract to Ford Aerospace & Communications Corp.
$!	October 21, 1985.
$!
$!	We normally submit this command file before incremental backups.
$!
$	SET NOON
$!
$!	Here we define the symbol SETUSER.  The program SETUSR will
$!	change the USERNAME of the current process and set a symbol
$!	NEWUIC.  The command file SETUSR uses the NEWUIC symbol to
$!	perform a SET UIC command.  This program requires SYSPRV,
$!	and CMKRNL priveleges.
$!
$	DEFUSER = F$GETJPI("","USERNAME")
$!
$	SETUSER :== @SYS_LOGIN:SETUSR
$!
$!	Here we open the file which will provide the USERNAMES for
$!	compression of mail files.  This file has the same structure
$!	as a mailing list, one username per line.  You mail in fact
$!	wish to use your system wide mailing list if you have 
$!	established one.
$!
$	OPEN/READ/ERR=OPN_ERR/END_OF=EXIT CMPLIST SYS_AGENDA:MANAGER.LIS
$!
$ START:
$!
$!	Here we read the username of the mail file to be compressed.
$!	Note that we must assume that the names in the file manager.lis
$!	are accurate.  If they are not, the only consequence is that
$!	the previous user is maintained and compressed again.  The 
$!	next read of the file manager.lis will alleviate this problem.
$!
$	READ/END_OF=EXIT CMPLIST NXTACC
$!
$	SETUSER 'NXTACC'
$!
$	MAIL
COMPRESS
EXIT
$!
$	GOTO START
$!
$ EXIT:
$!
$	CLOSE CMPLIST
$!
$!	Here we submit a command file that will globally delete all
$!	files named mail.old from the disk sets.  It is recommened
$!	that this job be submitted to run after the incremental backup
$!	has completed to insure the mail.old files are recoverable.
$!
$	SETUSER 'DEFUSER'
$!
$	SUBMIT/QUE=AGENDA/LOG=ROOT_SYSMAN:[LOG]/AFTER=05:30 -
			SYS_AGENDA:DELOLDMAIL
$!
$ OPN_ERR:
$!
$	EXIT
