      PROGRAM DEFINESYM
C*******************************************************************************
C **  PROGRAM AUTHOR:       ELAINE FRAHLMAN
C
C **  PROGRAM DESCRIPTION:  DEFINESYM.FOR DEFINES SYMBOLS AND LOGICALS
C **                        FOR USERS LOGGING IN.
C
C **  DEFINESYM.FOR DICTIONARY
C **  ------------------------
C
C **  DEF                   DEFINITION OF A SYMBOL OR A LOGICAL
          CHARACTER DEF(500)*132, DEF_SEND*132
C **  I                     COUNTER FOR DO LOOP
          INTEGER   I
C **  ID                    INDICATOR FOR THE TABLE WHICH WILL CONTAIN
C **                        THE DEFINED SYMBOL
          INTEGER   ID
C **  LENGTH1               THE LENGTH OF THE SYMBOL OR LOGICAL
          INTEGER   LENGTH1(500)
C **  LENGTH2               THE LENGTH OF THE DEFINITION
          INTEGER   LENGTH2(500)
C **  SYM                   SYMBOL OR LOGICAL NAME
          CHARACTER SYM(500)*32, SYM_SEND*32
C **  TOTAL                 TOTAL NUMBER OF SYMBOLS AND LOGICALS
          INTEGER   TOTAL
C **  STYPE                  INDICATES IF THE DEFINITION IS A SYMBOL
C **                        OR A LOGICAL
          CHARACTER STYPE(500)*1
C **  PROC_NAME	             NEW PROCESS NAME
C **
          CHARACTER PROC_NAME*16
C **  LEN_NAME               LENGTH OF PROCESS NAME
C **
          INTEGER   LEN_NAME
C*******************************************************************************
C 
C **  INDICATE THE VARIABLES: STYPE, TOTAL, SYM, DEF, LENGTH1 AND LENGTH2 
C **  ARE TO BE SHARED IN COMMON.
C
      COMMON  /SYM_DATA/ TOTAL, LENGTH1, LENGTH2, STYPE, SYM, DEF
C
C **  INITIALIZE VARIABLES
C
      ID = 2
C
C **  DEFINE SYMBOLS AND LOGICALS FROM COMMON
C
      DO 100 I = 1,TOTAL
C 
C **    IF STYPE IS EQUAL TO A SYMBOL THEN
C
	J = LENGTH1(I)
	K = LENGTH2(I)
	DEF_SEND = DEF(I)
	SYM_SEND = SYM(I)

        IF (STYPE(I) .EQ. 'S') THEN
C
C **      DEFINE THE SYMBOL
C
          CALL LIB$SET_SYMBOL( SYM_SEND(1:J), DEF_SEND(1:K), ID)
C
C **    ELSE IF STYPE IS EQUAL TO A LOGICAL THEN
C 
	ELSE 
C
C **      DEFINE THE LOGICAL
C
          CALL LIB$SET_LOGICAL( SYM_SEND(1:J), DEF_SEND(1:K) )
C
C **    END OF TYPE CONDITION
C
        ENDIF
C
100   CONTINUE
C
C **    GET PROCESS NAME
C
      CALL PROCNAME( PROC_NAME, LEN_NAME )
C
C **    GET PROCESS NAME
C
      CALL SYS$SETPRN( PROC_NAME(1:LEN_NAME) )
C
      END     
