      OPTIONS/EXTEND
      SUBROUTINE PROCNAME(PROC_NAME, LEN_NAME)
C
      INCLUDE '($JPIDEF)'
      INCLUDE '($SSDEF)'
C
C DEFINE JPI STRUCTURE
C
      STRUCTURE /ITMLIST/			! JPI ITEM LIST
         UNION					! WE WILL HAVE 11 ITEMS
            MAP					! TO PROMPT FOR.
               INTEGER*2 BUFLEN			! 
               INTEGER*2 CODE			! THE TWELFTH ITEM IS THE
               INTEGER*4 BUFADR			! END CODE.
               INTEGER*4 RETLENADR		!
            END MAP
            MAP
               INTEGER*4 END_LIST
            END MAP
         END UNION
      END STRUCTURE
      RECORD /ITMLIST/ JPILIST(4)
C
C DEFINE THE JPI DATA AREA WHICH IS RETURNED
C
      CHARACTER*14    INFO_USERNAME
      CHARACTER*8     INFO_TERMINAL
      INTEGER*4       INFO_TERMINAL_LENGTH, INFO_USERNAME_LENGTH
      INTEGER*4	      LENUSER, LENTERM, LEN_NAME, INFO_MODE
C
C DEFINE MISCELLANEOUS VARIABLES
C
      CHARACTER*16    PROC_NAME
      INTEGER*4       JPIPID /JPI$_CHAIN/, SYS$GETJPIW
C
C-----------------------------------------------------------------------
C
C SETUP JPI BUFFER
C
      JPILIST(01).BUFLEN      = 8
      JPILIST(01).CODE        = (JPI$_TERMINAL)
      JPILIST(01).BUFADR      = %LOC(INFO_TERMINAL)
      JPILIST(01).RETLENADR   = %LOC(INFO_TERMINAL_LENGTH)
C
      JPILIST(02).BUFLEN      = 14
      JPILIST(02).CODE        = (JPI$_USERNAME)
      JPILIST(02).BUFADR      = %LOC(INFO_USERNAME)
      JPILIST(02).RETLENADR   = %LOC(INFO_USERNAME_LENGTH)
C
      JPILIST(03).BUFLEN      = 4
      JPILIST(03).CODE        = (JPI$_MODE)
      JPILIST(03).BUFADR      = %LOC(INFO_MODE)
      JPILIST(03).RETLENADR   = %LOC(INFO_MODE_LENGTH)
C
      JPILIST(04).END_LIST   = 0
C
C-----------------------------------------------------------------------
C
C GET TERMINAL
C
100      JPI_RETCODE = SYS$GETJPIW (,,,JPILIST,,,)
C
         IF (JPI_RETCODE.NE.SS$_NORMAL)
     *      CALL SYS$EXIT(%VAL(JPI_RETCODE))
C
      IF (INFO_MODE .NE. 3) RETURN
C
      LenTerm = INFO_TERMINAL_LENGTH
C
      Lenuser = INFO_USERNAME_LENGTH
C
      CALL STR$TRIM(INFO_TERMINAL, INFO_TERMINAL(1:LenTerm), LenTerm)
C
      CALL STR$TRIM(INFO_USERNAME, INFO_USERNAME(1:Lenuser), Lenuser)
C
      PROC_NAME = '                '
C
      LEN_NAME = LenUser + 5
      IF (LEN_NAME .GT. 16) THEN
          Len_Name = 16
          LenUser  = 11
      ENDIF
C
      IF (INFO_TERMINAL(2:2) .EQ. 'X') THEN
C
         PROC_NAME(1:3) = INFO_TERMINAL(2:4)
         PROC_NAME(4:4) = '_'
         PROC_NAME(5:Len_Name) = INFO_USERNAME(1:LenUser)
C
      ELSE
C
         PROC_NAME(1:1) = INFO_TERMINAL(1:1)
         PROC_NAME(2:3) = INFO_TERMINAL((LenTerm-2):(LenTerm)-1)
         PROC_NAME(4:4) = '_'
         PROC_NAME(5:Len_Name) = INFO_USERNAME(1:LenUser)
C
      ENDIF
C
      RETURN
      END
