$!
$!============================================================================
$!
$!	COMMAND FILE FOR SUBMITTING REMOTE JOBS WITH PARAMETERS.
$!
$!	P1	= NODE::COMMAND.FILE
$!			WHERE NODE:: IS NODE WHERE JOB IS TO BE SUBMITTED.
$!			WHERE COMMAND.FILE IS THE PROCEDURE TO BE SUBMITTED.
$!
$!	P2-P8	= PARAMETERS FOR JOB BEING SUBMITTED ON REMOTE NODE.
$!				  MUST BE ENCLOSED IN QUOTES.
$!
$!============================================================================
$!
$	SET NOON
$!
$	CNT = 1
$!
$!	FIND NODE NAME FOR REMOTE JOB SUBMITTAL
$!
$ LOOP:
$!
$	IF P'CNT' .EQS. "" THEN GOTO NONODE
$!
$	LOC_COL = F$LOCATE("::",P'CNT')
$	LEN_PAR = F$LENGTH(P'CNT')
$!
$	IF LOC_COL.NE. LEN_PAR THEN GOTO FNDNODE
$!
$	CNT = CNT + 1
$	IF CNT .GT. 8 THEN GOTO NONODE
$!
$	GOTO LOOP
$!
$ FNDNODE:
$!
$	NODENAM = F$EXTRACT(0,LOC_COL,P'CNT')
$!
$	PARAM = ""
$	KNT = 0
$!
$!	PARSE PARAMETERS INTO A SINGLE PARAMETER SYMBOL.
$!
$ PARLOOP:
$!
$	KNT = KNT + 1
$	IF KNT .GT. 8 THEN GOTO EXIT_PAR
$!
$	IF KNT .EQ. CNT THEN GOTO PARLOOP
$	IF P'KNT' .EQS. "" THEN GOTO EXIT_PAR
$!
$	IF F$EXTRACT(0,1,P'KNT') .NES. "/" THEN P'KNT' = "/" + P'KNT'
$!
$	PARAM = PARAM + P'KNT'
$!
$	GOTO PARLOOP
$!
$!	SUBMIT THE REMOTE JOB, APPEND FILE TYPE ".COM" TO THE PROCEDURE SYMBOL.
$!
$ EXIT_PAR:
$!
$	LEN_LOC = F$LOCATE(".COM",P'CNT')
$	IF LEN_PAR .EQ. LEN_LOC THEN P'CNT' = P'CNT' + ".COM"
$!
$	COMFLE = P'CNT' - "''NODENAM'::"
$!
$!	@directory:TELL  'NODENAM' SUBMIT 'COMFLE' 'PARAM'
$!
$	@FORDUTIL:NMPRUN 'NODENAM' SUBMIT 'COMFLE' 'PARAM'
$!
$	EXIT
$!
$ NONODE:
$!
$	WRITE SYS$OUTPUT "NO NODE NAME FOUND"
$!
$	SHOW SYMBOL/LOCAL
$!
$	EXIT
