$!---------------------------------------------------------------------*
$!  W H O I S :                                                        |
$!---------------------------------------------------------------------*
$!  Command:  WHOIS                    Source File:  WHOIS.COM
$!  Purpose:  To Search List of Authorized VAX/VMS Users for a String.
$!
$!
$	SET NOON 
$	SET NOVERIFY
$!
$	IF F$MODE() .NES. "NETWORK" THEN GOTO BEGIN
$!
$	DEFINE/USER SYS$OUTPUT SYS$NET
$!
$	GOTO NETWORK
$!
$ BEGIN:
$!
$	IF P1 .EQS. "" THEN INQUIRE P1 "Enter string to search user list for"
$!
$	USRNODE = F$LOCATE("::",P1)
$	USRLEN  = F$LENGTH(P1)
$	IF USRNODE .NE. USRLEN THEN GOTO GETNET
$!
$ NETWORK:
$!
$	SRCHUAF :== $FORDUTIL:WHOISUAF
$!
$	IF P2 .EQS. "/OUT" THEN ASSIGN WHO.OUT SYS$OUTPUT
$	SRCHUAF 'P1'
$	IF P2 .EQS. "/OUT" THEN DEASSIGN SYS$OUTPUT
$!
$	EXIT
$!
$ GETNET:
$!
$	USRNAME = F$EXTRACT(USRNODE+2,USRLEN,P1)
$	USRLEN  = F$LENGTH(USRNAME)
$	IF USRLEN .GT. 6 THEN USRLEN = 6
$!
$       USRNAME = F$EXTRACT(0,USRLEN,USRNAME)
$	USRNAME = F$EDIT(USRNAME,"COMPRESS,TRIM")
$!
$	NODENAM = F$EXTRACT(0,USRNODE,P1)
$	NODENAM = F$EDIT(NODENAM,"COMPRESS,TRIM")
$!
$	IF NODENAM .EQS. "HMF"		THEN GOTO DONET
$	IF NODENAM .EQS. "EPLAB"	THEN GOTO DONET
$	IF NODENAM .EQS. "MEDIC2"	THEN GOTO DONET
$	IF NODENAM .EQS. "PROFS"	THEN GOTO PROFS_NAMES
$	IF NODENAM .EQS. "SSW"		THEN GOTO SSW_NAMES
$!
$	BLDFLE := 'NODENAM'"""""::USERLIST.LIS
$	CHFLE = F$SEARCH(BLDFLE)
$	IF CHFLE .EQS. "" THEN GOTO NOFILE
$!
$	IF USRNAME .EQS. "" THEN TYPE/PAGE 'BLDFLE'
$	IF USRNAME .NES. "" THEN SEARCH 'BLDFLE' 'USRNAME'
$!
$	EXIT
$!
$ DONET:
$!
$	TYPE 'NODENAM'""::"TASK=WHOIS ''USRNAME'"
$!
$	EXIT
$!
$ NOFILE:
$!
$	WRITE SYS$OUTPUT "	"
$	WRITE SYS$OUTPUT "NO USERLIST ON REMOTE NODE:  ''NODENAM'"
$!
$	WRITE SYS$OUTPUT "	"
$	WRITE SYS$OUTPUT "FIRST TRY FINGER PROGRAM AS AN ALTERNATIVE:  (''NODENAM')"
$	WRITE SYS$OUTPUT "	"
$!
$	IF USRNAME .EQS. "" THEN WHOALL 'NODENAM'::"%"
$	IF USRNAME .NES. "" THEN WHOALL 'NODENAM'::'USRNAME'
$!
$!
$	BLDFLE := 'NODENAM'"""""::TELL.COM
$	CHFLE = ""
$	CHFLE = F$SEARCH(BLDFLE)
$	IF CHFLE .EQS. "" THEN GOTO NOTELL
$!
$	WRITE SYS$OUTPUT "	"
$	WRITE SYS$OUTPUT "GOING TO SHOW CURRENTLY ACTIVE USERS ON NODE ''NODENAM'"
$	WRITE SYS$OUTPUT "	"
$!
$	NMP "''NODENAM'" "SHOW USERS"
$!
$ NOTELL:
$!
$	EXIT
$!
$ PROFS_NAMES:
$!
$	IF USRNAME .EQS. "" THEN GOTO PAGE_PROFS
$!
$	TYPE SYS$INPUT

 NICKNAME       NODENAME USERID         FULL NAME
_________       ________ _______        _______________
$!
$	SEARCH LIB3:[NETMGR]NICKNAME.DAT "''usrname'"
$!
$	EXIT
$!
$ PAGE_PROFS:
$!
$	 WRITE SYS$OUTPUT "[1;1H[2J"
$	 WRITE SYS$OUTPUT "[4;24r"
$	 WRITE SYS$OUTPUT -
"[1;1H NICKNAME       NODENAME USERID         FULL NAME"
$	 WRITE SYS$OUTPUT -
"_________       ________ _______        _______________"
$!
$	PAGE	LIB3:[NETMGR]NICKNAME.DAT	-T	-R	-P:20
$!
$	INQUIRE DONE "Press RETURN to continue"
$!
$	WRITE SYS$OUTPUT "[1;24r"
$	WRITE SYS$OUTPUT "[24;1H"
$	WRITE SYS$OUTPUT " "
$!
$	EXIT
$!
$ SSW_NAMES:
$!
$	IF USRNAME .EQS. "" THEN GOTO PAGE_SSW
$!
$	TYPE SYS$INPUT

 NICKNAME       NODENAME USERID         FULL NAME
_________       ________ _______        _______________
$!
$	SEARCH LIB3:[NETMGR]SSWNICKNAME.DAT "''usrname'"
$!
$	EXIT
$!
$ PAGE_SSW:
$!
$	 WRITE SYS$OUTPUT "[1;1H[2J"
$	 WRITE SYS$OUTPUT "[4;24r"
$	 WRITE SYS$OUTPUT -
"[1;1H NICKNAME       NODENAME USERID         FULL NAME"
$	 WRITE SYS$OUTPUT -
"_________       ________ _______        _______________"
$!
$	PAGE	LIB3:[NETMGR]SSWNICKNAME.DAT	-T	-R	-P:20
$!
$	INQUIRE DONE "Press RETURN to continue"
$!
$	WRITE SYS$OUTPUT "[1;24r"
$	WRITE SYS$OUTPUT "[24;1H"
$	WRITE SYS$OUTPUT " "
$!
$	EXIT
