	SUBROUTINE AD_CHNL_DEF( DEVICE_ID, NCHNL, A, G )
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  DEFINES CHANNELS TO A/D CONVERTER.
C **                        
C
C **  ADDA_CHNLDEF.FOR
C     -----------------------
C
	INTEGER*4	STATUS, NCHNL, DEVICE_ID, G(16), A(16)
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
C
	IF (NCHNL .EQ. 1) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 2) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 3) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3))
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3))
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 4) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 5) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 6) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 7) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 8) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 9) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 10) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 11) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10), A(11) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10), G(11) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 12) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10), A(11), A(12) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10), G(11), G(12) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 13) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10), A(11), A(12), A(13) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10), G(11), G(12), G(13) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 14) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10), A(11), A(12), A(13), A(14) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10), G(11), G(12), G(13), G(14) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 15) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10), A(11), A(12), A(13), A(14), A(15) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10), G(11), G(12), G(13), G(14), G(15) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 16) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_CHAN, NCHNL, A(1), A(2), A(3), A(4), A(5), A(6),
     &					A(7), A(8), A(9), A(10), A(11), A(12), A(13), A(14), A(15), A(16) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_AD_GAIN, NCHNL, G(1), G(2), G(3), G(4), G(5), G(6),
     &					G(7), G(8), G(9), G(10), G(11), G(12), G(13), G(14), G(15), G(16) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ENDIF
C
	RETURN
	END
C
C
	SUBROUTINE DA_CHNL_DEF( DEVICE_ID, NCHNL, D )
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  DEFINES CHANNELS TO D/A CONVERTER.
C **                        
C
C **  ADDA_CHNLDEF.FOR
C     -----------------------
C
	INTEGER*4	STATUS, NCHNL, DEVICE_ID, D(NCHNL)
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	IF (NCHNL .EQ. 1) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_DA_CHAN, NCHNL, D(1))
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ELSE IF (NCHNL .EQ. 2) THEN
C
		STATUS = LIO$SET_I( DEVICE_ID, LIO$K_DA_CHAN, NCHNL, D(1), D(2) )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	ENDIF
C
	RETURN
	END
