	SUBROUTINE WRITE_CONFIG( MYDEV )
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  WRITES A DATA CONFIGURATION FILE.
C ** 
C
C **  WRITE_CONFIG
C     ------------
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	WRITE(11,100) DEVICE(MYDEV)
100	FORMAT('%AX=',A4)
C
	IF (USE_CLOCK) THEN
		WRITE(11,700)
700	FORMAT('%CL=T')
	ELSE
		WRITE(11,750)
750	FORMAT('%CL=F')
	ENDIF
C
	IF (MYDEV .EQ. 1) THEN
		IF (AD_CLOCK1) THEN
			WRITE(11,800)
800			FORMAT('%AC=T')
		ELSE
			WRITE(11,850)
850			FORMAT('%AC=F')
		ENDIF
	ELSE
		IF (AD_CLOCK1) THEN
			WRITE(11,800)
		ELSE
			WRITE(11,850)
		ENDIF
	ENDIF
C
	WRITE(11,200) CLK_SOURCE, CLK_DIVIDER, CLK_RATE
200	FORMAT('%SR=',I1,2X,'%DI=',I5,2X,'%RT=',F12.2)
C
	WRITE(11,400) AD_NUMBR(MYDEV), DA_NUMBR(MYDEV), TYP_TRGGR(MYDEV)
400	FORMAT('%AN=',I2,2X,'%DN=',I1,2X,'%TR=',I1)
C
	IF (AD_NUMBR(MYDEV) .NE. 0) WRITE(11,500) ( AD_CHNL(MYDEV,II).CHAN_NUM,
     &			AD_CHNL(MYDEV,II).CHAN_GAIN,
     &			AD_CHNL(MYDEV,II).CHAN_DSCR, II=1,AD_NUMBR(MYDEV))
500	FORMAT('%AD=',I2,2X,'%GA=',I6,2X,'%DE=',A72)
C
C
	IF (DA_NUMBR(MYDEV) .NE. 0) WRITE(11,600) ( DA_CHNL(MYDEV,II).CHAN_NUM,
     &			DA_CHNL(MYDEV,II).CHAN_DEVICE,
     &			DA_CHNL(MYDEV,II).CHAN_FROM,
     &			DA_CHNL(MYDEV,II).CHAN_DSCR, II=1,2)
600	FORMAT('%DA=',I2,2X,'%DV=',I1,2X,'%FM=',I2,2X,'%DE=',A72)
C
	RETURN
	END
