C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  DEFINES AN AREA OF SHARED COMMON FOR USE BY
C **                        A/D AND D/A DATA ACQUISITION PROGRAMS.
C
C **  ADDA_SHR.FOR DICTIONARY
C     -----------------------
C
	STRUCTURE /AD_LIST/
		UNION
			MAP
				INTEGER*4	CHAN_NUM
				INTEGER*4	CHAN_GAIN
				CHARACTER*72	CHAN_DSCR
			END MAP
		END UNION
	END STRUCTURE
C
	STRUCTURE /DA_LIST/
		UNION
			MAP
				INTEGER*4	CHAN_NUM
				CHARACTER*72	CHAN_DSCR
				INTEGER*4	CHAN_DEVICE
				INTEGER*4	CHAN_FROM
			END MAP
		END UNION
	END STRUCTURE
C
	RECORD /AD_LIST/ AD_CHNL(2,16)
C
	RECORD /DA_LIST/ DA_CHNL(2,2)
C
	LOGICAL		START_STOP, USE_CLOCK, AD_CLOCK1, AD_CLOCK2
	LOGICAL		AD1_CLK, AD2_CLK, AD1_SET, AD2_SET, USE_LOGICAL
C
	INTEGER*4	AD_NUMBR(2), DA_NUMBR(2)
C
	INTEGER*4	TYP_TRGGR(2)
	INTEGER*4	CLK_SOURCE
	INTEGER*4	CLK_DIVIDER
	REAL*4		CLK_RATE
C
	INTEGER*4	ADDA_ID(2)
	INTEGER*4	CLOCK_ID
C
	INTEGER*4	PRV_PNTR1, CUR_PNTR1, AD1_PNTR
	INTEGER*4	PRV_PNTR2, CUR_PNTR2, AD2_PNTR
	INTEGER*4	CUR_TIME
C
	INTEGER*4	NEWOPT
C
	CHARACTER*4	DEVICE(2)
C
	INTEGER*2	AD1_DATA1(120,16), AD1_DATA2(120,16)
	INTEGER*2	AD2_DATA1(120,16), AD2_DATA2(120,16)
	INTEGER*4	AD1_TIME1(120),    AD1_TIME2(120)
	INTEGER*4	AD2_TIME1(120),    AD2_TIME2(120)
C
	INTEGER*2	AD1_BUFFER(16), DA1_BUFFER(2)
	INTEGER*2	AD2_BUFFER(16), DA2_BUFFER(2)
	INTEGER*4	AD1_BUFFLEN, AD2_BUFFLEN
C
C***************************************************************************
C 
C **  DECLARES THE SHARED COMMON.
C
	COMMON /ADDA_DATA/	AD_CHNL, DA_CHNL, DEVICE, AD2_TIME2,
     &				AD1_DATA1, AD1_DATA2, AD1_BUFFER,
     &				AD2_DATA1, AD2_DATA2, AD2_BUFFER, 
     &				DA1_BUFFER, DA2_BUFFER, CUR_TIME,
     &				AD1_TIME1, AD1_TIME2, AD2_TIME1
C
	COMMON /ADDA_PNTR/	ADDA_ID, CLOCK_ID, PRV_PNTR1, CUR_PNTR1,
     &				TYP_TRGGR, CLK_SOURCE, CLK_DIVIDER,
     &				PRV_PNTR2, CUR_PNTR2, AD1_PNTR, AD2_PNTR
C
	COMMON /ADDA_LOGIC/	USE_CLOCK, AD_CLOCK1, AD_CLOCK2, START_STOP,
     &				AD1_CLK, AD2_CLK, AD1_SET, AD2_SET, USE_LOGICAL
C
	COMMON /ADDA_NMBR/	CLK_RATE, AD_NUMBR, DA_NUMBR, AD1_BUFFLEN,
     &				AD2_BUFFLEN, NEWOPT
C
