	PROGRAM ADDA_FILE
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  FOR FILING OF DATA GATHERED BY ADDA_MAINIO.
C **                        
C
C **  ADDA_FILE.FOR
C     -----------------------
C
	STRUCTURE /FILE_LIST/
		UNION
			MAP
				INTEGER*2	DATA(120,16)
				INTEGER*4	TIME(120)
			END MAP
		END UNION
	END STRUCTURE
	RECORD /FILE_LIST/	FILE_BUFFER
C
	INTEGER*2	AD_CHAN
	INTEGER*4	OPTION, AD_LUN, STATUS
	CHARACTER*64	ADDA_CONTROL, AD_FILE, AD_CONFIG, AD_IN
C
	INCLUDE 'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC/LIST'
C
	CALL LIB$GET_FOREIGN(AD_IN,'String: ',LEN_AD)
	CALL STR$TRIM(AD_IN, AD_IN(1:LEN_AD), LEN_AD)
C
	IF (AD_IN(1:LEN_AD) .EQ. DEVICE(1)(1:LEN_AD) ) THEN
		MYDEV = 1
	ELSE IF (AD_IN(1:LEN_AD) .EQ. DEVICE(2)(1:LEN_AD)) THEN
		MYDEV = 2
	ENDIF

	ADDA_CONTROL = AD_IN(1:LEN_AD)//'_FILER'
	AD_FILE	     = AD_IN(1:LEN_AD)//'_DATA'
	AD_CONFIG    = AD_IN(1:LEN_AD)//'_CONFIG'
C
	LEN_CTRL = LEN_AD + 6
C
	TYPE *, AD_FILE(1:9)
	TYPE *, AD_CONFIG(1:11)
	TYPE *, ADDA_CONTROL(1:LEN_CTRL)
C
	STATUS = SYS$CREMBX( %VAL(1), AD_CHAN, , , , , ADDA_CONTROL(1:LEN_CTRL) )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	STATUS = LIB$GET_LUN( AD_LUN )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	OPEN( UNIT = AD_LUN, FILE=ADDA_CONTROL(1:LEN_CTRL),
     &		CARRIAGECONTROL = 'LIST', STATUS = 'NEW' )
C
	IFL = 0
C
1000	IF (IFL .EQ. 9) GOTO 5000
C
	IF (IFL .EQ. 3) CLOSE(10)
C
	OPEN( UNIT = 10, FILE=AD_FILE,
     &		STATUS = 'NEW', FORM='UNFORMATTED' )
	OPEN( UNIT = 11, FILE=AD_CONFIG, FORM='FORMATTED',
     &		STATUS = 'NEW', CARRIAGECONTROL = 'LIST' )
C
C		WRITE CONFIGURATIONS FOR AXx0: SETTINGS.
C
	CALL WRITE_CONFIG( MYDEV )
C
	CLOSE(11)
C
2000	READ(AD_LUN,50) IPRV, IFL
50	FORMAT(2I1)
C
	IF (IFL .GT. 2) GOTO 1000
C
	IF (MYDEV .NE. IFL) GOTO 3000
C
	IF (IFL .EQ. 1) THEN
C
		IF (IPRV .EQ. 1) THEN
			DO II = 1,120
				DO KK = 1,16
					FILE_BUFFER.DATA(II,KK) = AD1_DATA1(II,KK)
				ENDDO
				FILE_BUFFER.TIME(II) = AD1_TIME1(II)
			ENDDO
C
		ELSE IF (IPRV .EQ. 2) THEN
			DO II = 1,120
				DO KK = 1,16
					FILE_BUFFER.DATA(II,KK) = AD1_DATA2(II,KK)
				ENDDO
				FILE_BUFFER.TIME(II) = AD1_TIME2(II)
			ENDDO
C
		ENDIF
C
	ELSE IF (IFL .EQ. 2) THEN
C
		IF (IPRV .EQ. 1) THEN
			DO II = 1,120
				DO KK = 1,16
					FILE_BUFFER.DATA(II,KK) = AD2_DATA1(II,KK)
				ENDDO
				FILE_BUFFER.TIME(II) = AD2_TIME1(II)
			ENDDO
C
		ELSE IF (IPRV .EQ. 2) THEN
			DO II = 1,120
				DO KK = 1,16
					FILE_BUFFER.DATA(II,KK) = AD2_DATA2(II,KK)
				ENDDO
				FILE_BUFFER.TIME(II) = AD2_TIME2(II)
			ENDDO
C
		ENDIF
C
	ENDIF
C
3000	WRITE(AD_LUN,50) -IPRV
C
	IF (MYDEV .NE. IFL) GOTO 2000
C
	WRITE(10) FILE_BUFFER
C
	GOTO 2000
C
5000	CLOSE(UNIT=AD_LUN)
	CLOSE(10)
C
	STATUS = SYS$DELMBX( %VAL(AD_CHAN) )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	STATUS = SYS$DASSGN( %VAL(AD_CHAN) )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	END
