	PROGRAM	ADDA_LOADER
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  READS A DATA CONFIGURATION FILE.
C ** 
C
C **  ADDA_LOADER
C     ------------
C
	CHARACTER*99	DLINE, AD_IN
	LOGICAL		FIRSTLINE
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	FIRSTLINE = .TRUE.
	II = 0
	JJ = 0
	KK = 0
C
	CALL LIB$GET_FOREIGN(AD_IN,'String: ',LEN_AD)
	CALL STR$TRIM(AD_IN, AD_IN(1:LEN_AD), LEN_AD)
C
	DECODE(LEN_AD,750,AD_IN) MYDEV
750	FORMAT(I<LEN_AD>)
C
	OPEN( UNIT=8, FILE='ADDA_LOAD_FILE', CARRIAGECONTROL = 'LIST',
     &		TYPE='OLD', FORM='FORMATTED')
C
	READ(8,50,IOSTAT=ISTAT) LLEN, DLINE
50	FORMAT(Q,A98)
C
	DO WHILE (ISTAT .EQ. 0)
C
		IF (DLINE(1:3) .EQ. '%AX') THEN
C
			IF (FIRSTLINE) FIRSTLINE = .FALSE.
			DEVICE(MYDEV) = DLINE(5:8)
			KK = KK + 1
C
		ELSE IF ((DLINE(1:3) .EQ. '%SR') .AND. (.NOT. FIRSTLINE)) THEN
C
			DECODE(LLEN,150,DLINE) CLK_SOURCE, CLK_DIVIDER, CLK_RATE
150			FORMAT(4X,I1,6X,I5,6X,F12.2)
			KK = KK + 1
C
		ELSE IF ((DLINE(1:3) .EQ. '%AN') .AND. (.NOT. FIRSTLINE)) THEN
C
			DECODE(LLEN,250,DLINE) AD_NUMBR(MYDEV), DA_NUMBR(MYDEV), TYP_TRGGR(MYDEV)
250			FORMAT(4X,I2,6X,I1,6X,I1)
			KK = KK + 1
C
		ELSE IF ((DLINE(1:3) .EQ. '%AD') .AND. (.NOT. FIRSTLINE)) THEN
C
			II = II + 1
			LDSCR = LLEN - 24
			IF (LDSCR .LE. 0) LDSCR = 1
C
			DECODE(LLEN,350,DLINE)  AD_CHNL(MYDEV,II).CHAN_NUM, AD_CHNL(MYDEV,II).CHAN_GAIN,
     &						AD_CHNL(MYDEV,II).CHAN_DSCR
350			FORMAT(4X,I2,6X,I6,6X,A<LDSCR>)
			KK = KK + 1
C
		ELSE IF ((DLINE(1:3) .EQ. '%DA') .AND. (.NOT. FIRSTLINE)) THEN
C
			JJ = JJ + 1
			LDSCR = LLEN - 26
			IF (LDSCR .LE. 0) LDSCR = 1
C
			DECODE(LLEN,450,DLINE)  DA_CHNL(MYDEV,JJ).CHAN_NUM,  DA_CHNL(MYDEV,JJ).CHAN_DEVICE,
     &						DA_CHNL(MYDEV,JJ).CHAN_FROM, DA_CHNL(MYDEV,JJ).CHAN_DSCR
450			FORMAT(4X,I2,6X,I1,6X,I2,6X,A<LDSCR>)
			KK = KK + 1
C
		ELSE IF ((DLINE(1:3) .EQ. '%CL') .AND. (.NOT. FIRSTLINE)) THEN
C
			IF (DLINE(5:5) .EQ. 'T') THEN
				USE_CLOCK = .TRUE.
			ELSE
				USE_CLOCK = .FALSE.
			ENDIF
			KK = KK + 1
C
		ELSE IF ((DLINE(1:3) .EQ. '%AC') .AND. (.NOT. FIRSTLINE)) THEN
C
			IF (MYDEV .EQ. 1) THEN
				IF (DLINE(5:5) .EQ. 'T') THEN
					AD_CLOCK1 = .TRUE.
				ELSE
					AD_CLOCK1 = .FALSE.
				ENDIF
			ELSE
				IF (DLINE(5:5) .EQ. 'T') THEN
					AD_CLOCK2 = .TRUE.
				ELSE
					AD_CLOCK2 = .FALSE.
				ENDIF
			ENDIF
			KK = KK + 1
C
		ENDIF
C
		READ(8,50,IOSTAT=ISTAT) LLEN, DLINE
C
	ENDDO
C
	IF (KK .LE. 0) THEN
		WRITE(6,5000)
5000		FORMAT ('   NO DATA WAS LOADED INTO THE SHARED COMMON DATABASE.')
	ELSE
		WRITE(6,5150)
5150		FORMAT ('   DATA HAS BEEN LOADED INTO THE SHARED COMMON DATABASE.')
	ENDIF
C
	CLOSE(8)
C
	END
