$!
$!
$!---------------------------------------------------------------------------
$!	DEFINE INITIAL ENVIRONMENT FOR RUNNING PROGRAM.
$!		SET ERROR LEVEL SO WE DON'T STOP ROUTINE ON NORMAL ERRORS.
$!		SET WHERE TO GOTO ON A USERS REQUEST FOR ABORT.
$!		SET USERS TERMINAL TO WRAP.
$!		SEE IF USER WISHES TO VERIFY TELEMAIL USERNAMES.
$!		FIND OUT USERS USERNAME.
$!		DEFINE SYS$COMMAND LOGICAL.
$!		INITIALIZE SYMBOLS FOR TELEMAIL SEND PROGRAM.
$!---------------------------------------------------------------------------
$	SET NOON
$!
$	ON CONTROL_Y THEN GOTO ABORT
$!
$	SET TERM/WRAP
$!
$	CHKVER = "N"
$	IF F$EXTRACT(0,1,P1) .EQS. "V" THEN CHKVER = "Y"
$!
$	IF F$LOGICAL("SYS$INPUT") .NES. "" THEN DEASSIGN SYS$INPUT
$	ASSIGN/USER SYS$COMMAND SYS$INPUT
$!
$	LONGNAME =  F$GETJPI("", "USERNAME")
$	USRNM    =  F$EDIT(LONGNAME, "COMPRESS,TRIM")
$!
$	out      := write sys$output
$	TUSR     =  ""
$!
$!---------------------------------------------------------------------------
$!	WARN USER OF NEED FOR VERIFICATION OF TELEMAIL USERNAMES.
$!	TELL USER HOW TO ABORT THE PROGRAM.
$!		TRY TO OPEN TELEMAIL NAME FILE.
$!			IF NOT AVAILABLE GOTO NORMAL PROGRAM BEGINNING.
$!		READ VAX USERNAME.
$!		READ TELEMAIL USERNAME.
$!		READ TELEMAIL PASSWORD.
$!		CLOSE NAME FILE
$!		DEFINE SYMBOL INDICATING EXISTANCE OF NAME FILE.
$!---------------------------------------------------------------------------
$!
$	out "  "
$	out "		WELCOME TO TELESEND VERSION 2.1"
$	out "  "
$!
$	out "  HAVE YOU VERIFIED THE TELEMAIL USERNAMES"
$	out "  OF THE PEOPLE YOU PLAN TO SEND MAIL?"
$	out "  "
$	out "  YOU CAN ABORT THIS PROGRAM BY TYPING <CTRL>C ANYTIME."
$	out "  "
$!
$	NAMFIL_EXIST = "N"
$!
$	OPEN/READ/ERROR=BEGIN_PROG	NAMFIL	SYS$SCRATCH:TELESEND.WORDS
$!
$	READ/ERROR=BEGIN_PROG	NAMFIL	VAXUSR
$!
$	READ/ERROR=BEGIN_PROG	NAMFIL	TUSR
$!
$	READ/ERROR=BEGIN_PROG	NAMFIL	TELEPASS
$!
$	CLOSE NAMFIL
$!
$	NAMFIL_EXIST = "Y"
$!
$	out "  I ALREADY KNOW YOUR TELEMAIL USERNAME AND PASSWORD."
$	out "  "
$!
$!---------------------------------------------------------------------------
$!		CHECK IF VAX USERNAME IS SAME AS PROCESS VAX USERNAME.
$!			IF NOT SAME THEN EXIT WITH MESSAGE.
$!---------------------------------------------------------------------------
$!
$	VAXUSR = F$EDIT(VAXUSR,"COMPRESS,TRIM")
$	IF VAXUSR .NES. USRNM THEN GOTO SECUR_ABORT
$!
$ BEGIN_PROG:
$!
$!---------------------------------------------------------------------------
$!	DETERMINE IF NAME FILE EXIST, AND BRANCH AS NEEDED.
$!---------------------------------------------------------------------------
$!
$	IF NAMFIL_EXIST .EQS. "Y" THEN GOTO SKIP_PAST
$!
$ USER_STEP:
$!
$!---------------------------------------------------------------------------
$!	INQUIRE THE USERS TELEMAIL USER NAME.
$!---------------------------------------------------------------------------
$!
$	out " "
$	READ SYS$INPUT TUSR /PROMPT="What is your TELEMAIL username.     >>>   "
$	out " "
$!
$	IF "''TUSR'" .EQS. "" THEN GOTO USER_STEP
$!
$!---------------------------------------------------------------------------
$!	IF VERIFY IS ON, THEN SET RETURN POINTS AND VERIFY THE TELEMAIL NAME.
$!---------------------------------------------------------------------------
$!
$	OKRTRN := "PASS_STEP"
$	ERRTRN := "USER_STEP"
$!
$	IF CHKVER .EQS. "Y" THEN GOTO CHK_NAME
$!
$ PASS_STEP:
$!
$!---------------------------------------------------------------------------
$!	SET SYMBOL FOR THE TELEMAIL USERNAME, TO BE WRITTEN TO FILE.
$!	ASK USER FOR HIS TELEMAIL PASSWORD.
$!---------------------------------------------------------------------------
$!
$	out " "
$	READ SYS$INPUT TELEPASS /PROMPT="What is your TELEMAIL password.     >>>   "
$!
$ SKIP_PAST:
$!
$	IF "''TELEPASS'" .EQS. "" THEN GOTO PASS_STEP
$!
$!---------------------------------------------------------------------------
$!	INFORM USER THAT HIS MAIL IS SENT TO HIS TELEMAIL.
$!---------------------------------------------------------------------------
$!
$	out " "
$	out ""
$	out "TELEMAIL is sent to your own TELEMAIL account automatically."
$	out "This is to verify that your TELEMAIL message is properly sent."
$	out "  "
$!
$!---------------------------------------------------------------------------
$!	DETERMINE IF NAME FILE IS TO BE WRITTEN.
$!	IF YES, THEN
$!		OPEN NAME FILE
$!		WRITE NAME FILE INFORMATION
$!		CLOSE NAME FILE
$!		SET NAME FILE PROTECTIONS AND PURGE
$!---------------------------------------------------------------------------
$!
$	IF NAMFIL_EXIST .EQS. "Y" THEN GOTO START_STEP
$!
$	OPEN/WRITE/ERROR=NOSPACE	NAMFIL	SYS$SCRATCH:TELESEND.WORDS
$!
$	WRITE	NAMFIL	"''USRNM'"
$!
$	WRITE	NAMFIL	"''TUSR'"
$!
$	WRITE	NAMFIL	"''TELEPASS'"
$!
$	CLOSE NAMFIL
$!
$	SET PROT=(S:RE,O:RWED,G,W) SYS$SCRATCH:TELESEND.WORDS;*
$!
$	PURGE/NOLOG	SYS$SCRATCH:TELESEND.WORDS
$!
$ START_STEP:
$!
$!---------------------------------------------------------------------------
$!	CREATE SEND FILE NAME
$!	OPEN SEND FILE
$!	WRITE TO SEND FILE USERNAMES / PASSWORDS.
$!---------------------------------------------------------------------------
$!
$	LPTYME = F$TIME()
$!
$	UNIQUE = "''F$EXTRACT(12,8,LPTYME)'" - ":" - ":"
$!
$	SENDFILE = "SYS$SCRATCH:SEND$''UNIQUE'$COMM.TELL"
$!
$	OPEN/WRITE	DOFILE		'SENDFILE'
$!
$	urenv = f$environ("default")
$!
$	TELEUSER := "''TUSR'"
$!
$	WRITE DOFILE "''TELEUSER'"
$!
$	WRITE DOFILE "''TELEPASS'"
$!
$	ALTSERV = "NASAMAIL"
$!
$	IF F$LOCATE("/USRA","''TUSR'") .NE. F$LENGTH(TUSR) THEN	-
			ALTSERV = "TELEMAIL"
$!
$	IF F$LOCATE("/OMNI","''TUSR'") .NE. F$LENGTH(TUSR) THEN	-
			ALTSERV = "MAIL"
$!
$	OUT "	"
$	INQUIRE/NOPUN	CNTQUES "Ready to Begin?  "
$	IF F$EXTRACT(0,1,CNTQUES) .EQS. "N" THEN GOTO ABORT
$!
$!---------------------------------------------------------------------------
$!	INITIALIZE SYMBOLS FOR OBTAINING USERNAME TO SEND MESSAGE TO.
$!---------------------------------------------------------------------------
$!
$	NRMRTRN  := "SEND_STEP"
$	TELESEND = "''TELEUSER'"
$	TELECC   = ""
$!
$!---------------------------------------------------------------------------
$!	INFORM USER HOW TO ABORT PROGRAM.
$!	INFORM USER ABOUT DISTRIBUTION LIST OPTION.	
$!	SET UP SCROLLING REGION.
$!---------------------------------------------------------------------------
$!
$	out "[H[J"
$	out "  TO ABORT THIS PROGRAM, TYPE  <CTRL>C  ANYTIME."
$	out " "
$	out "	To use a distribution list, enter an ''''@'''' before the filename"
$	out "	which contains the list of TELEMAIL Usernames."
$	out "		Example:        @SAHQ"
$	out "[8;22r[9;1H"
$	out " "
$!
$	OUT "  "
$	OUT "SEND LIST SO FAR:  "
$	OUT "  "
$	OUT TELESEND
$	OUT "  "
$!
$ SEND_STEP:
$!
$!---------------------------------------------------------------------------
$!	REQUEST TELEMAIL USERNAME.
$!---------------------------------------------------------------------------
$!
$	out " "
$	out "To close your send list, enter <RETURN>."
$	out " "
$	READ SYS$INPUT INUSER /PROMPT="Name of user to send TELEMAIL to.   >>>   "
$!
$	TUSR = F$EDIT("''INUSER'","COMPRESS,TRIM")
$!
$!---------------------------------------------------------------------------
$!	CHECK FOR DISTRIBUTION LIST OPTION.
$!---------------------------------------------------------------------------
$!
$	IF F$EXTRACT(0,1,"''TUSR'") .EQS. "@" THEN GOTO LIST_ACTION
$!
$!---------------------------------------------------------------------------
$!	VERIFY USER HAS ENTERED AT LEAST ONE TELEMAIL NAME FOR SENDING.
$!---------------------------------------------------------------------------
$!
$	IF ("''TUSR'" .EQS. "") THEN GOTO CC_STEP
$!
$	IF F$LOCATE("/JAP",TUSR) .NE. F$LENGTH(TUSR) THEN GOSUB SEND_JAPAN
$!
$!---------------------------------------------------------------------------
$!	DEFINE SYMBOLS FOR RETURN FROM VERIFY, GOTO VERIFY IF REQUESTED.
$!---------------------------------------------------------------------------
$!
$	OKRTRN := "NAME_STEP"
$	ERRTRN := "NONAME_STEP"
$!
$	IF CHKVER .EQS. "Y" THEN GOTO CHK_NAME
$!
$ NAME_STEP:
$!
$!---------------------------------------------------------------------------
$!	PARSE NAME SUBMITTED, AND INSERT INTO STRING FOR 'TO LIST'.
$!---------------------------------------------------------------------------
$!
$	SENDLEN  = F$LENGTH("''TUSR'")
$	TELELEN  = F$LENGTH("''TELESEND'")
$	TOTLEN   = SENDLEN + TELELEN
$!
$	IF TOTLEN .GT. 130 THEN GOTO CCNM_STEP
$!
$	IF "''TELESEND'" .NES. "" THEN TELESEND = TELESEND + ",''TUSR'"
$	IF "''TELESEND'" .EQS. "" THEN TELESEND = "''TUSR'"
$	IF "''NRMRTRN'"  .EQS. "LSTRD" THEN GOTO 'NRMRTRN'
$!
$!---------------------------------------------------------------------------
$!	SHOW CURRECT 'TO LIST', AND RETURN TO NORMAL RETURN POINT.
$!---------------------------------------------------------------------------
$!
$	OUT "  "
$	OUT "SEND LIST SO FAR:  "
$	OUT "  "
$	OUT TELESEND
$	OUT "  "
$!
$	GOTO 'NRMRTRN'
$!
$ NONAME_STEP:
$!
$!---------------------------------------------------------------------------
$!	INFORM USER THAT PROVIDED TELEMAIL USERNAME WAS INVALID.
$!---------------------------------------------------------------------------
$!
$	out "TELEMAIL USER:  ",TUSR," NOT FOUND IN USERS LIST, TRY AGAIN."
$!
$	GOTO SEND_STEP
$!
$ CC_STEP:
$!
$!---------------------------------------------------------------------------
$!	DEFINE NORMAL RETURN POINT, AND REQUEST 'CC LIST' TELEMAIL NAMES.
$!---------------------------------------------------------------------------
$!
$	NRMRTRN := "CC_STEP"
$!
$	out " "
$	out "To close your CC list, enter <RETURN>."
$	out " "
$	READ SYS$INPUT INUSER /PROMPT="Name of user to CC TELEMAIL to.   >>>     "
$!
$	IF "''INUSER'" .EQS. "" THEN GOTO FILE_QUES
$!
$	TUSR = F$EDIT("''INUSER'","COMPRESS,TRIM")
$!
$!---------------------------------------------------------------------------
$!	CHECK FOR DISTRIBUTION LIST OPTION.
$!---------------------------------------------------------------------------
$!
$	IF F$EXTRACT(0,1,"''TUSR'") .EQS. "@" THEN GOTO LIST_ACTION
$!
$!---------------------------------------------------------------------------
$!	DEFINE SYMBOLS FOR VERIFY, AND GOTO VERIFY IF REQUESTED.
$!---------------------------------------------------------------------------
$!
$	OKRTRN := "CCNM_STEP"
$	ERRTRN := "NOCCNM_STEP"
$!
$	IF CHKVER .EQS. "Y" THEN GOTO CHK_NAME
$!
$ CCNM_STEP:
$!
$!---------------------------------------------------------------------------
$!	INSERT CC TELEMAIL NAME INTO CC SEND LIST.
$!---------------------------------------------------------------------------
$!
$	SENDLEN  = F$LENGTH("''TUSR'")
$	TELELEN  = F$LENGTH("''TELECC'")
$	TOTLEN   = SENDLEN + TELELEN
$!
$	IF TOTLEN .GT. 130 THEN GOTO NOROOM_STEP
$!
$	IF "''TELECC'" .NES. "" THEN TELECC = TELECC + ",''TUSR'"
$	IF "''TELECC'" .EQS. "" THEN TELECC = "''TUSR'"
$	IF "''NRMRTRN'"  .EQS. "LSTRD" THEN GOTO 'NRMRTRN'
$!
$ CC_LST:
$!
$!---------------------------------------------------------------------------
$!	SHOW CC SEND LIST ACCUMULATED SO FAR.
$!---------------------------------------------------------------------------
$!
$	OUT "  "
$	OUT "CC LIST SO FAR:  "
$	OUT "  "
$	OUT TELECC
$	OUT "  "
$!
$	GOTO 'NRMRTRN'
$!
$ NOCCME_STEP:
$!
$!---------------------------------------------------------------------------
$!	INFORM USER THAT TELEMAIL USERNAME WAS INVALID.
$!---------------------------------------------------------------------------
$!
$	out "TELEMAIL USER:  ",TUSR," NOT FOUND IN USERS LIST, TRY AGAIN."
$!
$	GOTO CC_STEP
$!
$ NOROOM_STEP:
$!
$!---------------------------------------------------------------------------
$!	INFORM USER THAT NO MORE ROOM EXISTS TO ADD TELEMAIL USERNAMES.
$!---------------------------------------------------------------------------
$!
$	out "NO MORE ROOM FOR TELEMAIL USERNAME TO SEND TO."
$!
$	IF NRMRTRN .EQS. "LSTRD" THEN GOTO ENDLST
$!
$ FILE_QUES:
$!
$!---------------------------------------------------------------------------
$!	DEFINE SYMBOL FOR BRANCH.
$!	TURN OFF SCROLLING REGION ON SCREEN.
$!	SHOW USER WHO HE IS SENDING MESSAGE.
$!---------------------------------------------------------------------------
$!
$	OKRTRN := "FILE_OUT"
$!
$	OUT "[1;24r"
$	out "[H[J"
$!
$	OUT "  "
$	OUT "SEND LIST:  "
$	OUT "  "
$	OUT TELESEND
$	OUT "  "
$!
$	OUT "  "
$	OUT "CC LIST:  "
$	OUT "  "
$	OUT TELECC
$	OUT "  "
$!
$!---------------------------------------------------------------------------
$!	TELL USER HIS FILE OPTIONS.
$!	OBTAIN FILE OPTION FROM USER.
$!	BRANCH TO FILE OPTION.
$!---------------------------------------------------------------------------
$!
$	OUT "	"
$	OUT "	"
$	OUT "	Do you want to:"
$	OUT "	"
$	OUT "		<S>	Send an existing text file.   (also <RETURN>)"
$	OUT "		<E>	EDIT and Send an existing text file."
$	OUT "		<M>	Create a message to send."
$	OUT "		<Q>	Quit this program.
$	OUT "	"
$!
$	INQUIRE/NOPUN	FLEQUES      "	Enter Option  >>  "
$!
$	IF FLEQUES .EQS. "S" THEN GOTO FILE_STEP
$	IF FLEQUES .EQS. "E" THEN GOTO FILE_STEP
$	IF FLEQUES .EQS. "M" THEN GOTO FILE_CREATE
$	IF FLEQUES .EQS. "Q" THEN GOTO ABORT
$	IF FLEQUES .NES. "" THEN GOTO FILE_QUES
$!
$ FILE_STEP:
$!
$!---------------------------------------------------------------------------
$!	ASK USER FOR FILENAME OF MESSAGE TO BE SENT.
$!---------------------------------------------------------------------------
$!
$	out " "
$	out "Enter Name of file where TELEMAIL message is contained."
$	out " "
$	READ SYS$INPUT FILEIN /PROMPT="File:> "
$!
$	IF "''FILEIN'" .EQS. "" THEN GOTO FILE_STEP
$!
$	TELEFILE = F$EDIT("''FILEIN'","COMPRESS,TRIM")
$!
$!---------------------------------------------------------------------------
$!	VERIFY FILE EXIST, IF NOT THEN BRANCH, OTHERWISE CONTINUE.
$!---------------------------------------------------------------------------
$!
$	LOCPER = F$LOCATE(".",TELEFILE)
$	LENFIL = F$LENGTH(TELEFILE)
$	IF LOCPER .EQ. LENFIL THEN TELEFILE = "''TELEFILE'."
$!
$	CHKFLE = F$SEARCH("''TELEFILE'")
$	IF CHKFLE .NES. "" THEN GOTO FILE_OUT
$!
$	OUT "	"
$	OUT "	File to be send, ''TELEFILE', not found.  Try Again."
$	OUT "	"
$!
$	GOTO FILE_STEP
$!
$ FILE_OUT:
$!
$!---------------------------------------------------------------------------
$!	WRITE OUT INFORMATION INPUT SO FAR, FILENAME, SENDLIST, CCLIST
$!	INFORM USER OF FILE TO BE SENT AND ITS STATUS AFTER SEND.
$!	DEFINE PROTECTION ON TEMPORARY SEND FILE.
$!---------------------------------------------------------------------------
$!
$	IF ((FLEQUES .EQS. "S") .OR. (FLEQUES .EQS. "M")) THEN GOTO WRT_FILE
$!
$	ASSIGN/USER	SYS$COMMAND SYS$INPUT
$	EDT	'TELEFILE'
$	PURGE/NOLOG	'TELEFILE'
$!
$ WRT_FILE:
$!
$	WRITE DOFILE TELEFILE
$!
$	WRITE DOFILE TELESEND
$!
$	WRITE DOFILE TELECC
$!
$	OUT "	"
$	OUT "	File to be sent to TELEMAIL is:  ''TELEFILE'"
$	OUT "	"
$	IF FLEQUES .NES. "M" THEN GOTO SUBJ_STEP
$	OUT "	Temporary file,  ''TELEFILE' ,   will be retained in your"
$	OUT "	directory for one week and then will be purged from the system."
$	OUT "	Please do not delete this file before the message has been sent."
$	OUT "	"
$!
$ SUBJ_STEP:
$!
$	SET PROT=(G,W) 'TELEFILE'
$!
$!
$!---------------------------------------------------------------------------
$!	ASK FOR SUBJECT OF TELEMAIL MESSAGE BEING SENT.
$!	TRIM LENGTH AS NECESSARY, AND SHOW SUBJECT TO BE SENT
$!	WRITE SUBJECT TO SEND FILE.
$!---------------------------------------------------------------------------
$!
$	out " "
$	out "Enter Subject of TELEMAIL message, No more than 75 Characters."
$	out " "
$	out " 123456789012345678901234567890123456789012345678901234567890123456789012345"
$	READ SYS$INPUT TELESUBJ /PROMPT=">"
$!
$	LENSUBJ = F$LENGTH(TELESUBJ)
$	IF LENSUBJ .GT. 79 THEN TELESUBJ = F$EXTRACT(0,79,TELESUBJ)
$!
$	out " "
$	out "This is the subject of your TELEMAIL message:"
$	out " "
$	out "''TELESUBJ'"
$	out " "
$	out " "
$!
$	WRITE DOFILE TELESUBJ
$!
$ retry_howsnd:
$!
$	out " "
$	out "	Now select how to send the mail to the recipient(s)."
$	out " "
$	out "		<N>	NORMAL,		Sends message with no special"
$	out "			attributes.  (Just Press <RETURN>)
$!	out " "
$!	out "		<R>	REGISTERED,	Recipient must acknowledge"
$!	out "			receipt of message before reading message."
$!	out "			Returns receipt aknowledgement to sender."
$	out " "
$	out "		<U>	URGENT,		Places message at top of"
$	out "			the recipients list of new messages to read."
$	out " "
$	out "		<V>	RETURN RECEIPT, Returns a message to sender"
$	out "			when the recipient reads the message sent."
$	out " "
$	out "		<UV>	URGENT/RECEIPT, Combination of <U> and <V>.
$	out " "
$	out " "
$	out " "
$!
$	inquire/nopun howsend "	Enter code for how to send mail:  "
$!
$	if howsend .eqs. ""   then howsend := "N"
$	if howsend .eqs. "N"  then typeofmail := "NORMAL"
$!	if howsend .eqs. "R"  then typeofmail := "(REGISTERED)"
$	if howsend .eqs. "V"  then typeofmail := "(RECEIPT)"
$	if howsend .eqs. "U"  then typeofmail := "(URGENT)"
$	if howsend .eqs. "UV" then typeofmail := "(URGENT,RECEIPT)"
$	if typeofmail .eqs. "" then goto retry_howsnd
$	if howsend .eqs. "N"  then typeofmail := ""
$!
$	WRITE DOFILE TYPEOFMAIL
$!
$	CLOSE/NOLOG DOFILE
$!
$!---------------------------------------------------------------------------
$!	
$!---------------------------------------------------------------------------
$!
$	IF ALTSERV .NES. "NASAMAIL" THEN GOTO OTHR_SERVICE
$!
$	SUBMIT	/QUEUE=TELESEND	/LOG=SYS$LOGIN	/NOPRINT	-
		/KEEP	/PARAM=("''URENV'","''SENDFILE'")	-
			ROOT_TMAIL:[SEND]TELESEND
$!
$	GOTO INFRM_USER
$!
$ OTHR_SERVICE:
$!
$	SUBMIT	/QUEUE=TELESEND	/LOG=SYS$LOGIN	/NOPRINT	-
		/KEEP	/PARAM=("''URENV'","''SENDFILE'","''ALTSERV'")	-
			ROOT_TMAIL:[SEND]TELESEND
$!
$!---------------------------------------------------------------------------
$!	INFORM USER OF ACTION TAKEN, AND POSSIBLE ERROR CONDITION.
$!---------------------------------------------------------------------------
$!
$ INFRM_USER:
$!
$	OUT "  "
$	OUT "	YOUR MAIL IS NOW BEING SENT TO THE TELEMAIL SYSTEM."
$	OUT "  "
$	OUT "	CONTACT SHOULD BE MADE WITHIN THE NEXT FIFTEEN MINUTES."
$	OUT "  "
$	OUT "	IF CONTACT WITH TELEMAIL IS NOT MADE WITHIN THE NEXT"
$	OUT "	FOUR HOURS THE MAIL WILL NOT BE SENT AND YOU WILL BE"
$	OUT "	INFORMED ALONG WITH THE SYSTEM MANAGER OF THIS PROBLEM."
$	OUT "  "
$!
$!---------------------------------------------------------------------------
$!	SEE IF USER HAS MORE MESSAGES TO TRANSMIT TO TELEMAIL.
$!---------------------------------------------------------------------------
$!
$	out " "
$	READ SYS$INPUT QUES /PROMPT="Any more TELEMAIL to send? <Y/N>  >>> (N) "
$!
$	IF "''QUES'" .EQS. "Y" THEN GOTO START_STEP
$!
$	EXIT
$!
$!
$!
$ ABORT:
$!
$!---------------------------------------------------------------------------
$!	CLOSE AND DELETE FILES WHEN USER ABORTS THE REQUEST.
$!---------------------------------------------------------------------------
$!
$	OUT "[1;24r"
$	out "[H[J"
$!
$	CLOSE/NOLOG DOFILE
$!
$	CLOSE/NOLOG CHKNAM
$!
$	DELETE/NOLOG 'SENDFILE';*
$!
$	EXIT
$!
$ SECUR_ABORT:
$!
$	OUT "	"
$	OUT "	YOUR NOT WHO YOU SAY YOU ARE!!!!"
$	OUT "	"
$	OUT "	UNABLE TO COMPLY WITH YOU REQUEST."
$	OUT "	"
$!
$	EXIT
$!
$ CHK_NAME:
$!
$!---------------------------------------------------------------------------
$!	VERIFY TELEMAIL USERNAME.	PRIMITIVE!!!
$!		CREATE OUTPUT FILE OF POSSIBLE MATCHES TO TELEMAIL USERNAME.
$!		IF POSSIBLE MATCHES EXIST THEN ASSUME USERNAME IS ALRIGHT.
$!		IF NOT THEN BRANCH TO INFORM USER.
$!---------------------------------------------------------------------------
$!
$	SEARCH/NOLOG ROOT_TMAIL:[TEXT]*.USR 'TUSR'/OUT=SYS$SCRATCH:CHKUSER.NAM
$!
$	OPEN/READ	CHKNAM	SYS$SCRATCH:CHKUSER.NAM
$	READ/END_OF_FILE=QUIT_CHK/ERROR=QUIT_CHK CHKNAM LINE
$	IF F$EXTR(0,5,"''LINE'") .EQS. "%SEAR" THEN GOTO QUIT_CHK
$	CLOSE CHKNAM
$!
$	DELETE/NOLOG SYS$SCRATCH:CHKUSER.NAM;*
$!
$	GOTO 'OKRTRN'
$!
$ QUIT_CHK:
$!
$!---------------------------------------------------------------------------
$!	REQUESTED TELEMAIL USERNAME WAS NOT FOUND IN SEARCH FILE.
$!	INFORM THE USER AND CLEANUP.  GIVE USER AN OPTION TO SEND ANYWAY.
$!---------------------------------------------------------------------------
$!
$	CLOSE CHKNAM
$!
$	DELETE/NOLOG SYS$SCRATCH:CHKUSER.NAM;*
$!
$	OUT "  "
$	OUT "	INVALID USERNAME ''TUSR'"
$	READ SYS$INPUT USRVER /PROMPT="	DO YOU WISH TO KEEP THIS USERNAME ANYWAY?  <Y/N>  "
$	OUT "  "
$	IF USRVER .EQS. "Y" THEN GOTO 'OKRTRN'
$!
$	GOTO 'ERRTRN'
$!
$!
$ FILE_CREATE:
$!
$!---------------------------------------------------------------------------
$!	CREATE FILE NAME FOR FILE TO BE CREATED.
$!---------------------------------------------------------------------------
$!
$	LPTYME = F$TIME()
$!
$	UNIQUE = "''F$EXTRACT(12,8,LPTYME)'" - ":" - ":"
$!
$	TELEFILE = "SEND$''UNIQUE'.TML"
$!
$!---------------------------------------------------------------------------
$!	USER ENTERS TEXT OF THE FILE TO BE SENT HERE.
$!---------------------------------------------------------------------------
$!
$	out "  "
$	out "Enter Message below.  Press <CTRL>Z to SEND. <CTRL>Y to ABORT Send."
$!
$	CREATE 'TELEFILE'
$!
$	GOTO 'OKRTRN'
$!
$ LIST_ACTION:
$!
$!---------------------------------------------------------------------------
$!	PARSE OUT FILENAME OF THE DISTRIBUTION LIST FILE.
$!---------------------------------------------------------------------------
$!
$	LSTLEN = F$LENGTH("''TUSR'")
$	FLENME = F$EXTRACT(1,LSTLEN-1,"''TUSR'")
$!
$ LST_SUBACT:
$!
$!---------------------------------------------------------------------------
$!	VERIFY DISTRIBUTION LIST EXIST, IF NOT THE BRANCH
$!---------------------------------------------------------------------------
$!
$	CHKFLE = F$SEARCH("''FLENME'.DIS")
$	IF CHKFLE .EQS. "" THEN GOTO NO_LIST
$!
$!---------------------------------------------------------------------------
$!	SET NORMAL RETURN SYMBOL
$!	INDICATE READING DISTRIBUTION LIST.
$!---------------------------------------------------------------------------
$!
$	NRMRTRN := "LSTRD"
$!
$	OUT " "
$	OUT "	READING THE DISTRIBUTION LIST ''FLENME'.DIS"
$	OUT " "
$!
$	OPEN/READ LSTUSRS 'FLENME'.DIS
$!
$ LSTRD:
$!
$!---------------------------------------------------------------------------
$!	READ DISTRIBUTION LIST AND PROCESS NORMALLY, NO VERIFICATION.
$!---------------------------------------------------------------------------
$!
$	READ/END_OF_LINE=ENDLST LSTUSRS TUSR
$!
$	GOTO NAME_STEP
$!
$ ENDLST:
$!
$!---------------------------------------------------------------------------
$!	CLOSE DISTRIBUTION LIST, AND SHOW USERNAMES SELECTED SO FAR.
$!---------------------------------------------------------------------------
$!
$	CLOSE LSTUSRS
$!
$	NRMRTRN := "SEND_STEP"
$	TELELEN  = F$LENGTH("''TELESEND'")
$	IF TELELEN .GT. 110 THEN NRMRTRN := "CC_STEP"
$!
$	OUT "  "
$	OUT "SEND LIST SO FAR:  "
$	OUT "  "
$	OUT TELESEND
$	OUT "  "
$!
$	GOTO CC_LST
$!
$ NO_LIST:
$!
$!---------------------------------------------------------------------------
$!	DISTRIBUTION LIST WAS NOT FOUND, GIVE OPTION TO CREATE.
$!	OTHER WISE RETURN USER TO USER NAME ENTRY.
$!---------------------------------------------------------------------------
$!
$	OUT "  "
$	READ SYS$INPUT LSTQUES /PROMPT="NO LIST FOUND, DO YOU WISH TO CREATE?  <Y/N>  "
$	OUT "  "
$!
$	IF LSTQUES .EQS. "Y" THEN GOTO CR_LST
$!
$	GOTO NONAME_STEP
$!
$ CR_LST:
$!
$!---------------------------------------------------------------------------
$!	CREATE TELEMAIL USERNAME DISTRIBUTION LIST.
$!---------------------------------------------------------------------------
$!
$	OPEN/WRITE	LSTUSRS		'FLENME'.DIS
$!
$	OUT "  "
$	OUT "	TELEMAIL USERNAMES WILL BE VERIFIED DURING FILE CREATION."
$	OUT "  "
$!
$	OUT "Enter <CTRL>Y To ABORT this PROGRAM."
$!
$	ERRTRN := "STR_LST"
$	OKRTRN := "STR_WRT"
$!
$ STR_LST:
$!
$!---------------------------------------------------------------------------
$!	INQUIRE USERNAME AND VERIFY.
$!---------------------------------------------------------------------------
$!
$	READ SYS$INPUT TUSR /PROMPT="(Press <RETURN> to End)   Username:  "
$!
$	IF "''TUSR'" .EQS. "" THEN GOTO LST_QUIT
$!
$	GOTO CHK_NAME
$!
$ STR_WRT:
$!
$!---------------------------------------------------------------------------
$!	WRITE DISTRIBUTION LIST NAME.
$!---------------------------------------------------------------------------
$!
$	WRITE LSTUSRS TUSR
$!
$	GOTO STR_LST
$!
$ LST_QUIT:
$!
$!---------------------------------------------------------------------------
$!	CLOSE DISTRIBUTION LIST AND THEN INSERT INTO LIST OF SEND NAMES.
$!---------------------------------------------------------------------------
$!
$	CLOSE LSTUSRS
$!
$	GOTO LST_SUBACT
$!
$ NOSPACE:
$!
$!---------------------------------------------------------------------------
$!	PROBLEM WITH CREATING A NEW NAME FILE.
$!	INFORM USER OF THIS PROBLEM AND EXIT.
$!---------------------------------------------------------------------------
$!
$	OUT "	"
$	OUT "	Out of Diskquota or you have set an invalid protection on"
$	OUT "	your [.MAIL] subdirectory.  Call System Manager for help."
$	OUT "	"
$!
$	CLOSE DOFILE
$!
$	DELETE/NOLOG 'SENDFILE';*
$!
$	EXIT
$!
$ SEND_JAPAN:
$!
$	LENJAP = F$LOCATE("/JAP",TUSR)
$!
$	TUSRJAP = F$EXTRACT(0,LENJAP,TUSR)
$!
$	TUSR = "[''TUSRJAP'/INTEC] MAIL/USA"
$!
$	RETURN
