$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$!	Name:		menu.com
$!
$!	Author: 	Fred Bassett
$!
$!	Description:	DCL Menu
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$!	Logical name "def_menu_file" to be defined to point to a
$!	text file containing the menu displays etc. 
$!	(default = sys$ligin:menu.dat)
$!	
$!	Logical name "def_menu_level" to be defined to contain a menu
$!	level number to be the first displayed menu
$!	(default = 1)
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$	open_file = 0
$ 	on error then continue
$ 	on control_y then goto did_control_y
$	clear = "[2J"
$	home = "[;H"
$	double = "#6"
$	underline = "[4m"
$	end_video = "[m"
$	bold = "[1m"
$	reverse = "[7m"
$	blink = "[5m"
$ 	space = "                             "
$ 	opt_tab = "|" 
$ 	opt_menu_tab = "|"       
$ 	opt_command_tab = "|"
$ 	opt_subcommand_tab = "|"
$ 	opt_level_tab = "|"
$	menu_level = 1
$	if "''p1'" .nes. "" then assign/nolog 'p1' def_menu_file
$	if "''f$trnlnm("def_menu_level")'" .nes. "" then menu_level = f$integer(f$trnlnm("def_menu_level"))
$ open_menu:
$ 	on error then goto error
$	if "''f$trnlnm("def_menu_file")'" .eqs. "" then assign "''f$trnlnm("sys$login")'menu.dat" def_menu_file
$ load_menu:
$	write sys$output clear,home
$	open/error=no_open/read menu_file def_menu_file
$	open_file = 1
$	menu_opt_num = 1
$ 	opt_current_tab = "|"
$	opt_current_count = 0
$ read_menu:
$	read/end=select_opt menu_file menu_record
$	ele_level = 'f$element(0,"|",menu_record)'
$	ele_type = "''f$element(1,"|",menu_record)'"
$	ele_code = "''f$element(2,"|",menu_record)'"
$	ele_desc = "''f$element(3,"|",menu_record)'"
$	ele_command = "''f$element(4,"|",menu_record)'"
$	ele_subcommand = "''f$element(5,"|",menu_record)'"
$	if "''ele_type'" .nes. "T" .and. f$locate("|''ele_code'|",opt_tab) .eq. f$length(opt_tab) then -
 		opt_level_tab = "''opt_level_tab'''ele_level'|"
$	if "''ele_type'" .nes. "T" .and. f$locate("|''ele_code'|",opt_tab) .eq. f$length(opt_tab) then -
 		opt_command_tab = "''opt_command_tab'''ele_command'|"
$	if "''ele_type'" .nes. "T" .and. f$locate("|''ele_code'|",opt_tab) .eq. f$length(opt_tab) then -
 		opt_subcommand_tab = "''opt_subcommand_tab'''ele_subcommand'|"
$	if "''ele_type'" .nes. "T" .and. f$locate("|''ele_code'|",opt_tab) .eq. f$length(opt_tab) then -
 		opt_tab = "''opt_tab'''ele_code'|"
$	if "''ele_type'" .nes. "T" .and. 'ele_level' .eq. 'menu_level' then -
 		opt_current_tab = "''opt_current_tab'''ele_code'|"
$	if "''ele_type'" .nes. "T" .and. 'ele_level' .eq. 'menu_level' then -
 		opt_current_count = 'opt_current_count' + 1
$	if "''ele_type'" .eqs. "M" .and. f$locate("|''ele_code'|",opt_menu_tab) .eq. f$length(opt_menu_tab) then -
		opt_menu_tab = "''opt_menu_tab'''ele_code'|"
$	if 'ele_level' .ne. 'menu_level' then goto read_menu
$	if "''ele_type'" .eqs. "T" then goto menu_title
$	number_space = 21 - 'f$length(menu_opt_num)'
$	detail_space = "''f$extract(0,number_space,space)'"
$	number_space = 7 - 'f$length(ele_code)'
$	opt_space = "''f$extract(0,number_space,space)'"
$	write sys$output -                       
	"''detail_space'''underline'''menu_opt_num'''end_video'     ''bold'''ele_code'''end_video' ''opt_space'''ele_desc'"
$	menu_opt_num = menu_opt_num + 1
$	goto read_menu
$ menu_title:
$	number_space = (34 - 'f$length(ele_desc)') / 2
$	title_space = "''f$extract(0,number_space,space)'"
$	write sys$output "''title_space'''double'''reverse'''ele_desc'''end_video'"
$	write sys$output " "
$	write sys$output " "
$	write sys$output "                  Item   Code     Description"
$	write sys$output " "
$	goto read_menu
$ select_opt:
$	close menu_file
$	open_file = 0
$	write sys$output " "                                        
$	write sys$output " "
$ get_opt:
$	inquire/nopunctuation do_opt "                    Enter selection: "
$	if "''do_opt'" .eqs. "" then goto get_opt
$	if "''f$type(do_opt)'" .eqs. "INTEGER" then if 'do_opt' .gt. 'opt_current_count' .or. 'do_opt' .lt. 1 then goto opt_error
$	if "''f$type(do_opt)'" .eqs. "INTEGER" then do_opt = "''f$element(do_opt,"|",opt_current_tab)'"
$	if 'f$locate(do_opt,opt_tab)' .nes. 'f$length(opt_tab)' then goto find_ele_num
$ opt_error:
$	write sys$output " "
$	write sys$output "''blink'Invalid function entered, try again...''end_video'"
$	write sys$output " "
$	goto get_opt
$ find_ele_num:
$	ele_num = 0
$	test_tab = "''opt_tab'"
$ ele_loop:
$	opt_pos = 'f$locate(do_opt,test_tab)'
$	delim_pos  = 'f$locate("|",test_tab)'
$	if 'delim_pos' .gt. 'opt_pos' then goto ele_found
$	tab_length = 'f$length(test_tab)'
$	test_tab = "''f$extract(delim_pos + 1,tab_length,test_tab)'"
$	ele_num = 'ele_num' + 1
$	goto ele_loop
$ ele_found:
$	menu_level = 'f$element(ele_num,"|",opt_level_tab)'
$	function_command = "''f$element(ele_num,"|",opt_command_tab)'"
$	sub_command = "''f$element(ele_num,"|",opt_subcommand_tab)'"
$	if 'f$locate(do_opt,opt_menu_tab)' .nes. 'f$length(opt_menu_tab)' then menu_level = 'function_command'
$	if 'f$locate(do_opt,opt_menu_tab)' .nes. 'f$length(opt_menu_tab)' then goto load_menu
$ perform_function:
$ 	assign/nolog/user sys$command sys$input
$	'function_command'
$	if "''f$edit(sub_command,"upcase")'" .eqs. "WAIT" then -
		inquire/nopunctuation reply_cont "''blink'Press <Return> or <Enter> keys to continue...''end_video'"
$	goto load_menu
$ no_open:
$ 	write sys$output "''blink'Could not open menu data file ''f$trnlnm("def_menu_file")'''end_video'"
$	goto exit
$ error:
$ 	write sys$output "''blink'Error occured, contact a DP staff member...''end_video'"
$ did_control_y:
$	if 'open_file' .eq. 1 then close menu_file
$ exit:
$	exit
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
