
C+
C   Get_USERNAME	Subroutine to return the USERNAME of the 
C			current process.
C
C	CALL Get_USERNAME(Cuser_Name,Ilength)
C	Where:
C		Cuser_Name  Character*12   User name string
C		Ilength	    I*4		   Length of name string
C
C	Written by:	James G. Downward
C			KMS Fusion, Inc.
C			P.O. Box 1567
C			Ann Arbor, Mich 48104
C			(313)-769-8500
C
C			
C-
C
	SUBROUTINE Get_USERNAME(Cuser_Name,Ilength)
	CHARACTER*12 Cuser_name				!
	INTEGER*2 JPI_Code,JPI_Length,JPI_Header(2)	! For GETJPI setup
	INTEGER*4 LIST(3)				!
	INTEGER*4 Istatus,Ilength			!

	EQUIVALENCE (JPI_Header(1),JPI_Length)
	EQUIVALENCE (JPI_Header(2),JPI_Code)
	EQUIVALENCE (JPI_Header(1),LIST(1))


C
C -- Find out the User_Name of the current process
C
	JPI_Code = '202'X				! Get USERNAME
	JPI_Length = 12					! 4 bytes long
	LIST (2) = %LOC(Cuser_name)			! Set up GETJPI
	LIST (3) = %LOC(Ilength)			! Length of name strng
	ISTATUS=SYS$GETJPI(,,,LIST,,,)			!
	Ilength=INDEX(Cuser_Name,' ')-1			! get end of name
	END

