*******************************************************************************
*
identification division.
program-id.	users.
author.		fred bassett.
installation.	j g boswell co
		po box 457
		corcoran ca 93212
		(209)992-2141.
date-written.	march 25, 1987
*
*remarks.
*		vax/vms v4.5, cobol v3.4
*
*		get info on all active users (processess)
*
environment division.
configuration section.
	source-computer.	vax-11.
	object-computer.	vax-11.
*
special-names.
    symbolic escape is 28.
*
input-output section.
file-control.
    select report-file
           assign to "sys$disk:",
           organization is sequential,
           access mode is sequential.
    select sort-file
           assign to "sys$disk".
*
data division.
*
file section.
fd  report-file
    record contains 132 characters
    value of id is report-file-name
    data record is report-line.
01	report-line		       		pic	x(132).
*
sd  sort-file
    data record is sort-record.
01	sort-record.
	03	sort-key			pic	x(100).
	03	sort-fields.
		05	sort-prcnam		pic	x(15).
		05	sort-prcnam-len		pic	9(4)	comp.
		05	sort-username		pic	x(12).
		05	sort-username-len	pic	9(4)	comp.
		05	sort-mode		pic	9(9)	comp.
		05	sort-owner		pic	9(9)	comp.
		05	sort-terminal		pic	x(6).
		05	sort-terminal-len	pic	9(4)	comp.
		05	sort-logintim		pic	s9(11)v9(7)	comp.
		05	sort-prib		pic	9(9)	comp.
		05	sort-pri		pic	9(9)	comp.
		05	sort-pid		pic	9(9)	comp.
		05	sort-grp		pic	9(9)	comp.
		05	sort-mem		pic	9(9)	comp.
		05	sort-cputim		pic	9(9)	comp.
		05	sort-ppgcnt		pic	9(9)	comp.
		05	sort-gpgcnt		pic	9(9)	comp.
		05	sort-filcnt		pic	9(9)	comp.
		05	sort-fillm		pic	9(9)	comp.
		05	sort-imagecount		pic	9(9)	comp.
		05	sort-imagname		pic	x(100).
		05	sort-imagname-len	pic	9(4)	comp.
*
working-storage section.
*
01	return-status				pic	s9(9)	comp.
01	sort-read-flag				pic	s9(4)	comp.
	88	sort-read-success		value	0.
	88	sort-read-failed		value	1.
01	terminal-width-flag			pic	s9(4)	comp.
	88	term-width-unchanged		value	0.
	88	term-width-changed		value	1.
01	destination-qualifier-flag		pic	s9(4)	comp.
	88	dest-terminal			value	0.
	88	dest-file			value	1.
01	page-qualifier-flag  			pic	s9(4)	comp.
	88	page-qualifier			value	0.
	88	no-page-qualifier		value	1.
01	sort-qualifier-flag			pic	s9(4)	comp.
	88	sort-qualifier-username		value	0.
	88	sort-qualifier-prcnam 		value	1.
	88	sort-qualifier-uic 		value	2.
	88	sort-qualifier-port 		value	3.
	88	sort-qualifier-image 		value	4.
01	job-qualifier-flag			pic	s9(4)	comp.
	88	job-qualifier-no		value	0.
	88	job-qualifier-yes 		value	1.
01	id-qualifier-flag			pic	s9(4)	comp.
	88	id-qualifier-no			value	0.
	88	id-qualifier-yes 		value	1.
	88	id-qualifier-done 		value	2.
01	ws-char-buf.
	03	filler				pic	xx.
	03	ws-term-width			pic	s9(4)	comp.
	03	filler				pic	x(4).
01  	ws-save-width				pic	s9(4)	comp.
01	ws-function-sense			pic	s9(9)	comp	value	external	io$_sensemode.
01	ws-function-set				pic	s9(9)	comp	value	external	io$_setmode.
01	ws-channel				pic	s9(4)	comp.
01	ws-io-status-block.
	03	ws-iostat			pic	s9(4)	comp.
	03	filler				pic	x(6).
01	ws-id-str.
	03	filler				pic	x.
	03	ws-id-4.
		05	filler			pic	x.
		05	ws-id-3.
			10	filler		pic	x.
		     	10	ws-id-2		pic	xx.
01	ws-id					pic	9(9)	comp.
01	ws-dummy				pic	x.
01	ws-null					pic	9(4)	comp	value	0.
01	ws-null-char redefines ws-null.
	03	ws-null-1			pic	x.
	03	ws-null-2			pic	x.
01	ws-line-cnt				pic	s9(4)	comp.
01	ws-sort-key.
	03	ws-sort-key-1			pic	9(9)	comp.
	03	ws-sort-key-2			pic	9(9)	comp.
01	ws-octal-grp				pic	9(9).
01	ws-octal-mem				pic	9(9).
01	ws-new-cputim				pic	9(9)	comp.
01	ws-cpu-time.
	03	ws-cpu-h			pic	9.
	03	filler				pic	x	value	":".
	03	ws-cpu-m			pic	99.
	03	filler				pic	x	value	":".
	03	ws-cpu-s			pic	99.
01	ws-time-str.
	03	ws-time-dd-mmm			pic	x(6).
	03	filler				pic	x(5).
	03	ws-time-hh-mm			pic	x(6).
	03	filler				pic	x(6).
01	ws-login-time.
	03	ws-login-dd-mmm			pic	x(6).
	03	ws-login-hh-mm			pic	x(6).
01	report-file-name			pic	x(50).
01	file-report-name			pic	x(50).
01	file-report-name-default		pic	x(50)	value	"sys$disk:show_users.lis                           ".
01	terminal-report-name			pic	x(50)	value	"sys$output:                                       ".
01	terminal-set.
	03	escape-1			pic	x.
	03	filler				pic	x(4)	value	"[?3h".
	03	filler				pic	x(127)	value	spaces.
01	terminal-reset.
	03	escape-2			pic	x.
	03	filler				pic	x(5)	value	"[?3l".
	03	filler				pic	x(126)	value	spaces.
01	ws-sub					pic	s9(9)	comp.
01	ws-tally				pic	s9(4)	comp.
01	ws-tally2				pic	s9(4)	comp.
01	ws-size-left				pic	s9(4)	comp.
01	ws-dow-values.
	03	filler				pic	x(22)	value	"Monday     Tuesday    ".
	03	filler				pic	x(22)	value	"Wednesday  Thursday   ".
	03	filler				pic	x(22)	value	"Friday     Saturday   ".
	03	filler				pic	x(11)	value	"Sunday     ".
01	ws-dow-tbl redefines ws-dow-values.
	03	ws-weekday occurs 7 times	pic	x(11).
01	ws-qualifiers-read.
	03	ws-qualifiers			pic	x(100).
	03	ws-wrk-str   			pic	x(100).
	03	ws-qualifier-len		pic	9(4)	comp.
01	ws-jpi.
	03	ws-ss-nomoreproc		pic	9(9)	comp	value	external	ss$_nomoreproc.
	03	ws-ss-notran 			pic	9(9)	comp	value	external	ss$_notran.
	03	ws-pidadr			pic	s9(9)	comp.
	03	ws-pidadr-default		pic	s9(9)	comp	value	-1.
	03	ws-count-process		pic	s9(4)	comp.
	03	jpi-jpi-fields.
		05	jpi-prcnam		pic	x(15).
		05	jpi-prcnam-len		pic	9(4)	comp.
		05	jpi-username		pic	x(12).
		05	jpi-username-len	pic	9(4)	comp.
		05	jpi-mode		pic	9(9)	comp.
		05	jpi-owner		pic	9(9)	comp.
		05	jpi-terminal		pic	x(6).
		05	jpi-terminal-len	pic	9(4)	comp.
		05	jpi-logintim		pic	s9(11)v9(7)  	comp.
		05	jpi-prib		pic	9(9)	comp.
		05	jpi-pri			pic	9(9)	comp.
		05	jpi-pid			pic	9(9)	comp.
		05	jpi-grp			pic	9(9)	comp.
		05	jpi-mem			pic	9(9)	comp.
		05	jpi-cputim		pic	9(9)	comp.
		05	jpi-ppgcnt		pic	9(9)	comp.
		05	jpi-gpgcnt		pic	9(9)	comp.
		05	jpi-filcnt		pic	9(9)	comp.
		05	jpi-fillm		pic	9(9)	comp.
		05	jpi-imagecount		pic	9(9)	comp.
		05	jpi-imagname		pic	x(100).
		05	jpi-imagname-len	pic	9(4)	comp.
	03	ws-jpi-fields occurs 1 to 100 times depending on ws-count-process indexed by ws-jpi-index.
		05	ws-prcnam		pic	x(15).
		05	ws-prcnam-len		pic	9(4)	comp.
		05	ws-username		pic	x(12).
		05	ws-username-len		pic	9(4)	comp.
		05	ws-mode			pic	9(9)	comp.
		05	ws-owner		pic	9(9)	comp.
		05	ws-terminal		pic	x(6).
		05	ws-terminal-len		pic	9(4)	comp.
		05	ws-logintim		pic	s9(11)v9(7)	comp.
		05	ws-prib			pic	9(9)	comp.
		05	ws-pri			pic	9(9)	comp.
		05	ws-pid			pic	9(9)	comp.
		05	ws-grp			pic	9(9)	comp.
		05	ws-mem			pic	9(9)	comp.
		05	ws-cputim		pic	9(9)	comp.
		05	ws-ppgcnt		pic	9(9)	comp.
		05	ws-gpgcnt		pic	9(9)	comp.
		05	ws-filcnt		pic	9(9)	comp.
		05	ws-fillm		pic	9(9)	comp.
		05	ws-imagecount		pic	9(9)	comp.
		05	ws-imagname		pic	x(100).
		05	ws-imagname-len		pic	9(4)	comp.
01	jpi-item-list.
	03	jpi-prcnam-param.
		05	jpi-prcnam-length	pic	9(4)	comp	value	15.
		05	jpi-prcnam-code		pic	9(4)	comp	value	external	jpi$-prcnam.
		05	jpi-prcnam-buf		usage	pointer		value	reference	jpi-prcnam.
		05	jpi-prcnam-return	usage	pointer		value	reference	jpi-prcnam-len.
	03	jpi-username-param.
		05	jpi-username-length	pic	9(4)	comp	value	12.
		05	jpi-username-code	pic	9(4)	comp	value	external	jpi$-username.
		05	jpi-username-buf	usage	pointer		value	reference	jpi-username.
		05	jpi-username-return	usage	pointer		value	reference	jpi-username-len.
	03	jpi-mode-param.
		05	jpi-mode-len		pic	9(4)	comp	value	4.
		05	jpi-mode-code		pic	9(4)  	comp 	value	external	jpi$-mode.
		05	jpi-mode-buf		usage	pointer		value	reference	jpi-mode.
		05	jpi-mode-return		pic	9(9)	comp	value	0.
	03	jpi-owner-param.
		05	jpi-owner-len		pic	9(4)	comp	value	6.
		05	jpi-owner-code		pic	9(4)	comp	value	external	jpi$-owner.
		05	jpi-owner-buf		usage	pointer		value	reference	jpi-owner.
		05	jpi-owner-return	pic	9(9)	comp	value	0.
	03	jpi-terminal-param.
		05	jpi-terminal-length	pic	9(4)	comp	value	6.
		05	jpi-terminal-code	pic	9(4)	comp	value	external	jpi$-terminal.
		05	jpi-terminal-buf	usage	pointer		value	reference	jpi-terminal.
		05	jpi-terminal-return	usage	pointer		value	reference	jpi-terminal-len.
	03	jpi-logintim-param.
		05	jpi-logintim-len	pic	9(4)	comp	value	8.
		05	jpi-logintim-code  	pic	9(4)	comp	value	external	jpi$-logintim.
		05	jpi-logintim-buf	usage	pointer		value	reference	jpi-logintim.
		05	jpi-logintim-return	pic	9(9)	comp	value	0.
	03	jpi-prib-param.
		05	jpi-prib-len		pic	9(4)	comp	value	4.
		05	jpi-prib-code		pic	9(4)	comp	value	external	jpi$-prib.
		05	jpi-prib-buf		usage	pointer		value	reference	jpi-prib.
		05	jpi-prib-return	pic	9(9)	comp	value	0.
	03	jpi-pri-param.
		05	jpi-pri-len		pic	9(4)	comp	value	4.
		05	jpi-pri-code		pic	9(4)	comp	value	external	jpi$-pri.
		05	jpi-pri-buf		usage	pointer		value	reference	jpi-pri.
		05	jpi-pri-return	pic	9(9)	comp	value	0.
	03	jpi-pid-param.
		05	jpi-pid-len		pic	9(4)	comp	value	4.
		05	jpi-pid-code		pic	9(4)	comp	value	external	jpi$-pid.
		05	jpi-pid-buf		usage	pointer		value	reference	jpi-pid.
		05	jpi-pid-return	pic	9(9)	comp	value	0.
	03	jpi-grp-param.
		05	jpi-grp-len		pic	9(4)	comp	value	4.
		05	jpi-grp-code		pic	9(4)	comp	value	external	jpi$-grp.
		05	jpi-grp-buf		usage	pointer		value	reference	jpi-grp.
		05	jpi-grp-return	pic	9(9)	comp	value	0.
	03	jpi-mem-param.
		05	jpi-mem-len		pic	9(4)	comp	value	4.
		05	jpi-mem-code		pic	9(4)	comp	value	external	jpi$-mem.
		05	jpi-mem-buf		usage	pointer		value	reference	jpi-mem.
		05	jpi-mem-return	pic	9(9)	comp	value	0.
	03	jpi-cputim-param.
		05	jpi-cputim-len		pic	9(4)	comp	value	4.
		05	jpi-cputim-code		pic	9(4)	comp	value	external	jpi$-cputim.
		05	jpi-cputim-buf		usage	pointer		value	reference	jpi-cputim.
		05	jpi-cputim-return	pic	9(9)	comp	value	0.
	03	jpi-ppgcnt-param.
		05	jpi-ppgcnt-len		pic	9(4)	comp	value	4.
		05	jpi-ppgcnt-code		pic	9(4)	comp	value	external	jpi$-ppgcnt.
		05	jpi-ppgcnt-buf		usage	pointer		value	reference	jpi-ppgcnt.
		05	jpi-ppgcnt-return	pic	9(9)	comp	value	0.
	03	jpi-gpgcnt-param.
		05	jpi-gpgcnt-len		pic	9(4)	comp	value	4.
		05	jpi-gpgcnt-code		pic	9(4)	comp	value	external	jpi$-gpgcnt.
		05	jpi-gpgcnt-buf		usage	pointer		value	reference	jpi-gpgcnt.
		05	jpi-gpgcnt-return	pic	9(9)	comp	value	0.
	03	jpi-filcnt-param.
		05	jpi-filcnt-len		pic	9(4)	comp	value	4.
		05	jpi-filcnt-code		pic	9(4)	comp	value	external	jpi$-filcnt.
		05	jpi-filcnt-buf		usage	pointer		value	reference	jpi-filcnt.
		05	jpi-filcnt-return	pic	9(9)	comp	value	0.
	03	jpi-fillm-param.
		05	jpi-fillm-len		pic	9(4)	comp	value	4.
		05	jpi-fillm-code		pic	9(4)	comp	value	external	jpi$-fillm.
		05	jpi-fillm-buf		usage	pointer		value	reference	jpi-fillm.
		05	jpi-fillm-return	pic	9(9)	comp	value	0.
	03	jpi-imagecount-param.
		05	jpi-imagecount-len	pic	9(4)	comp	value	4.
		05	jpi-imagecount-code	pic	9(4)	comp	value	external	jpi$-imagecount.
		05	jpi-imagecount-buf	usage	pointer		value	reference	jpi-imagecount.
		05	jpi-imagecount-return	pic	9(9)	comp	value	0.
	03	jpi-imagname-param.
		05	jpi-imagname-length	pic	9(4)	comp	value	100.
		05	jpi-imagname-code	pic	9(4)	comp	value	external	jpi$-imagname.
		05	jpi-imagname-buf	usage	pointer		value	reference	jpi-imagname.
		05	jpi-imagname-return	usage	pointer		value	reference	jpi-imagname-len.
	03	jpi-terminate			pic	9(9)	comp	value	0.
01	rpt-heading-1.
	03	filler				pic	x(2)	value	spaces.
	03	filler				pic	x(30)	value	"U s e r s   o n   N o d e :   ".
	03	rpt-node			pic	x(20).
	03	filler				pic	x(20)	value	spaces.
 	03	filler				pic	x(22)	value	"D a t e / T i m e :   ".
 	03	rpt-dow				pic	x(11).
 	03	rpt-date-time			pic	x(23).
	03	filler				pic	x(2)	value	spaces.
01	rpt-heading-2.
	03	filler				pic	x(3)	value	spaces.
	03	filler				pic	x(4)	value	"User".
	03	filler				pic	x(9)	value	spaces.
	03	filler				pic	x(7)	value	"Process".
	03	filler	    			pic	x(8)	value	spaces.
	03	filler				pic	x(3)	value	"Pid".
	03	filler				pic	x	value	space.
	03	filler				pic	x(4)	value	"Mode".
	03  	filler				pic	x	value	spaces.
	03	filler				pic	x(4)	value	"Port".
	03	filler				pic	x(6)	value	spaces.
	03	filler				pic	x(5)	value	"Login".
	03	filler				pic	x(3)	value	spaces.
	03	filler				pic	x(7)	value	"Priorty".
	03	filler				pic	x(3)	value	spaces.
	03	filler				pic	x(3)	value	"Uic".
	03	filler				pic	x(6)	value	spaces.
	03	filler				pic	x(3)	value	"Cpu".
	03	filler				pic	x(4)	value	spaces.
	03	filler				pic	x(2)	value	"Ws".
	03	filler				pic	x(2)	value	spaces.
	03	filler				pic	x(2)	value	"Fl".
	03	filler				pic	x  	value	space.
	03	filler				pic	x(3)	value	"Img".
	03	filler				pic	x(4)	value	spaces.
	03	filler				pic	x(5)	value	"Image".
	03	filler				pic	x(29)	value	spaces.
01	rpt-heading-3.
	03	filler				pic	x(3)	value	spaces.
	03	filler				pic	x(4)	value	"Name".
	03	filler				pic	x(10)	value	spaces.
	03	filler				pic	x(4)	value	"Name".
	03	filler				pic	x(29)	value	spaces.
	03	filler				pic	x(4)	value	"Time".
	03	filler				pic	x(6)	value	spaces.
	03	filler				pic	x(4)	value	"C  B".
	03	filler				pic	x(13)	value	spaces.
	03	filler				pic	x(4)	value	"Time".
	03	filler				pic	x(2)	value	spaces.
	03	filler				pic	x(4)	value	"Size".
	03	filler				pic	x	value	space.
	03	filler				pic	x(2)	value	"Ct".
	03	filler				pic	x	value	space.
	03	filler				pic	x(3)	value	"Cnt".
	03	filler				pic	x(4)	value	spaces.
	03	filler				pic	x(4)	value	"Name".
	03	filler				pic	x(29)	value	spaces.
01	rpt-heading-4.
	03	filler				pic	x(50)	value	"==================================================".
	03	filler				pic	x(50)	value	"==================================================".
	03	filler				pic	x(32)	value	"================================".
01	rpt-detail.
	03	rpt-username			pic	x(12).
	03	filler				pic	x	value	space.
	03	rpt-prcnam			pic	x(15).
	03	filler				pic	x	value	space.
	03	rpt-pid				pic	z(5).
	03	filler				pic	x	value	space.
	03	rpt-mode			pic	x(3).
	03	filler				pic	x	value	space.
	03	rpt-terminal			pic	x(6).
	03	filler				pic	x	value	space.
	03	rpt-logintim			pic	x(12).
	03	filler				pic	x	value	space.
	03  	rpt-pri				pic	z9.
	03	filler				pic	x	value	space.
	03	rpt-prib			pic	z9.
	03	filler				pic	x	value	space.
	03	filler				pic	x	value	"[".
	03	rpt-grp				pic	zz9.
	03	filler				pic	x	value	",".
	03	rpt-mem				pic	zz9.
	03	filler				pic	x	value	"]".
	03	filler				pic	x	value	space.
	03	rpt-cputim			pic	x(7).
	03	filler				pic	x	value	space.
	03	rpt-wssize			pic	z(3)9.
	03	filler				pic	x	value	space.
	03	rpt-filecnt			pic	z9.
	03	filler				pic	x	value	space.
	03	rpt-imagecount			pic	zz9.
	03	filler				pic	x	value	space.
	03	rpt-imagname			pic	x(37).
*
linkage section.
*
/
*******************************************************************************
*
procedure division
	giving	return-status.
*
a000-mainline-section section.
*
a000-mainline.
*
	perform u000-initialize.
	perform b000-get-user-info.
	if	return-status success
	then	sort	sort-file
		    	on ascending key sort-key
			input	procedure is c000-sort-input-procedure
			output	procedure is d000-sort-output-procedure
		if	return-status success
		then	perform e000-do-report
		end-if
	end-if.
*
a999-exit-program.
*
     	exit program.
*
b000-get-user-info.
*
*	perform b100-print-headings.
	perform	varying	ws-count-process
		from	1
		by	1
		until	return-status failure
		or	return-status = ws-ss-nomoreproc
		or	ws-count-process greater than 100
		or	id-qualifier-done
		call "sys$getjpiw"
			using	by value	0
				by reference	ws-pidadr
				by value	0
				by reference	jpi-item-list
				by value	0
						0
						0
			giving			return-status
		if	return-status success
		   and	return-status not equal ws-ss-nomoreproc
		then	if	(job-qualifier-no and ((jpi-mode equal 0 or jpi-mode equal 1) and jpi-owner = 0))
			then	subtract 1 from ws-count-process
			else	move jpi-jpi-fields to ws-jpi-fields (ws-count-process)
			end-if
			if	id-qualifier-yes
			then	set id-qualifier-done to true
			end-if
		else	subtract 1 from ws-count-process
		end-if
	end-perform.
	if	return-status equal ws-ss-nomoreproc
	then	set return-status to success
	end-if.
	subtract 1 from ws-count-process.
*
c000-sort-input-procedure section.
*
c000-sort-inputs.
*
	perform	varying	ws-jpi-index
		from	1
		by	1
		until	ws-jpi-index greater than ws-count-process
		move spaces to sort-key
		if	sort-qualifier-prcnam
		then	move ws-prcnam (ws-jpi-index) (1:ws-prcnam-len (ws-jpi-index)) to sort-key
		else	if	sort-qualifier-uic
			then	move ws-grp (ws-jpi-index) to ws-sort-key-1
				move ws-mem (ws-jpi-index) to ws-sort-key-2
				move ws-sort-key to sort-key
			else	if	sort-qualifier-port
				then	move ws-terminal (ws-jpi-index) (1:ws-terminal-len (ws-jpi-index)) to sort-key
				else	if	sort-qualifier-image
					then	move ws-imagname (ws-jpi-index) (1:ws-imagname-len (ws-jpi-index)) to sort-key
					else	move ws-username (ws-jpi-index) (1:ws-username-len (ws-jpi-index)) to sort-key
					end-if
				end-if
			end-if
		end-if
		move ws-jpi-fields (ws-jpi-index) to sort-fields
		release sort-record
	end-perform.
*
d000-sort-output-procedure section.
*
d000-sort-ouputs.
*
	initialize sort-record.
	set sort-read-success to true.
	perform	varying	ws-jpi-index
		from	1
		by	1
		until	ws-jpi-index greater than ws-count-process
		or	sort-read-failed
		return	sort-file
			at end set sort-read-failed to true
		end-return
		if	sort-read-success
		then	move sort-fields to ws-jpi-fields (ws-jpi-index)
		end-if
	end-perform.
*
e000-last-section section.
*
e000-do-report.
*
	if	dest-terminal
	then	move escape to escape-1, escape-2
		move terminal-report-name to report-file-name
	else	move file-report-name to report-file-name
	end-if.
	open output report-file.
	if     dest-terminal
	then	perform e050-terminal-width
	end-if.
	if	return-status success
	then	perform e100-write-headings
		perform e200-write-detail
		if	dest-terminal
		then	display "Press <Enter/Return> to continue, <Ctrl-Z) to exit..." with no advancing
			accept 	ws-dummy
				at end	set return-status to success
			end-accept
			if	term-width-changed
			then	perform e075-reset-width
			end-if
		end-if
	end-if.
	close report-file.
*
e050-terminal-width.
*
	call "sys$assign"
		using by	descriptor	"TT:"
				reference	ws-channel
				value		0
						0
		giving			return-status.
	if	return-status success
	then	call "sys$qiow"
			using by	value		0
							ws-channel
							ws-function-sense
					reference	ws-io-status-block
	       				value		0
							0
					reference	ws-char-buf
					value		0
							0
							0
							0
							0
			giving			return-status
		if	return-status success
		then	if	ws-term-width not equal 132
			then	set term-width-changed to true
				move ws-term-width to ws-save-width
				move 132 to ws-term-width
				call "sys$qiow"
					using by	value		0
									ws-channel
									ws-function-set
							reference	ws-io-status-block
							value		0
									0
							reference	ws-char-buf
	       						value		0
									0
									0
									0
									0
					giving			return-status
			else	set term-width-unchanged to true
			end-if
			if	return-status success
			then	write report-line
					from terminal-set
			end-if
		end-if
	end-if.
*
e075-reset-width.
*
	move ws-save-width to ws-term-width.
	call "sys$qiow"
		using by	value		0
						ws-channel
						ws-function-set
				reference	ws-io-status-block
				value		0
						0
				reference	ws-char-buf
				value		0
						0
						0
						0
						0
		giving			return-status.
	if	return-status success
	then	write report-line
			from terminal-reset
	end-if.
*
e100-write-headings.
*
	write report-line
		from		rpt-heading-1
		after		advancing 1 lines.
	write report-line
		from		rpt-heading-4
		after		advancing 1 lines.
	write report-line
		from		rpt-heading-2
		after		advancing 1 lines.
	write report-line
		from		rpt-heading-3
		after		advancing 1 lines.
	write report-line
		from		rpt-heading-4
		after		advancing 1 lines.
*
e200-write-detail.
*
	move 0 to ws-line-cnt.
	perform	varying	ws-jpi-index
		from	1
		by	1
		until	ws-jpi-index greater than ws-count-process
		move spaces to rpt-prcnam
		move ws-prcnam (ws-jpi-index) (1:ws-prcnam-len (ws-jpi-index)) to rpt-prcnam
		move spaces to rpt-terminal
	       	move ws-username (ws-jpi-index) (1:ws-username-len (ws-jpi-index)) to rpt-username
		inspect rpt-username replacing all ws-null-1 by spaces
		move spaces to rpt-terminal
	       	move ws-terminal (ws-jpi-index) (1:ws-terminal-len (ws-jpi-index)) to rpt-terminal
		move ws-pri (ws-jpi-index) to rpt-pri
		move ws-prib (ws-jpi-index) to rpt-prib
		call	"ots$cvt_l_tz"
				using	by	reference	ws-pid (ws-jpi-index)
						descriptor	rpt-pid
				giving				return-status
		if	return-status success
		then	inspect rpt-pid replacing leading zeros by spaces
			add ws-ppgcnt (ws-jpi-index), ws-gpgcnt (ws-jpi-index) giving rpt-wssize
			move ws-imagecount (ws-jpi-index) to rpt-imagecount
			if	ws-mode (ws-jpi-index) equal 0
			then	if	ws-owner (ws-jpi-index) equal 0
				then	move "Oth" to rpt-mode
				else	move "Spw" to rpt-mode
				end-if
			else	if	ws-mode (ws-jpi-index) equal 1
				then	move "Net" to rpt-mode
				else	if	ws-mode (ws-jpi-index) equal 2
					then	move "Bat" to rpt-mode
					else	if	ws-mode (ws-jpi-index) equal 3
						then	if	ws-owner (ws-jpi-index) equal 0
							then	move "Int" to rpt-mode
							else	move "Spw" to rpt-mode
							end-if
						else	if	ws-mode (ws-jpi-index) equal 4
							then	if	ws-owner (ws-jpi-index) equal 0
								then	move "Dia" to rpt-mode
								else	move "Spw" to rpt-mode
								end-if
							else	if	ws-mode (ws-jpi-index) equal 5
								then	if	ws-owner (ws-jpi-index) equal 0
									then	move "Rmt" to rpt-mode
									else	move "Spw" to rpt-mode
									end-if
								end-if
							end-if
						end-if
					end-if
				end-if
			end-if
			subtract ws-filcnt (ws-jpi-index) from ws-fillm (ws-jpi-index) giving rpt-filecnt
			divide ws-cputim (ws-jpi-index) by 100 giving ws-new-cputim 
			divide ws-new-cputim by 60 giving ws-new-cputim remainder ws-cpu-s
			divide ws-new-cputim by 60 giving ws-cpu-h remainder ws-cpu-m
			move ws-cpu-time to rpt-cputim
			call	"sys$asctim"
				using	by	value		0
						descriptor	ws-time-str
						reference	ws-logintim (ws-jpi-index)
						value		0
				giving				return-status
			if	return-status success
			then	move ws-time-dd-mmm to ws-login-dd-mmm
				move ws-time-hh-mm to ws-login-hh-mm
				move ws-login-time to rpt-logintim
				call	"ots$cvt_l_to"
					using	by	reference	ws-grp (ws-jpi-index)
							descriptor	ws-octal-grp
							value		9
					giving				return-status
				if	return-status success
				then	move ws-octal-grp to rpt-grp
					call	"ots$cvt_l_to"
						using	by	reference	ws-mem (ws-jpi-index)
						      		descriptor	ws-octal-mem
								value		9
	  					giving				return-status
					if	return-status success
					then	move ws-octal-mem to rpt-mem
						perform e210-image-name
					end-if
				end-if
			end-if
		end-if
		write report-line
			from		rpt-detail
			after		advancing 1 lines
    		if	dest-terminal
		   and	page-qualifier
		then	add 1 to ws-line-cnt
			if	ws-line-cnt greater than 16
			then	display "Press <Enter/Return> to continue, <Ctrl-Z) to exit..." at column 1 at line 24
				accept 	ws-dummy
					at end	set return-status to success
						set ws-jpi-index to ws-count-process
						set ws-jpi-index up by 1
				end-accept
				if	ws-jpi-index less than ws-count-process
				then	perform e100-write-headings
					move 0 to ws-line-cnt
				end-if
			end-if
		end-if
	end-perform.
*
e210-image-name.
*
	if	ws-imagname-len (ws-jpi-index) less than 37
	then	move ws-imagname (ws-jpi-index) to rpt-imagname
	else	move zero to ws-tally
		inspect ws-imagname (ws-jpi-index) tallying ws-tally for characters before "["
		add 1 to ws-tally
		subtract ws-tally from ws-imagname-len (ws-jpi-index) giving ws-size-left
		if	ws-size-left less than 37
		then	move ws-imagname (ws-jpi-index) (ws-tally:ws-size-left) to rpt-imagname
		else	move zero to ws-tally
			inspect ws-imagname (ws-jpi-index) tallying ws-tally for characters before "]"
			add 2 to ws-tally
			subtract ws-tally from ws-imagname-len (ws-jpi-index) giving ws-size-left
			move ws-imagname (ws-jpi-index) (ws-tally:ws-size-left) to ws-wrk-str
			move zero to ws-tally
			inspect ws-wrk-str tallying ws-tally for characters before "]"
			if	ws-tally not less than ws-size-left
			then	move ws-wrk-str (1:ws-size-left) to rpt-imagname
			else	add 2 to ws-tally
				move ws-wrk-str (ws-tally:ws-size-left) to rpt-imagname
			end-if
		end-if
	end-if.
*
u000-initialize.
*
	set return-status to success.
	call "lib$date_time"
		using	by	descriptor	rpt-date-time
		giving				return-status.
	if	return-status success
	then	call "lib$day_of_week"
			using	by	value		0
					reference	ws-sub
			giving				return-status
		if	return-status success
		then	move ws-weekday (ws-sub) to rpt-dow
		end-if
	end-if.
	if	return-status success
	then	call	"lib$sys_trnlog"
			using	by	descriptor	"SYS$NODE"
					value		0
					descriptor	rpt-node
					value		0
							0
							0
			giving				return-status
		if	return-status equal ws-ss-notran
		then	set return-status to success
			move "Unknown" to rpt-node
		end-if
	end-if.
	if	return-status success
	then	perform u100-get-qualifiers
	end-if.
*
u100-get-qualifiers.
*
	call	"lib$get_foreign"
		using	by	descriptor	ws-qualifiers
				value		0
				reference	ws-qualifier-len
				value		0
		giving				return-status.
	if	return-status success
	then	perform u110-find-output
		perform u120-find-sort
		perform u130-find-id
		perform u140-find-job
	end-if.
*
u110-find-output.
*
	move zero to ws-tally.
	inspect ws-qualifiers tallying ws-tally for characters before "/OUT".
	if	ws-tally less than ws-qualifier-len
	then	set dest-file to true
		subtract ws-tally from ws-qualifier-len giving ws-size-left
		add 1 to ws-tally
		move ws-qualifiers (ws-tally:ws-size-left) to ws-wrk-str
		move zero to ws-tally, ws-tally2
		inspect ws-wrk-str tallying ws-tally for characters before "="
		inspect ws-wrk-str tallying ws-tally2 for characters before "/"
		if	(ws-tally not less than ws-tally2 and ws-tally2 not equal 0)
		   or	ws-tally not less than ws-size-left
		then	move file-report-name-default to file-report-name
		else	add 1 to ws-tally
			subtract ws-tally from ws-size-left
			add 1 to ws-tally
			move ws-wrk-str (ws-tally:ws-size-left) to ws-wrk-str
			move zero to ws-tally
			inspect ws-wrk-str tallying ws-tally for characters before "/"
			if	ws-tally not less ws-size-left
			then	move zero to ws-tally
				inspect ws-wrk-str tallying ws-tally for characters before " "
				if	ws-tally not less ws-size-left
				then	move ws-size-left to ws-tally
				end-if
			end-if
			move ws-wrk-str (1:ws-tally) to file-report-name
		end-if
	else	set dest-terminal to true
		perform u111-find-page
	end-if.
*
u111-find-page.
*
	move zero to ws-tally.
	inspect ws-qualifiers tallying ws-tally for characters before "/PAG".
	if	ws-tally less than ws-qualifier-len
	then	set page-qualifier to true
	else	set no-page-qualifier to true
	end-if.
*
u120-find-sort.
*
	move zero to ws-tally.
	inspect ws-qualifiers tallying ws-tally for characters before "/SOR".
	if	ws-tally less than ws-qualifier-len
	then	subtract ws-tally from ws-qualifier-len giving ws-size-left
		add 1 to ws-tally
		move ws-qualifiers (ws-tally:ws-size-left) to ws-wrk-str
		move zero to ws-tally, ws-tally2
		inspect ws-wrk-str tallying ws-tally for characters before "="
		inspect ws-wrk-str tallying ws-tally2 for characters before "/"
		if	(ws-tally not less than ws-tally2 and ws-tally2 not equal 0)
		   or	ws-tally not less than ws-size-left
		then	set sort-qualifier-username to true
		else	add 1 to ws-tally
			subtract ws-tally from ws-size-left
			add 1 to ws-tally
			move ws-wrk-str (ws-tally:ws-size-left) to ws-wrk-str
			move zero to ws-tally
			inspect ws-wrk-str tallying ws-tally for characters before "/"
			if	ws-tally not less ws-size-left
			then	move zero to ws-tally
				inspect ws-wrk-str tallying ws-tally for characters before " "
				if	ws-tally not less ws-size-left
				then	move ws-size-left to ws-tally
				end-if
			end-if
			if	ws-wrk-str (1:ws-tally) equal "PRCNAM"
			then	set sort-qualifier-prcnam to true
			else	if	ws-wrk-str (1:ws-tally) equal "UIC"
				then	set sort-qualifier-uic to true
				else	if	ws-wrk-str (1:ws-tally) equal "PORT"
					then	set sort-qualifier-port to true
					else	if	ws-wrk-str (1:ws-tally) equal "IMAGE"
						then	set sort-qualifier-image to true
						else	set sort-qualifier-username to true
						end-if
					end-if
				end-if
			end-if
		end-if
	else	set sort-qualifier-username to true
	end-if.
*
u130-find-id.
*
	move zero to ws-tally.
	inspect ws-qualifiers tallying ws-tally for characters before "/ID".
	if	ws-tally less than ws-qualifier-len
	then	set id-qualifier-yes to true
		subtract ws-tally from ws-qualifier-len giving ws-size-left
		add 1 to ws-tally
		move ws-qualifiers (ws-tally:ws-size-left) to ws-wrk-str
		move zero to ws-tally, ws-tally2
		inspect ws-wrk-str tallying ws-tally for characters before "="
		inspect ws-wrk-str tallying ws-tally2 for characters before "/"
		if	(ws-tally not less than ws-tally2 and ws-tally2 not equal 0)
		   or	ws-tally not less than ws-size-left
		then	set id-qualifier-no to true
			move ws-pidadr-default to ws-pidadr
		else	add 1 to ws-tally
			subtract ws-tally from ws-size-left
			add 1 to ws-tally
			move ws-wrk-str (ws-tally:ws-size-left) to ws-wrk-str
			move zero to ws-tally
			inspect ws-wrk-str tallying ws-tally for characters before "/"
			if	ws-tally not less ws-size-left
			then	move zero to ws-tally
				inspect ws-wrk-str tallying ws-tally for characters before " "
				if	ws-tally not less ws-size-left
				then	move ws-size-left to ws-tally
				end-if
			end-if
			if    	ws-tally equal 2
			then	move ws-wrk-str (1:ws-tally) to ws-id-2
				call	"ots$cvt_tz_l"
					using	by	descriptor	ws-id-2
							reference	ws-id
							value		4
									0
					giving				return-status
			else	if	ws-tally equal 3
				then	move ws-wrk-str (1:ws-tally) to ws-id-3
					call	"ots$cvt_tz_l"
						using	by	descriptor	ws-id-3
								reference	ws-id
								value		4
										0
						giving				return-status
				else	if	ws-tally equal 4
					then	move ws-wrk-str (1:ws-tally) to ws-id-4
						call	"ots$cvt_tz_l"
							using	by	descriptor	ws-id-4
									reference	ws-id
									value		4
											0
							giving				return-status
					else	move ws-wrk-str (1:ws-tally) to ws-id-str
						call	"ots$cvt_tz_l"
							using	by	descriptor	ws-id-str
									reference	ws-id
									value		4
											0
							giving				return-status
					end-if
				end-if
			end-if
			if	return-status success
			then	move ws-id to ws-pidadr
			end-if
		end-if
	else	set id-qualifier-no to true
		move ws-pidadr-default to ws-pidadr
	end-if.
*
u140-find-job.
*
	move zero to ws-tally.
	inspect ws-qualifiers tallying ws-tally for characters before "/ALL".
	if	ws-tally less than ws-qualifier-len
	then	set job-qualifier-yes to true
	else	if	id-qualifier-yes
		then	set job-qualifier-yes to true
		else	set job-qualifier-no to true
		end-if
	end-if.
*
*******************************************************************************
*
