$ v = f$verify ()
$ !set nover
$ ! TPCOUT.COM - command file to write copies of tapes from TPC images.
$ !
$ ! Calling Sequence:
$ !	@TPCOUT { dens } name name name name ...
$ !
$ ! Where:
$ !	dens - tape density: either 1600 or 6250
$ !	name - name of the TPC image to write (from disk$scratch:[TAPES]).
$ !
$ set command [costello.lib]tpc
$ number = 1
$ dens = ""
$ if p1 .eqs. "1600" then dens = "/dens=1600"
$ if p1 .eqs. "6250" then dens = "/dens=6250"
$ if dens .nes. "" then number = 2
$ if p1 .eqs. "" then dens = "/dens=1600"
$1:
$ name = p'number'
$ if name .eqs. "" then $ exit
$ comment = """Mount blank tape for writing "+name+"."""
$ mou mu:/for'dens'/comment='comment'/cache=tape_data
$ write sys$output "writing "+name+" ..."
$ tpc disk$scratch:[tapes]'name'.tap mu:
$ dism mu:
$ number = number + 1
$ goto 1
