$ v = f$verify (0)
$ ! VAXOUT.COM - command file to write (multiple backup sets on) a VAX SIG tape.
$ !
$ ! Calling Sequence:
$ !	@VAXOUT dens yrt yrt yrt yrt ...
$ !
$ ! Where:
$ !	dens - tape density to use (1600 or 6250)
$ !	yrt - name of directory tree to backup (eg, VAX00085A, VAX85A)
$ !
$ dens = p1
$ number = 2
$ tape = p'number' - "000"
$ assign disk$scratch disk
$ sd disk:[sigtapes]
$ comment="""Mount blank tape for writing "+tape+" VAX sig tape."""
$ mou mu:/for/comment='comment'/cache=tape_data
$ label_switch = "/label=" + tape
$ rew_switch = "/rew"
$next_set:
$ yrt = p'number'
$ if yrt .eqs. "" then $ goto end
$ if yrt - "000" .nes. yrt then $ goto vax000
$ if f$search ("[-]''yrt'.dir") .eqs. "" then $ rename []'yrt'.dir [-]
$ write sys$output "writing "+yrt+" ..."
$ backup/interchange'rew_switch'/dens='dens' ['yrt'...] mu:'yrt''label_switch'
$ rename [-]'yrt'.dir []
$ goto common
$vax000:
$ if f$search ("[-]vax000.dir") .eqs. "" then $ rename []'yrt'.dir [-]vax000
$ write sys$output "writing "+yrt+" ..."
$ backup/interchange'rew_switch'/dens='dens' [vax000...] mu:vax000'label_switch'
$ rename [-]vax000.dir []'yrt'
$common:
$ number = number + 1
$ label_switch = ""
$ rew_switch = "/norew"
$ goto next_set
$end:
$ dism mu:
$ deass disk
$ v = f$verify (v)
