$!.. FL.COM -- Create a list of files in a directory tree, sorted by file name
$! P1=root ("."=current directory)  [P2=output] (defaults to SYS$OUTPUT)
$	ON WARNING THEN GOTO DONE
$	ON CONTROL_Y THEN GOTO DONE
$	@MCOM:TYPO
$
$	IF P1 .EQS. "" THEN GOTO NO_P1
$	IF P1 .EQS. "." THEN P1 = F$DIRECTORY ()
$	ROOT = P1
$	L1 = F$LOCATE ("...", ROOT)
$	IF L1 .LT. F$LENGTH (ROOT) THEN ROOT = ROOT -"..."
$	ROOT = ROOT -"]" +"...]"
$
$	IF P2 .EQS. "" THEN P2 = "SYS$OUTPUT"
$	OPEN/WRITE  FO  'P2'
$	FOOPEN = "TRUE"
$	WRFO := WRITE FO
$	WRFO F$TIME (), T$TAB, "List of files in ", ROOT
$
$	NFILES = 0
$	TOTALQ = 0
$	F1OPEN = "FALSE"
$	F2OPEN = "FALSE"
$	F3OPEN = "FALSE"
$	TYPO "--DIRECTORY--
$	DIR/OUT=FL.TMP1/COL=1/NOHEAD/NOTRAIL 'ROOT'
$	OPEN/READ F1 FL.TMP1
$	F1OPEN = "TRUE"
$	OPEN/WRITE F2 FL.TMP2
$	F2OPEN = "TRUE"
$
$	TYPO "--extract name.type--"
$FLOOP:
$	READ  F1  FLINE /END=EOF1
$	FIL = F$PARSE (FLINE,,, "NAME") +F$PARSE (FLINE,,, "TYPE")
$	WRITE  F2  FIL
$	GOTO FLOOP
$EOF1:
$	CLOSE  F1
$	F1OPEN = "FALSE"
$	CLOSE  F2
$	F2OPEN = "FALSE"
$
$	TYPO "--SORT--"
$	SORT FL.TMP2 FL.TMP3 /KEY=(POS=1,SIZ=20)
$	OPEN  F3  FL.TMP3
$	F3OPEN = "TRUE"
$
$	TYPO "--list of duplicates--"
$	FIL0 = ""
$LOOP:
$	READ  F3  FIL1 /END=DONE
$	IF FIL1 .EQS. FIL0 THEN GOTO LOOP
$	IF FIL1 .EQS. P2 THEN GOTO LOOP
$	FIL0 = FIL1
$	SPEC1 = F$SEARCH (ROOT +FIL1, 1)
$	TYP1 = F$PARSE (SPEC1,,, "TYPE")
$	IF TYP1 .EQS. ".DIR" THEN GOTO LOOP
$	WRFO T$LF, FIL1
$LOOP2:
$	ON ERROR THEN GOTO L2_ERR
$	SPEC2 = F$SEARCH (ROOT +FIL1 +";*", 2)
$	IF SPEC2 .EQS. "" THEN GOTO LOOP2_DONE
$	FIL2 = F$PARSE (SPEC2,,, "NAME") +F$PARSE (SPEC2,,, "TYPE")
$	DIR2 = SPEC2 -FIL2
$	WRFO T$TAB, DIR2
$
$	CDT2 = F$FILE_ATTRIBUTE (SPEC2, "CDT")
$	ALQ2 = F$FILE_ATTRIBUTE (SPEC2, "ALQ")
$	FID2 = F$FILE_ATTRIBUTE (SPEC2, "FID")
$	WRFO T$TAB, "  ", CDT2, T$TAB, ALQ2, T$TAB, FID2
$
$	NFILES = NFILES +1
$	TOTALQ = TOTALQ +ALQ2
$	GOTO LOOP2
$
$LOOP2_DONE:
$	ON WARNING THEN GOTO DONE
$	GOTO LOOP
$
$L2_ERR:
$	XSTAT = $STATUS
$	ON ERROR THEN GOTO L2_ERR
$	WRFO T$TAB, "file access error"
$	WRFO F$FAO ("!_!AS !AS", XSTAT, F$MESSAGE (XSTAT))
$	GOTO LOOP2
$
$NO_P1:
$	WRITE SYS$OUTPUT "%FILIST-F-NOP1, missing parameter: directory root"
$	EXIT
$
$DONE:
$	WRFO T$LF, NFILES, " files", T$TAB, TOTALQ, " blocks in ", ROOT
$	DEASSIGN   SYS$OUTPUT
$	IF F1OPEN THEN CLOSE F1
$	IF F2OPEN THEN CLOSE F2
$	IF F3OPEN THEN CLOSE F3
$	IF FOOPEN THEN CLOSE FO
$	DELETE   FL.TMP1;*,FL.TMP2;*,FL.TMP3;*
$EXIT
