$!..GEN_ASCII.COM -- Generate list of ASCII codes
$
$	ON WARNING THEN GOTO ER1
$	ON CONTROL_Y THEN GOTO CTLY
$	OPEN/WRITE  ALIST  ASCII256.LIS
$	TYPO := WRITE ALIST
$
$	NAMES = "NUL SOH STX ETX EOT ENQ ACK BEL BS HT LF VT FF " -
		+"CR SO SI DLE DC1 DC2 DC3 DC4 NAK SYN ETB CAN EM " -
		+"SUB ESC FS GS RS US SP"
$	DMCS_NAMES = "IND NEL SSA ESA HTS HTJ VTS PLD PLU RI SS2 SS3 " -
		+"DCS PU1 PU2 STS CCH MW SPA EPA . . . CSI ST OSC PM APC"
$
$	HDG = "Binary-- Oct Dec  Hx Char"
$	TYPO F$FAO ("!4(32AS)", HDG, HDG, HDG, HDG)
$
$	LAST1 = 63
$	CODE = 0
$LOOP:
$	CODE1 = CODE
$	CODE2 = CODE1 +64
$	CODE3 = CODE2 +64
$	CODE4 = CODE3 +64
$	GOSUB GET_CODE
$	COL1 = COL
$	CODE = CODE2
$	GOSUB GET_CODE
$	COL2 = COL
$	CODE = CODE3
$	GOSUB GET_CODE
$	COL3 = COL
$	CODE = CODE4
$	GOSUB GET_CODE
$	COL4 = COL
$
$	WRITE SYS$OUTPUT F$FAO ("!4(5UB)", CODE1, CODE2, CODE3, CODE4)
$	TYPO F$FAO ("!4(32AS)", COL1, COL2, COL3, COL4)
$
$	CODE = CODE1 +1
$	IF CODE .LE. LAST1 THEN GOTO LOOP
$ER1:
$CTLY:
$	CLOSE ALIST
$EXIT
$
$GET_CODE:	!gosubroutine
$	COL = ""
$	IF CODE .GT. 255 THEN RETURN
$
$	BITN = 128
$	BINARY = ""
$BLOOP:		!convert to binary
$	BIT = CODE .AND. BITN
$	IF BIT .EQ. 0 THEN BINARY = BINARY +"0"
$	IF BIT .NE. 0 THEN BINARY = BINARY +"1"
$
$	IF BITN .EQ. 1 THEN GOTO BDONE
$	BITN = BITN/2
$	GOTO BLOOP
$BDONE:
$
$	CHAR = "  "
$	NM = ""
$	CHAR[0,8] = CODE
$	IF CODE .GT. 31 THEN GOTO OUT_OF_CONTROL
$		CHAR = "^"
$		CHAR[8,8] = CODE .OR. %X40
$OUT_OF_CONTROL:
$	IF CODE .EQ. 31 THEN CHAR = "^_"
$	IF CODE .EQ. 32 THEN CHAR = "  "
$	IF CODE .LE. 32 THEN NM = " " +F$ELEMENT (CODE, " ", NAMES)
$	IF CODE .EQ. 127 THEN CHAR = ".."
$	IF CODE .EQ. 127 THEN NM = " DEL"
$	IF CODE .EQ. 128 THEN NM = " ///"
$	IF CODE .GE. 128  .AND.  CODE .LE. 159 THEN CHAR = ".."
$	IF CODE .GE. 132  .AND.  CODE .LE. 159 THEN -
		NM = " " +F$ELEMENT (CODE-131, " ", DMCS_NAMES)
$	IF NM .EQS. " ." THEN NM = ""
$	IF CODE .EQS. 255 THEN CHAR = ".."
$	IF CODE .EQS. 255 THEN NM = " ///"
$
$	COL = F$FAO ("!8AS !3OB !3UB. !2XB !2AS!AS", -
		BINARY, CODE, CODE, CODE, CHAR, NM)
$
$	RETURN	!from GET_CODE
