$!..OPERSECURITY.COM -- read OPERATOR.LOG for Security Alarms
$!both parameters optional -- P1 "IGNORE" -- P2 log file spec
$!defaults: P1="NOIGNORE" -- P2="SYS$MANAGER:OPERATOR.OLD"
$	VERIFY = F$VERIFY (0)
$
$	ASSIGN/NOLOG  USR$DISK1:[MAUS.]  MTOP /TRANS=CONCEALED
$	ASSIGN/NOLOG  MTOP:[COM]  MCOM
$	IF P1 .EQS. "" THEN P1 = "~"
$	IF P2 .EQS. "" THEN P2 = "~"
$	@MCOM:MSUBMIT  MCOM:OPERSECURITY.COM  ADCALC_BATCH  "" -
		"/PARAMETER=(''P1',''P2')"
$
$!these are the images that may be ignored (must match image name in
$!  OPERATOR.LOG)
$	LOGINOUT := $1$DUA0:[SYS1.SYSCOMMON.][SYSEXE]LOGINOUT.EXE
$	DIRECTORY := $1$DUA0:[SYS1.SYSCOMMON.][SYSEXE]DIRECTORY.EXE
$	MAIL := $1$DUA0:[SYS1.SYSCOMMON.][SYSEXE]MAIL.EXE
$	BACKUP := $1$DUA0:[SYS1.SYSCOMMON.][SYSEXE]BACKUP.EXE;2
$	SETP0 := $1$DUA0:[SYS1.SYSCOMMON.][SYSEXE]SETP0.EXE
$	SUBMIT := $1$DUA0:[SYS1.SYSCOMMON.][SYSEXE]SUBMIT.EXE
$	GETUAF := _$1$DUA0:[FERMI.][EXE]GETUAF.EXE
$	FINGER := _$1$DUA0:[FERMI.][EXE]FINGER.EXE
$
$	ON WARNING THEN GOTO ER1
$	ON CONTROL_Y THEN GOTO CTLY
$
$	@USR$DISK1:[MAUS.COM]TYPO
$	TYPO "[OPERSECURITY ", F$TIME(), " ]"
$
$	IGNORE = "FALSE"
$	IF F$EXTRACT (0,2, P1) .EQS. "IG" THEN IGNORE = "TRUE"
$	IF P2 .EQS. "~" THEN P2 = ""
$	P2 = F$PARSE (P2, "SYS$MANAGER:OPERATOR.OLD",,)
$	LOGFILE = F$SEARCH (P2)
$	IF LOGFILE .NES. "" THEN GOTO P2OK
$		TYPO "%OPERSECU-F-FNOTFND, log file /", P2, "/ not found."
$		GOTO ER1
$P2OK:
$
$	LOPEN = "FALSE"
$	OPEN/READ/SHARE  LOG  'LOGFILE'
$	LOPEN = "TRUE"
$
$	TYPO "  Input from: ", LOGFILE
$	TYPO "  Revision date/time: ", F$FILE_ATTRIBUTE (LOGFILE, "RDT")
$	IF .NOT. IGNORE THEN GOTO INTRO_DONE
$	TYPO "  Ignoring some alarms:"
$	TYPO "    Any alarm showing successful access to file SYSUAF"
$	TYPO "    by various specific images will be shown with two"
$	TYPO "    summary lines and no stop."
$INTRO_DONE:
$
$	TOP_FLAG = "FALSE"
$	SECUR_FLAG = "FALSE"
$	PROG_COUNT = 100	!report progress every PROG_COUNT message
$	PROG = 1		!report the first message
$	COUNT = 0
$	N = 0
$IN_LOOP:
$	READ  LOG  LINE /END=EOF
$	L1 = F$EDIT (F$EXTRACT (0, 5, LINE), "UPCASE,TRIM")
$	IF L1 .EQS. "%%%%%" THEN GOTO TOP_LINE
$	IF L1 .EQS. "SECUR" THEN GOTO S_ALARM
$
$	IF TOP_FLAG THEN GOTO SECOND_LINE
$	IF SECUR_FLAG THEN GOTO SAVE_IT
$	GOTO IN_LOOP
$
$SECOND_LINE:
$	TOP_FLAG = "FALSE"
$	IF SECUR_FLAG THEN GOTO SAVE_IT
$	N = 0
$	GOTO IN_LOOP
$
$S_ALARM:
$	IF .NOT. TOP_FLAG THEN GOTO IN_LOOP
$	SECUR_FLAG = "TRUE"
$	GOTO SAVE_IT
$
$TOP_LINE:
$	COUNT = COUNT +1
$	PROG = PROG -1
$	IF PROG .GT. 0 THEN GOTO PROG_DONE
$	PROG = PROG_COUNT
$	TYPO F$FAO ("  progressed to message !5SL, !AS", COUNT, -
		F$EXTRACT (20, 17, LINE))
$PROG_DONE:
$	IF N .GT. 0 THEN GOSUB OUTPUT_MSG
$	TOP_FLAG = "TRUE"
$	SECUR_FLAG = "FALSE"
$	N = 0
$SAVE_IT:
$	N = N +1
$	SA'N' = LINE
$	GOTO IN_LOOP
$
$OUTPUT_MSG:	!gosubroutine
$	IF .NOT. IGNORE THEN GOTO SHOW_IT
$	  L1 = F$LOCATE (" / ", SA2)
$	  IF L1 .GE. F$LENGTH (SA2) THEN GOTO SHOW_IT
$	  SUCCESS = F$EXTRACT (L1+3, 6, F$EDIT (SA2, "TRIM,UPCASE,COMPRESS"))
$	  IF SUCCESS .NES. "SUCCES" THEN GOTO SHOW_IT
$	  LX = F$EDIT (SA7, "TRIM,UPCASE,COMPRESS")
$	  L1 = F$ELEMENT (1, " ", LX)
$	  LX = F$PARSE (L1,,, "NAME")
$	  IF LX .NES. "SYSUAF" THEN GOTO SHOW_IT
$	  LX = F$EDIT (SA8, "TRIM,UPCASE,COMPRESS")
$	  MODE = F$EXTRACT (6, 99, LX)
$	  LX = F$EDIT (SA5, "TRIM,UPCASE,COMPRESS")
$	  USR = F$ELEMENT (2, " ", LX)
$	  LX = F$EDIT (SA6, "TRIM,UPCASE,COMPRESS")
$	  IMG = F$ELEMENT (1, " ", LX)
$	  IF IMG .EQS. LOGINOUT THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. DIRECTORY THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. MAIL THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. BACKUP THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. GETUAF THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. FINGER THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. SETP0 THEN GOTO OUTPUT_SHORT
$	  IF IMG .EQS. SUBMIT THEN GOTO OUTPUT_SHORT
$SHOW_IT:
$	TYPO T$LF, "----------------------------------------"
$	TYPO "  message ", COUNT, ", ", N, " lines, from ", LOGFILE
$	LIMIT = N
$	N = 0
$OUT_LOOP:
$	N = N +1
$	IF N .GT. LIMIT THEN GOTO OUT_DONE
$	TYPO SA'N'
$	GOTO OUT_LOOP
$OUT_DONE:
$	TYPO T$LF, "----------------------------------------"
$	READ SYS$COMMAND P8 /END=CTLZ/PROMPT="press RETURN to continue> "
$	TYPO " "
$	RETURN	!from OUTPUT_MSG
$OUTPUT_SHORT:
$	LX = F$EXTRACT (20, 23, SA1)	!get date/time
$	TYPO "  ", LX, " #", COUNT, ": ", MODE, " of SYSUAF by ", USR
$	TYPO "    with ", IMG
$	RETURN	!from OUTPUT_MSG
$
$EOF:
$	TYPO T$LF, "  EOF after message ", COUNT, ", in ", LOGFILE
$CTLY:
$CTLZ:
$ER1:
$	IF LOPEN THEN CLOSE LOG
$	TYPO "[exit OPERSECURITY]
$	VERIFY = F$VERIFY (VERIFY)
$EXIT
==============================================================================
 8-SEP-1987

	@OPERSECURITY [keyword] [input_file_spec]

[keyword] is an optional keyword to modify the performance of this procedure.
	There is only one keyword, "IGNORE".  Anything else is ignored.  If
	P2 is specified and P1 is to be omitted, use any character (for example
	period ".") to hold its place.  "IGNORE" may be abbreviated to "IG".
	Upper or lower case is allowed.

[input_file_spec] is optioanlly, the specification of the OPERATOR.LOG file
	that is used for input.  If omitted, it defaults to
	SYS$MANAGER:OPERATOR.OLD.  If any portion of the file spec is given,
	the remaining parts will be taken from SYS$MANAGER:OPERATOR.OLD.

OPERSECURITY starts by displaying a SUBMIT command and prompting about how
it is to run: not at all, queued to ADCALC_BATCH, or interactively.  A response
of "I" will cause it to run interactively with output to the terminal.  "Y"
response causes the procedure to be submitted with output to OPERSECURITY.LOG.
"N" response will cause exit.

--Logic description------------------------------------------------------------
  1) read a line
  2) if first line of new message (%%%%%), continue at (7)
  3) if "Security alarm", continue at (12)
  4) if TOP_FLAG, continue at (15)  !should only be true for second line
  5) if SECUR_FLAG, continue at (10)
  6) goto (1)  !do not save line
  7) report progress (maybe); if there are saved lines, display them
  8) reset line counter to zero; reset SECUR_FLAG
  9) set TOP_FLAG  !indicates first line of message
 10) save line; increment line counter
 11) goto (1)
 12) if not TOP_FLAG, goto (1)  !is this the second line?
 13) set SECUR_FLAG  !marks security alarm messages
 14) goto (10)  !save it
 15) reset TOP_FLAG
 16) if SECUR_FLAG, goto (10)  !save it, if this is a line from security alarm
 17) reset line counter to zero
 18) goto (1)  !do not save line

[end of OPERSECURITY.COM]
