$! WHO_COMMAND.COM -- D.J.Maus 8/86
$! Put the WHO command into system table
$
$	ON CONTROL_Y THEN GOTO EXIT
$	ON WARNING THEN GOTO EXIT
$	SAY := WRITE SYS$OUTPUT
$	LF[0,8] = 10	!line feed character
$	SAY LF, "[WHO_COMMAND.COM ", F$TIME(), "]"
$	TYPE SYS$INPUT

  This procedure inserts or replaces the WHO command in the system-wide DCL
  command table.  A new command table is created and installed with default
  qualifiers.  Alternatively, the WHO command can be inserted into the process
  command table with this command:
	$ SET COMMAND WHO.CLD

  Execute this command procedure once for the original installation of WHO and
  anytime the command definition, WHO.CLD, changes.

$
$	SET COMMAND/TABLE=SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE -
		/OUTPUT=SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE -
		WHO
$	ON WARNING THEN GOTO EXIT
$	W_INST := $INSTALL/COMMAND
$	W_INST
		REPLACE   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE /OPEN/HEADER/SHARE
		LIST/FULL   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE
		EXIT
$	DIRECTORY   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE
$
$	READ/END=EXIT/PROMPT="  Purge DCLTABLES? (Y or N) > " -
			SYS$COMMAND   P1
$	IF .NOT. P1 THEN GOTO EXIT
$	PURGE/LOG/KEEP=1   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE
$
$EXIT:
$	EXIT !WHO_COMMAND
