$! WHO_INSTALL.COM -- D.J.Maus -- 8/86
$! WHO program compile, link, move .EXE, INSTALL, and SET COMMAND
$TYPE SYS$INPUT

		Untested.  Offered as a suggestion only.

$
$	ON CONTROL_Y THEN GOTO EXIT
$	ON WARNING THEN GOTO EXIT
$	SAY := WRITE SYS$OUTPUT
$	LF[0,8] = 10	!line feed character
$	SAY LF, "[WHO_INSTALL ", F$TIME(), "]"
$
$DEST_PROMPT:
$	SAY LF, "  Enter destination specification for the WHO.EXE file."
$	READ/END=EXIT/PROMPT="  Default is SYS$SYSTEM:WHO.EXE > " -
			SYS$COMMAND   P1
$	WHO_EXE = F$PARSE (P1, "SYS$SYSTEM:WHO.EXE")
$	IF WHO_EXE .EQS. "" THEN GOTO DEST_PROMPT
$	SAY "    Destination is: ", WHO_EXE
$
$	TYPE SYS$INPUT

				* NOTE *
		The WHO command definition need only be inserted
		once at the time of original installation and
		again whenever the command definition, WHO.CLD,
		changes. 

$CMD_PROMPT:
$	SAY	"  Do you want this procedure to insert the WHO command"
$	SAY	"  definition into the system-wide DCL command table,"
$	SAY	"  SYS$LIBRARY:DCLTABLES.EXE?"
$	READ/END=EXIT/PROMPT="  Yes or No > "   SYS$COMMAND   P1
$	WHO_CMD = F$EDIT (F$EXTRACT (0,1, P1), "UPCASE")
$	IF WHO_CMD .EQS. "Y" THEN GOTO CMD_OK
$	IF WHO_CMD .NES. "N" THEN GOTO CMD_PROMPT
$CMD_OK:
$
$HLP_PROMPT:
$	SAY LF, "  Enter help library specification into which WHO.HLP is to"
$	SAY	"  be inserted (or NONE for no insertion)."
$	READ/END=EXIT/PROMPT="  Default is SYS$HELP:HELPLIB.HLB > " -
			SYS$COMMAND   P1
$	WHO_HLP = F$EDIT (P1, "TRIM,UPCASE")
$	IF WHO_HLP .EQS. "NONE" THEN GOTO HLP_OK
$	WHO_HLP = F$PARSE (P1, "SYS$HELP:HELPLIB.HLB")
$	IF F$SEARCH (WHO_HLP) .EQS. "" THEN GOTO HLP_PROMPT
$	SAY "    Help library is: ", WHO_HLP
$HLP_OK:
$
$	SAY LF, "  Do you want this procedure to DELETE/PURGE unneeded files"
$	SAY 	"  after installation?"
$CLN_PROMPT:
$	READ/END=EXIT/PROMPT="  Yes or No > "   SYS$COMMAND   P1
$	CLEAN_UP = F$EDIT (F$EXTRACT (0,1, P1), "UPCASE")
$	IF CLEAN_UP .EQS. "Y" THEN GOTO CLN_OK
$	IF CLEAN_UP .NES. "N" THEN GOTO CLN_PROMPT
$CLN_OK:
$
$	SAY "  Compiling."
$	ON WARNING THEN GOTO EXIT
$	FORTRAN/NODEBUG   WHO
$
$	SAY "  Linking."
$	ON WARNING THEN GOTO EXIT
$	LINK/NODEBUG/NOTRACE   WHO
$
$	IF WHO_HLP .EQS. "NONE" THEN GOTO HLP_DONE
$	SAY "  Adding WHO.HLP to library."
$	LIBRARY/LOG/HELP   'WHO_HLP'   WHO.HLP
$HLP_DONE:
$
$	SAY "  Moving WHO.EXE file to destination."
$	ON WARNING THEN GOTO EXIT
$	COPY/LOG   WHO.EXE   'WHO_EXE'
$
$	SAY "  Installing WHO image."
$	ON WARNING THEN CONTINUE
$	W_INST := $SYS$SYSTEM:INSTALL/COMMAND
$	W_INST REPLACE 'WHO_EXE'/PRIVILEGE=WORLD
$
$	IF .NOT. WHO_CMD THEN GOTO CMD_DONE
$	SAY "  Inserting WHO command."
$	ON WARNING THEN GOTO EXIT
$	SET COMMAND/TABLE=SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE -
		/OUTPUT=SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE -
		WHO
$
$	SAY "  Installing DCLTABLES."
$	ON WARNING THEN GOTO EXIT
$	W_INST
		REPLACE   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE /OPEN/HEADER/SHARE
		LIST/FULL   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE
		EXIT
$CMD_DONE:
$
$	IF .NOT. CLEAN_UP THEN GOTO CLN_DONE
$	SAY "  Cleaning up unneeded files."
$	DELETE/LOG   WHO.OBJ;*, WHO.EXE;*
$	WHO_EXE = F$ELEMENT (0, ";", WHO_EXE)	!remove version for PURGE
$	PURGE/LOG/KEEP=1   'WHO_EXE'
$	IF WHO_CMD THEN PURGE/LOG/KEEP=1   SYS$SYSROOT:[SYSLIB]DCLTABLES.EXE
$CLN_DONE:
$
$EXIT:
$	SAY "[WHO_INSTALL exit]"
$	EXIT !WHO_INSTALL
