$! DECAL2.COM	START DECALC
$! 
$! This our command file for starting a user DECALC session.
$! 
$! It is set up to run v2 and v3 parallel and accept passwords for the
$! conversion.
$! 
$	ON ERROR THEN GOTO BOMBER
$
$	ON CONTROL_Y 	THEN GOTO BOMBER
$
$	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$! Define the users common directory:
$
$	IF F$TRNLNM("DECALC$COMMON","LNM$PROCESS") .NES. "" THEN -
							GOTO START_DECALC
$
$	USER = F$EDIT(F$GETJPI("","USERNAME"),"COLLAPSE") ! GET USERNAME
$
$	IF USER .EQS. "user1"	.OR. -
	   USER .EQS. "user2"	THEN GOTO SET_ADMIN
$
$	IF USER .EQS. "user3"	.OR. -
	   USER .EQS. "user4"	THEN GOTO SET_FINANCE
$
$	GOTO START_DECALC
$
$ SET_ADMIN:
$
$	DEF/NOLOG DECALC$COMMON WORKA:[DECALC.ADMIN]
$
$	GOTO START_DECALC
$
$ SET_FINANCE:
$
$	DEF/NOLOG DECALC$COMMON WORKA:[DECALC.FINANCE]
$
$ START_DECALC:
$
$	GOSUB PSWD	! see if user wants to enter conversion passwords
$
$! 	See if user is allowed to run v3 now:
$
$	IF USER .EQS. "user1"	.OR. -
	   USER .EQS. "user2"	THEN GOTO START_V3
$
$ V22:	! start v2
$
$	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$	DECALC
$
$	EXIT 1
$
$ START_V3:
$	
$! 	Skip v3 prompt and convert if user does not have a v2 private directory:
$
$	IF F$SEARCH("SYS$LOGIN:HOO*.DIR") .EQS. "" THEN GOTO CHECK_V3_DIR
$	
$ ASK_V3:
$	
$	WRITE SYS$OUTPUT ""
$	
$	INQ ANS "DO YOU WANT TO USE DECALC VERSION 3 [NO]"
$	
$	ANS = F$EDIT(ANS,"COLLAPSE,UPCASE")
$	
$	IF ANS .EQS. "\" THEN EXIT 1
$	
$	IF ANS .EQS. "" THEN ANS = "N"
$	
$	IF 	ANS .EQS. "NO"	.OR. -
		ANS .EQS. "N"	THEN GOTO V22
$	
$	IF 	ANS .EQS. "YES"	.OR. -
		ANS .EQS. "Y"	THEN GOTO SET_V3_COM
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "ERROR - PLEASE RESPOND WITH YES OR NO"
$	
$	GOTO ASK_V3
$	
$ SET_V3_COM:
$	
$! 	During parallel run we assign v3 common to v2 default common:
$
$	DEF/NOLOG CALC$COMMON DECALC$COMMON
$	
$ ASK_CON:	! we allow user to convert one grid at a time so they do not
$		! kill responce time.
$	
$	WRITE SYS$OUTPUT ""
$	
$	INQ ANS -
	      "DO YOU WANT TO CONVERT A DECALC VERSION 2 GRID TO VERSION 3 [NO]"
$	
$	ANS = F$EDIT(ANS,"COLLAPSE,UPCASE")
$	
$	IF ANS .EQS. "\" THEN EXIT 1
$	
$	IF ANS .EQS. "" THEN ANS = "N"
$	
$	IF 	ANS .EQS. "NO"	.OR. -
		ANS .EQS. "N"	THEN GOTO CHECK_V3_DIR
$	
$	IF 	ANS .EQS. "YES"	.OR. -
		ANS .EQS. "Y"	THEN GOTO DO_CON
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "ERROR - PLEASE RESPOND WITH YES OR NO"
$	
$	GOTO ASK_CON
$	
$ DO_CON:
$	
$! 	Run modified convert procedure:
$
$	@DECALCON
$	
$ CHECK_V3_DIR:
$
$	@DECALCDIR	! CHECK USER HAS A V3 GRID DIR
$	
$	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$	DECALC3
$
$	EXIT 1
$
$ PSWD:		! routine to enter v3 conversion passwords
$	
$ ASK_PASS:
$	
$	WRITE SYS$OUTPUT ""
$	
$	INQ ANS "DO YOU WANT TO ENTER PASSWORDS FOR THE CONVERSION [NO]"
$
$	ANS = F$EDIT(ANS,"COLLAPSE,UPCASE")
$	
$	IF ANS .EQS. "\" THEN EXIT 1
$	
$	IF ANS .EQS. "" THEN ANS = "N"
$	
$	IF 	ANS .EQS. "NO"	.OR. -
		ANS .EQS. "N"	THEN RETURN
$	
$	IF 	ANS .EQS. "YES"	.OR. -
		ANS .EQS. "Y"	THEN GOTO ASK_PR_PSWD
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "ERROR - PLEASE RESPOND WITH YES OR NO"
$	
$	GOTO ASK_PASS
$	
$ ASK_PR_PSWD:
$	
$	DEF/NOLOG PSWD_FILE DECALC_PSWD.TMP
$	
$	CRE/FDL=ASCII PSWD_FILE
$	
$	SET FILE/PROT=(G,W)/ERASE PSWD_FILE
$
$	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$	RUN DECALCPSWD
$	
$	DEL DECALC_PSWD.TMP;*
$	
$ 	WRITE SYS$OUTPUT ""
$ 	INQUIRE ANS "DEPRESS RETURN TO CONTINUE"
$
$	RETURN
$	
$ BOMBER:
$
$ 	WRITE SYS$OUTPUT ""
$ 	INQUIRE ANS "DEPRESS RETURN TO CONTINUE"
$
$	EXIT 1
