	/* include files */
# include	<jpidef.h>
# include	<ssdef.h>
# include	<ctype.h>
	/* constant definitions */
# define	TRUE		1	/* boolean true			*/
# define	FALSE		0	/* boolean false		*/
# define	EFN		1	/* which event flag to use	*/
# define	NBRITEMS	10	/* number of getjpi items req.	*/
# define	SCH$C_COLPG	1
# define	SCH$C_MWAIT	2
# define	SCH$C_CEF	3
# define	SCH$C_PFW	4
# define	SCH$C_LEF	5
# define	SCH$C_LEFO	6
# define	SCH$C_HIB	7
# define	SCH$C_HIBO	8
# define	SCH$C_SUSP	9
# define	SCH$C_SUSPO	10
# define	SCH$C_FPG	11
# define	SCH$C_COM	12
# define	SCH$C_COMO	13
# define	SCH$C_CUR	14

	/* macros */
# define	SIGNAL(status)						\
			if (1&status != 1)				\
				lib$stop(status);
main(argc,argv)
int argc;
char *argv[];
{
char	img[128];		/* image name				*/
int	owner;			/* owner if subprocess			*/
int	pid;			/* process identification		*/
int	jobtype;		/* type of job				*/
char	terminal[7];		/* terminal of process			*/
char	username[15];		/* user name				*/
int	state;
int	mem,pmem,gmem,wmem;	/* amount of memory used		*/
int	memtot,memtot_b,memtot_i,memtot_o,memtot_noimg;
int	memfree;
unsigned short mem_free,mem_mod,mem_phys;
char	job_type[4],st[5];
int	com_tot,como_tot,swp_tot;

int	pidcontext;		/* process id context for getjpi call	*/
int	save_context;		/* last process id context 		*/
int	getjpi_status;		/* getjpi returned status variable	*/
int	sys$getjpiw();		/* getjpi system service returns an int	*/
int	bool_status;		/* boolean program status		*/
char	image[128];		/* image name after device removal	*/
register int	sleepytime;	/* number of seconds to sleep		*/
register int	print_flag;	/* 0=detached 1=sub 2=batch 3=inter 4=biu */
register int	index;		/* general purpose index		*/

struct
{
	short	io_s;
	short	len;
	int	info;
} iosb;


struct	ITEM
{
	short	len;		/* buffer length			*/
	short	item_code;	/* information item requested		*/
	char	*buf;		/* return buffer			*/
	int	*rlen;		/* return length			*/
};

struct
{
	struct	ITEM items[1];
	int	endoflist;
} itemlist_img				=
					{
		/* imagename	*/	128,JPI$_IMAGNAME,img	,0
					};

struct
{
	struct	ITEM items[NBRITEMS];
	int	endoflist;
} itemlist				=
					{
		/* owner	*/	4 , JPI$_OWNER	,&owner ,0
		/* pid		*/	,4 ,JPI$_PID	,&pid	,0
		/* job type	*/	,4 ,JPI$_JOBTYPE,&jobtype,0
		/* state	*/	,4 ,JPI$_STATE	,&state,0
		/* terminal	*/	,7 ,JPI$_TERMINAL,terminal,0
		/* user name	*/	,12,JPI$_USERNAME,username,0
		/* memory used  */	,4 ,JPI$_PPGCNT	,&pmem	,0
		/* global pages */	,4 ,JPI$_GPGCNT ,&gmem  ,0
		/* ws size	*/	,4 ,JPI$_WSSIZE ,&wmem  ,0
		/* try to get img*/	,4 ,JPI$_CHAIN	,&itemlist_img,0
					};


argv++;
if (argc == 1)
	sleepytime=0;
    else
	sscanf(*argv,"%d",&sleepytime);
itemlist.endoflist = itemlist_img.endoflist = 0;
for(;;)
    {
    memtot = memtot_b = memtot_i = memtot_o = memtot_noimg = 0;
    com_tot = como_tot = swp_tot = 0;
    lib$erase_page(&1,&1);
    printf("[7m  Pid    State Mem  Glob  Username");
    printf("   Type              Image Name               [m");
    bool_status = TRUE;
    for (pidcontext = -1;bool_status == TRUE;)
	{
	save_context = pidcontext;
	getjpi_status = sys$getjpiw(EFN,&pidcontext,0,&itemlist,&iosb,0,0);
	if ((getjpi_status == SS$_NORMAL) || (getjpi_status == SS$_SUSPENDED))
		{
		mem = pmem + gmem;
		print_flag = 0;
		memtot += mem;
		if (terminal[0] != '\0')
			{
			strncpy(job_type,"   \0",4);
			print_flag = 3;
			if (img[0] != '\0')
				memtot_i += mem;
			    else
				memtot_noimg += mem;
			}
	   	    else if (jobtype == JPI$K_BATCH)
			{
			print_flag = 2;
			memtot_b += mem;
			if (owner != 0)
				strncpy(job_type,"BSU\0",4);
			    else
				strncpy(job_type,"BAT\0",4);
			}
		    else if(jobtype != JPI$K_DETACHED)
			{
			if (img[0] != '\0')
				memtot_i += mem;
			    else
				memtot_noimg += mem;
			print_flag = 1;
			strncpy(job_type,"SUB\0",4);
			}
		    else
			memtot_o += mem;
		if (img[0] == '\0')
		    print_flag = 0;
		if (print_flag != 0)
			{
			image[0] = '\0';
			if (getjpi_status == SS$_SUSPENDED)
			    strcpy(image,"<<<<<<<<<< SUSPENDED JOB >>>>>>>>>>");
			  else
			    if (img[0] != '\0')
				{
				for (index=13;index <= 127;index++)
					{
					if (img[index] == ';')
						{
						img[index-4] = '\0';
						break;
						}
					}
				strcpy(image,strchr(img,'['));
				}
			    username[10] = '\0';
			    if (state == SCH$C_CEF)
				strcpy(st,"CEF ");
			      else if (state == SCH$C_COM)
				{
				strcpy(st,"COM ");
				com_tot++;
				}
			      else if (state == SCH$C_COMO)
				{
				strcpy(st,"COMO");
				com_tot++;
				como_tot++;
				swp_tot++;
				}
			      else if (state == SCH$C_CUR)
				strcpy(st,"CUR ");
			      else if (state == SCH$C_COLPG)
				strcpy(st,"COLP");
			      else if (state == SCH$C_FPG)
				strcpy(st,"FPG ");
			      else if (state == SCH$C_HIB)
				strcpy(st,"HIB ");
			      else if (state == SCH$C_HIBO)
				{
				strcpy(st,"HIBO");
				swp_tot++;
				}
			      else if (state == SCH$C_LEF)
				strcpy(st,"LEF ");
			      else if (state == SCH$C_LEFO)
				{
				strcpy(st,"LEFO");
				swp_tot++;
				}
			      else if (state == SCH$C_MWAIT)
				strcpy(st,"MWT ");
			      else if (state == SCH$C_PFW)
				strcpy(st,"PFW ");
			      else if (state == SCH$C_SUSP)
				strcpy(st,"SUSP");
			      else if (state == SCH$C_SUSPO)
				{
				strcpy(st,"SUSO");
				swp_tot++;
				}
			    printf("\n%08X %4s %4d (%4d) %-10s %4s %s",
			    	    pid,st,mem,gmem,username,job_type,image);
			}
		}
	    else if (getjpi_status == SS$_NOMOREPROC)
		{
		bool_status = FALSE;
		}
	    else if (getjpi_status == SS$_NOPRIV)
		{
		printf("\n<<<<<<<<< WORLD PRIVELEGE REQUIRED >>>>>>>>>");
		sleepytime = 0;
		bool_status = FALSE;
		}
	    else
		{
		SIGNAL(getjpi_status);
		SIGNAL(iosb.io_s);
		SIGNAL(getjpi_status);
		sleepytime=0;
		bool_status = FALSE;
		}
	}
    mem_free = *(unsigned short *)0x80001eec;
    mem_mod = *(unsigned short *)0x80001ef0;
    mem_phys = *(unsigned short *)0x80001ef8;

    printf ("\n[1m#4#6Bat = %5d   Int = %5d   Idl  = %5d"
	,memtot_b,memtot_i,memtot_noimg);
    printf ("\n#4#6Det = %5d   Tot = %5d"
	,memtot_o,memtot);
    printf ("\n#4#6Phy = %5d   Mod = %5d   Free = %5d"
	,mem_phys,mem_mod,mem_free);
    printf ("\n#4#6Com = %5d   Swp = %5d   Como = %5d[m"
	,com_tot,swp_tot,como_tot);
    if (sleepytime == 0)
	break;
    sleep(sleepytime);
    }	
}	
