$! ALECMP.COM		MAO	850214
$!
$! COMMAND FILE TO TRANSLATE AND COMPILE ALECS MODULES TO RUN IN
$! NATIVE MODE ON THE VAX.
$!
$! REVISIONS
$!
$ FLECS := $USER$Q:FLE	!define locally
$!
$ SRC   := [MP1Q.FLEALECOM]	!sources (note listing and object files
$!				!should be kept in [MP1Q.FLEALECOM.ALECS]
$!				!to distinguish them from ALECS files.
$!
$ MAC/LIST 'SRC'FILEVMS.MAR
$ PURGE FILEVMS.LIS,FILEVMS.OBJ
$!
$ FOR/NOI4/F77/LIST 'SRC'FSUB.FFF
$ PURGE FSUB.LIS,FSUB.OBJ
$!
$ FLECS A,A/-SP='SRC'A/CO:ALECS
$ FOR/NOI4/F77/LIST A.FTN
$ PURGE A.FLL,A.OBJ,A.LIS
$!
$ FLECS L,L/-SP='SRC'L/CO:ALECS
$ FOR/NOI4/F77/LIST L.FTN
$ PURGE L.FLL,L.OBJ,L.LIS
$!
$ FLECS M,M/-SP='SRC'M/CO:ALECS
$ FOR/NOI4/F77/LIST M.FTN
$ PURGE M.FLL,M.OBJ,M.LIS
$!
$ FLECS LAMPFI,LAMPFI/-SP='SRC'LAMPFI/CO:ALECS:VAX
$ FOR/NOI4/F77/LIST LAMPFI.FTN
$ PURGE LAMPFI.FLL,LAMPFI.OBJ,LAMPFI.LIS
$!
$ FLECS ASUB,ASUB/-SP='SRC'ASUB/CO:VAX
$ FOR/NOI4/F77/LIST ASUB.FTN
$ PURGE ASUB.FLL,ASUB.OBJ,ASUB.LIS
$!
$ FLECS STRING,STRING/-SP='SRC'STRING
$ FOR/NOI4/F77/LIST STRING.FTN
$ PURGE STRING.FLL,STRING.OBJ,STRING.LIS
$!
$ FLECS FILE,FILE/-SP='SRC'FILE/CO:ALECS:VAX
$ FOR/NOI4/F77/LIST FILE.FTN
$ PURGE FILE.FLL,FILE.OBJ,FILE.LIS
$!
$! PURGE .FTN FILES TOO
$!
$ PURGE *.FTN
$!
$! END OF FILE ALECMP.COM
