C
C	CSICOM.INC
C
C	THIS FILE IS USED BY CSI ROUTINES VIA AN INCLUDE STATEMENT.
C
C	*****NEVER DELETE THIS FILE ********
C
C REVISIONS:
C 2-FEB-84 (JFA) - INCREASE MAX NO SWITCH VALUES FROM 30 TO 100
C 850809mao Put file into standard format; convert L*1 variables to I*2.
C 861031mao Add NODIND_ADDR variable.
C
	INTEGER*2 MAX_NUM_SW
	INTEGER*2 MAX_NUM_VAL
 
	PARAMETER (MAX_NUM_SW=20)   !Max number of switches
	PARAMETER (MAX_NUM_VAL=100) !Max number of switch values
C
	INTEGER*4 DEVIND_ADDR     !Address to return device indicies
	INTEGER*4 EQUAL_ADDR      !Address to return equal status
	INTEGER*4 FILIND_ADDR     !Address to return file spec indicies
	INTEGER*2 LINE_POINTER(2) !Position in input line after last
C					! CSIGO call; one pointer
C					! for each side of equal sign.
	INTEGER*4 MORE_ADDR       !Address to return more status
	INTEGER*4 NODIND_ADDR     !Address to return Node indicies!861031
	INTEGER*2 NUM_SW_DFN      !Number of switches defined
	INTEGER*2 NUM_SW_VAL_DFN  !Number of switch values defined
	BYTE      SW_NAME(2,MAX_NUM_SW) !ASCII switch names
	INTEGER*4 SW_STATE_ADDR(MAX_NUM_SW) !Addr to return sw status
	INTEGER*2 SW_STATE_DFLT(MAX_NUM_SW) !Default for sw status
	INTEGER*4 SW_VALUE_ADDR(MAX_NUM_VAL) !Addr to return sw value
	INTEGER*2 SW_VALUE_CHAIN(2,MAX_NUM_SW) !Pointers to 1st & last sw
C					    value for a given sw in
C					    arrays. =(0,0) if no values
C					    for sw.
	INTEGER*2 SW_VALUE_LENGTH(MAX_NUM_VAL)
C			>0-->ASCII string, it's max length in bytes
C			=0-->Decimal I*2
C			=-1-->Octal I*2
C			=-2-->Hex I*2
C			=-10-->Decimal I*1
C			=-11-->Octal I*1
C			=-12-->Hex I*1
C			=-20-->Decimal I*4
C			=-21-->Octal I*4
C			=-22-->Hex I*4
C			=-30-->Real*4 (F floating)
C			=-40-->Real*8 (D floating)
	INTEGER*4 UICIND_ADDR     !Address to return directory indicies
	INTEGER*4 WILD_ADDR       !Address to return WILD status
C
	COMMON/CSI_DATA_BASE__/LINE_POINTER,
	1 NUM_SW_DFN,NUM_SW_VAL_DFN,NODIND_ADDR,DEVIND_ADDR,UICIND_ADDR,
	2 FILIND_ADDR,MORE_ADDR,WILD_ADDR,EQUAL_ADDR,SW_NAME,
	3 SW_STATE_ADDR,SW_STATE_DFLT,SW_VALUE_ADDR,SW_VALUE_LENGTH,
	4 SW_VALUE_CHAIN
C
C END OF FILE
