$ SAVERIFY = F$VERIFY(0)
$!***************************************************************************
$!									    *
$!  COPYRIGHT (c) 1983                                                      *
$!  By TECHNOLOGY DEVELOPMENT CORP.					    *
$!     621 Six Flags Drive, 						    *
$!     Arlington, Tx.							    *
$!     76012								    *
$!     (817) 461-1242							    *
$! 									    *
$!  THIS SOFTWARE IS FURNISHED WITHOUT LICENSE AND MAY BE USED AND  COPIED  *
$!  ONLY WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.		    *
$! 									    *
$!  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
$!  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY T.D.C.		    *
$! 									    *
$!  TECHNOLOGY DEVELOPMENT CORP. ASSUMES NO RESPONSIBILITY FOR THE USE OR   *
$!  RELIABILITY OF THIS SOFTWARE. 				    	    *
$!									    *
$!***************************************************************************
$ !
$ !	This command file will allow a quick way of checking how much space
$ !	is left on the disks you have on the system. Works V3.x and V4.x of
$ !     VMS.
$ !
$ !
$ ESC[0,8]       = 27
$ BELL[0,8]      = 7
$ BOLD_BLINK_ON  = ESC + "[1;5;m"
$ BOLD_BLINK_OFF = ESC + "[0;m"
$ !
$ ALERT = 85
$ !
$ DEFINE/USER_MODE SYS$OUTPUT DISK.TMP
$ SHOW DEVICES D
$ !
$ !
$ EXTRACT_START = 2
$ IF F$EXTRACT(0,2,F$GETSYI("VERSION")) .NES. "V3" THEN EXTRACT_START = 0
$ !
$ OPEN DISK DISK.TMP
$ READ/END=DONE DISK RECORD
$ READ/END=DONE DISK RECORD
$ READ/END=DONE DISK RECORD
$ !
$LOOP:
$ READ/END=DONE DISK RECORD
$ NAM = F$EXTRACT(EXTRACT_START,13,RECORD)
$ !
$ IF .NOT. F$GETDVI(NAM,"MNT") THEN GOTO NOT_MOUNTED
$ IF F$GETDVI(NAM,"FOR") THEN GOTO MOUNTED_FOREIGN
$ !
$ FREE_BLOCKS = F$GETDVI(NAM,"FREEBLOCKS")
$ !
$ MAX_BLOCKS  = F$GETDVI(NAM,"MAXBLOCK")
$ !
$ BLOCKS_USED = MAX_BLOCKS - FREE_BLOCKS
$ PCT_USED = BLOCKS_USED * 100 / MAX_BLOCKS
$ !
$ IF PCT_USED .GT. ALERT THEN GOTO ALARM
$ !
$ PHRASE = F$FAO(" !13AS!3SL Percent full, !7SL Blocks free",NAM,PCT_USED,FREE_BLOCKS)
$ WRITE SYS$OUTPUT PHRASE
$ GOTO LOOP
$ !
$ALARM:
$ PHRASE = F$FAO(" !13AS!AS!3SL!AS percent full, !AS!7SL!AS Blocks free",NAM,-
             BOLD_BLINK_ON, PCT_USED,    BOLD_BLINK_OFF,-
             BOLD_BLINK_ON, FREE_BLOCKS, BOLD_BLINK_OFF)
$ WRITE SYS$OUTPUT BELL, PHRASE
$ GOTO LOOP
$ !
$NOT_MOUNTED:
$ WRITE SYS$OUTPUT " ''NAM' On line, but not mounted"
$ GOTO LOOP
$ !
$MOUNTED_FOREIGN:
$ WRITE SYS$OUTPUT " ''NAM' Mounted foreign"
$ GOTO LOOP
$ !
$DONE:
$ CLOSE DISK
$ DELETE/NOCONFIRM/NOLOG DISK.TMP;0
$ SAVERIFY = F$VERIFY(SAVERIFY)
$ EXIT
