$!	MODEM.COM - invoke Kermit on an available dial out line
$!
$!	Dial out terminal lines must have logicals pointing to them of
$!	the form:  MODEMx  where x is the modem number, starting with
$!	one for the first and incremented for each additional modem line.
$!	(Example SYS$MANAGER:SYSTARTUP.COM: $ DEFINE/SYSTEM MODEM1 TXA1:)
$!	Also assumes you have defined KERMIT as a foreign command.
$!	(Example SYS$MANAGER:SYLOGIN.COM: $ KERMIT == "$SYS$SYSTEM:KERMIT")
$!
$	SAVERIFY = F$VERIFY(0)
$	ON ERROR THEN GOTO FINISHED
$	PREVPRIV = F$SETPRV("WORLD")
$	WORLDPRIV = F$PRIVILEGE("WORLD")
$	X = 1
$ LOOP1:
$	DIALOUT = "MODEM''X'"
$	IF .NOT. F$GETDVI(DIALOUT,"EXISTS") THEN GOTO FINISHED
$	IF F$GETDVI(DIALOUT,"REFCNT") .EQ. 0 THEN GOTO DO_IT
$	IF .NOT. WORLDPRIV THEN GOTO TRY_AGAIN
$	PID = F$GETDVI(DIALOUT,"PID")
$	WRITE SYS$OUTPUT "''DIALOUT' is in use by ''F$GETJPI(PID,""USERNAME"")"
$ TRY_AGAIN:
$	X = X + 1
$	GOTO LOOP1
$!
$ DO_IT:
$	WRITE SYS$OUTPUT "Defining ''DIALOUT' as default line for Kermit"
$	WRITE SYS$OUTPUT " "
$	DEFINE/USER_MODE KER$COMM 'DIALOUT'
$	DEFINE/USER_MODE SYS$INPUT SYS$COMMAND
$	KERMIT 'P1' 'P2' 'P3' 'P4' 'P5' 'P6' 'P7' 'P8'
$!
$ FINISHED:
$	PREVPRIV = F$SETPRV(PREVPRIV)
$	SAVERFIY = F$VERIFY(SAVERIFY)
$	EXIT
