$ !	Craig Young			3-AUG-87
$ !
$ !	This command procedure is used to compile and link the parts
$ !	of SWING.  It checks the creation date of the source file
$ !	against that of the current object file and compiles the source
$ !	only if it was created after the last object file.  A similar
$ !	check is done with the link.  In this way, only the subroutines
$ !	that were modified are recompiled.
$ !
$ compile /verify /include=(swing.cmn,pulldown.cmn) /library=swing-
	/nolist/'p1'debug/check -
ADD_NODE,-
ADD_NODE_TO_DISPLAY,-
ADJUST_NODE_POINTERS,-
APPEND_FNODE,-
APPEND_NODE,-
CHANGE_OPTIONS,-
CHANGE_SPEC,-
CHECK_DIRECTORY_MOVE,-
CREATE_DIRECTORY,-
CRT
$ compile /verify /include=(swing.cmn,pulldown.cmn) /library=swing-
	/nolist/'p1'debug/check -
DEFINE_PASTE_BOARD,-
DEFINE_SMG_LAYOUT,-
DELETE_DIRECTORY,-
DELETE_FILE,-
DELETE_FILES,-
DELETE_NODE,-
DIR_TO_FILE,-
DRAW_SCREEN
$ compile /verify /include=(swing.cmn,pulldown.cmn) /library=swing-
	/nolist/'p1'debug/check -
EDIT_FILE,-
EXECUTE_DCL,-
EXIT_SWING,-
FILE_OPTIONS,-
FILE_TO_DIR,-
FIND_NODE,-
FREE_NODE,-
GET_LOCATION,-
HARDCOPY,-
HELP,-
HELP_FILER,-
LOAD_DISPLAY
$ compile /verify/include=(swing.cmn,pulldown.cmn) /library=swing-
	/nolist/'p1'debug/check -
LOAD_FILES,-
LOAD_NODES,-
MODIFY_FILE_PROT,-
MOVE_FILE,-
MOVE_NODE,-
PD_BAR_CHOICE,-
PD_DRAW_BAR,-
PD_GET_CHOICE,-
PD_LIST_CHOICE,-
PD_LOAD_BAR,-
PD_UNDRAW_BAR,-
PRINT_FILE,-
PRINT_MESSAGE
$ compile /verify /include=(swing.cmn,pulldown.cmn) /library=swing-
	/nolist/'p1'debug/check -
PROCESS_COMMAND,-
RECORD_STRUCTURE,-
REDEFINE_SMG_LAYOUT,-
RENAME_DIRECTORY,-
RENAME_FILE,-
RESET_TERMINAL,-
SET_NOTAB,-
SHOW_FILES,-
SM_ALLOW_REPAINT,-
SM_REPAINT_SCREEN
$ compile /verify /include=(swing.cmn,pulldown.cmn) /library=swing-
	/nolist/'p1'debug/check -
TRANSLATE_LOGICAL,-
UPDATE_FILE_WINDOW,-
UPDATE_SCREEN,-
UPDATE_WINDOW1
$ compile /verify /include=(swing.cmn,pulldown.cmn)-
	/nolist/'p1'debug/check -
	/link=(/'p1'debug swing/lib) -
SWING
$ exit
