$!---------------------------------------------------------------------
$!             CD Command -  By William J. Baker, Jr.   November 1986
$!---------------------------------------------------------------------
$!
$!   Change Dir:  CD [[<]local-dir | >path | -PREV:# | -F|-H] {home}
$!
$!     GLOBAL SYMBOLS used:  SaveDir#, HelpDir, TopDir
$!     FILES used:  'HelpDir'cd.hlp
$!
$!---------------------------------------------------------------------
$      SET NOON
$      SET NOVERIFY
$      IF SaveDirLast .NES. "0" THEN GOTO Start
$      LastDir == F$INTEGER(SaveDirLast)
$      SaveDirLast :== "D"
$ Start:
$      MsgSet   = F$ENVIRONMENT("MESSAGE")
$      ON Control_Y THEN CONTINUE
$      NowPath := "''F$LOGI(""SYS$DISK"")'''F$DIR()'"
$      it := "''F$EXT(0,1,P1)'"
$      IF it .NES. "-" THEN GOTO NoOpt
$      it := "''F$EXT(0,2,P1)'"
$      IF it .EQS. "-T" THEN GOTO Top
$      IF it .EQS. "-S" THEN GOTO ShowPrevList
$      IF it .EQS. "-F" THEN GOTO FindPrevList
$      IF it .NES. "-P" THEN GOTO INFO
$!---------------------------------------------- Check for Previous Dir
$      last = 'F$LOC(":",P1)' + 1
$      knt = f$integer(f$extract(last,2,P1))
$      IF knt .eq. 0 then knt = LastDir
$      IF knt .eq. 0 then Goto Abort
$      IF (knt .gt. 20) .or. (SaveDir'knt' .eqs. "0") THEN GOTO Abort
$      PrevDef = SaveDir'knt'
$      Set Default 'PrevDef'
$      GOTO Save
$!---------------------------------------------- List Previous Directories
$ShowPrevList:
$      Out "    Current Directory:  ''NowPath'"
$      Out "    ## ----------- Previous Directories -----------"
$      cnt = 0
$ShowLoop:
$      cnt = cnt + 1
$      IF cnt .gt. 20 THEN GOTO MsgFinish
$      IF SaveDir'cnt' .eqs. "0" THEN GOTO ShowLoop
$      Spl = SaveDir'cnt'
$      QSpl = " "
$      IF cnt .eq. LastDir THEN QSpl = "Previous Dir"
$      Out "    ",cnt,"	''Spl'			''QSpl'"
$      GOTO ShowLoop
$!---------------------------------------------- List Previous Directories
$FindPrevList:
$      cnt = LastDir
$      FndLen = f$length("''P1'")
$      FndStr = f$extract(3,FndLen-3,"''P1'")
$FindLoop:
$      cnt = cnt - 1
$      IF cnt .lt. 1 THEN cnt = 20
$      IF SaveDir'cnt' .eqs. "0" THEN GOTO FindLoop
$      SdirLen = f$length(SaveDir'cnt')
$      IF f$locate(FndStr,SaveDir'cnt') .ne. SdirLen THEN GOTO Foundit
$      IF cnt .eq. LastDir THEN GOTO Abort
$      GOTO FindLoop
$Foundit:
$      PrevDef = SaveDir'cnt'
$      Set Default 'PrevDef'
$      GOTO Save
$!---------------------------------------------- Check Request
$NoOpt:IF it .EQS. "" THEN GOTO Home
$!---------------------------------------------- Get Directory Names
$      pt := "''P1'"
$      IF (it.EQS."#") .OR. (it.EQS."$") THEN GOTO ChngLogin
$      IF it.EQS."\".OR.it.EQS."<".OR.it.EQS.">" THEN pt:='F$EXT(1,80,pt)
$      IF 'F$LOC("[",pt) .NE. 'F$LEN(pt) THEN SET DEF 'pt'
$      IF 'F$LOC("[",pt) .NE. 'F$LEN(pt) THEN GOTO Save
$!---------------------------------------------- Check Path Direction
$      IF it .EQS. "\" THEN GOTO Up1
$      IF it .EQS. "<" THEN GOTO Up1
$      IF it .EQS. ">" THEN GOTO Path
$!---------------------------------------------- Change Directory down
$      SET DEF [.'pt']
$      GOTO Save
$!---------------------------------------------- Change SYS$LOGIN logical
$ChngLogin:
$      pt:='F$EXT(1,80,pt)
$      IF (it.EQS."$") THEN GOTO ResetLogin
$      ASSIGN 'pt' SYS$LOGIN
$      SET DEF 'pt'
$      GOTO Save
$!---------------------------------------------- Reset SYS$LOGIN logical
$ResetLogin:
$      DEASSIGN SYS$LOGIN
$      IF pt .eqs. "" THEN GOTO Home
$      SET DEF 'pt'
$      GOTO Save
$!---------------------------------------------- Change to Top Directory
$Top:  
$      loc = 'F$LOC(".",NowPath)
$      IF loc .NE. 'F$LEN(NowPath) THEN GOTO SDir
$      Goto SaveStart
$SDir:
$      TopDir :== 'F$EXT(0,loc,NowPath)
$      SET DEF 'TopDir']
$      GOTO Save
$!---------------------------------------------- Change to Home Directory
$Home: SET DEFAULT SYS$LOGIN
$      GOTO Save
$!---------------------------------------------- Change Directory up 1
$Up1:  IF 'F$LOC(".",NowPath) .NE. 'F$LEN(NowPath) THEN GOTO GetPrev
$      Out "         At top directory:  ", NowPath
$      Goto MsgFinish
$GetPrev:
$      IF pt .nes. "" THEN GOTO SetUpNext
$      SET DEF [-]
$      GOTO Save
$SetUpNext:
$      SET DEF [-.'pt']
$      GOTO Save
$!---------------------------------------------- Change Directory to Path
$Path: SET DEF ['pt]
$!---------------------------------------------- Save Previous Dir Path
$Save: 
$      ErrChk   = F$SEARCH("*.*")
$      IF ErrChk .NES. "" THEN GOTO SaveStart
$      SET MESSAGE/NOSEVER/NOID/NOFAC/NOTEXT
$      ON ERROR THEN GOTO Abort
$      DIR/OUT=SYS$SCRATCH:CDTMP.CDTMP
$      DEL/NOLOG SYS$SCRATCH:CDTMP.CDTMP;*
$SaveStart:
$      NewPath   = F$ENVIRONMENT("DEFAULT")
$      IF "''NowPath'" .eqs. "''NewPath'" THEN GOTO Final
$      LastDir == LastDir + 1
$      IF LastDir .eq. 21 THEN LastDir == 1
$      SaveDir'LastDir' :== "''NowPath'"
$!---------------------------------------------- Final Save Commands.
$ Final:
$      out "
 Directory: ''NewPath'"
$      out " "
$ MsgFinish:
$      SET MESSAGE 'MsgSet'
$      EXIT
$!---------------------------------------------- Abort and Reset to Previous
$ Abort:
$      DEL/NOLOG SYS$SCRATCH:CDTMP.CDTMP;*
$ FindNot:
$      SET MESSAGE 'MsgSet'
$      out " "
$      out "''P1' is not a legal change directory command."
$      out " "
$      Set Default 'NowPath'
$      out " Directory: ''NowPath'"
$      out " "
$      EXIT
