$!
$	SET NOON
$!
$	OUT :== WRITE SYS$OUTPUT
$!
$ RESTART:
$!
$	MYDEV = "''P1'"
$!
$	CLS
$	OUT "	"
$	OUT "		''P2' CONFIGURATION LOADING"
$	OUT "	"
$	OUT "		OPTION:		DESCRIPTION:"
$	OUT "	"
$	OUT "		<1>		CREATE A NEW CONFIGURATION."
$	OUT "		<2>		USE AN EXISTING CONFIGURATION."
$	OUT "	"
$	OUT "		<Q>		QUIT THIS ROUTINE."
$	OUT "	"
$	OUT "	"
$	INQUIRE/NOPUN	Q	"	ENTER OPTION:  "
$!
$	IF Q .EQS. "Q" THEN EXIT
$	IF Q .EQS. "1" THEN GOTO CR_CONFIG
$	IF Q .EQS. "2" THEN GOTO REVW_CONFIGS
$!
$ CR_CONFIG:
$!
$	CRCNFG := $SYS_ADDA:ADDA_DEFINE
$!
$	ASSIGN	ROOT_ADDA:[CONFIG]'P2'_NEW.TMP	ADDA_LOAD_FILE
$!
$	ASSIGN/USER	SYS$COMMAND	SYS$INPUT
$	CRCNFG 'MYDEV'
$	DEASSIGN/USER	SYS$INPUT
$!
$ RNAM_FILE:
$!
$	OUT "	"
$	OUT "		A TEMPORARY FILE WAS CREATED CALLED ''P2'_NEW.TMP"
$	OUT "	"
$	OUT "		IN ORDER TO BE USED IT MUST BE RENAMED TO HAVE A"
$	OUT "		FILE EXTENSION OF .CONFIG, AND A UNIQUE MAIN FILE"
$	OUT "		NAME CONTAINING THE ''P2' DESIGNATION."
$	OUT "	"
$	OUT "	"
$	INQUIRE/NOPUN	Q	"DO YOU WISH TO RENAME THIS FILE?   <Y/N>  "
$	IF Q .NES. "Y" THEN GOTO RESTART
$	OUT "	"
$	OUT "		TO RENAME THE FILE, JUST DESIGNATE THE MAIN FILE"
$	OUT "		NAME CONTAINING THE ''P2' DESIGNATION WITHOUT A FILE"
$	OUT "		EXTENSION.  THE FILE EXTENSION WILL BE FILLED IN."
$	OUT "	"
$	INQUIRE/NOPUN	NF	"	NEW FILE NAME?  "
$!
$	NFLEN = F$LENGTH(NF)
$	NFLOC = F$LOCATE("''P2'",NF)
$	IF NFLOC .EQ. NFLEN THEN GOTO RNAM_FILE
$	NF2 = F$EDIT(NF,"COMPRESS,TRIM")
$!
$	RENAME/LOG	ADDA_CONFIG:'P2'_NEW.TMP	ADDA_CONFIG:'NF2'.CONFIG
$!
$ REVW_CONFIGS:
$!
$	CNT = 0
$!
$ REVW_LOOP:
$!
$	FNDFLE = F$SEARCH("ADDA_CONFIG:*''P2'*.CONFIG")
$	IF FNDFLE .EQS. "" THEN GOTO REVW_AGN
$!
$	CNT = CNT + 1
$	SHWFLE'CNT' = F$PARSE("''FNDFLE'",,,"NAME")
$	SHWSIZ'CNT' = F$STRING(F$FILE("''FNDFLE'","EOF"))
$	SHWDAT'CNT' = F$FILE("''FNDFLE'","CDT")
$!
$	LINE'CNT' = F$FAO("!(20AS)	!(4AS)	!(20AS)",SHWFLE'CNT',SHWSIZ'CNT',SHWDAT'CNT')
$!
$	IF CNT .GE. 15 THEN GOTO REVW_AGN
$!
$	GOTO REVW_LOOP
$!
$ REVW_AGN:
$!
$	KNT = 0
$!
$	CLS
$	OUT "##	FILE:			SIZE:		DATE:"
$	OUT "============================================================"
$!
$ REVW_SHOW:
$	KNT = KNT + 1
$	OUT "<''KNT'>	",LINE'KNT'
$!
$	IF KNT .EQ. CNT THEN GOTO REVW_SLCT
$!
$	GOTO REVW_SHOW
$!
$ REVW_SLCT:
$!
$	OUT "	"
$	OUT "	"
$	OUT "		ENTER NUMBER OF THE FILE FOR CONFIGURING DEVICE ''P2':, OR"
$	OUT "		ENTER <RETURN> TO REVIEW MORE CONFIGURATION FILES, OR"
$	OUT "		ENTER <Q> TO ABORT AND RETURN TO THE MAIN MENU."
$	OUT "	"
$	INQUIRE/NOPUN	FILNMBR	"	NUMBER OF FILE TO USE FOR ''P2' CONFIGURATION?  "
$	NMBR = F$INTEGER("''FILNMBR'")
$	FILNMBR = F$EDIT(FILNMBR,"COMPRESS,TRIM")
$	IF NMBR .GT. KNT THEN GOTO REVW_AGN
$	IF FILNMBR .EQS. "" THEN REVW_CONFIGS
$	IF FILNMBR .EQS. "Q" THEN EXIT
$	
$!
$	USEFLE = SHWFLE'NMBR'
$	IF F$LOGICAL("ADDA_LOAD_FILE") .NES. "" THEN DEASS ADDA_LOAD_FILE
$	ASSIGN	ROOT_ADDA:[CONFIG]'USEFLE'.CONFIG	ADDA_LOAD_FILE
$!
$	OUT "	"
$	OUT "	"
$!
$	ADLDR := $SYS_ADDA:ADDA_LOADER
$!
$	ADLDR 'P1'
$!
$	OUT "	"
$	OUT "	"
$	INQUIRE	RDY	"READY  "
$!
$	EXIT
