	SUBROUTINE ADDA_MAP()
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  MAPS DATA CHANNELS TO ARRAYS FOR ACTUAL
C **                        PROGRAM EXECUTION.
C
C **  ADDA_MAP.FOR DICTIONARY
C     -----------------------
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC/LIST'
C
	AD1_NMBR = 0
	AD2_NMBR = 0
C
	AD1_STRT = .FALSE.
	AD2_STRT = .FALSE.
C
	AD1_SET = .FALSE.
	AD2_SET = .FALSE.
C
	AD1_NMBR = AD_NUMBR(1)
	AD2_NMBR = AD_NUMBR(2)
C
	DO II = 1,16
C
		IF (AD1_NMBR .GE. II) THEN
			AD1_CHAN(II) = AD_CHNL(1,II).CHAN_NUM
			AD1_GAIN(II) = AD_CHNL(1,II).CHAN_GAIN
		TYPE *, AD1_CHAN(II), AD1_GAIN(II)
			AD1_SET = .TRUE.
		ENDIF

		IF (AD2_NMBR .GE. II) THEN
			AD2_CHAN(II) = AD_CHNL(2,II).CHAN_NUM
			AD2_GAIN(II) = AD_CHNL(2,II).CHAN_GAIN
		TYPE *, AD2_CHAN(II), AD2_GAIN(II)
			AD2_SET = .TRUE.
		ENDIF

	ENDDO
C
	IF (AD1_NMBR .NE. 0) AD1_STRT = .TRUE.
	IF (AD2_NMBR .NE. 0) AD2_STRT = .TRUE.
C
	DA1_NMBR = DA_NUMBR(1)
	DA2_NMBR = DA_NUMBR(2)
C
	DO II = 1,2
C
		IF (DA1_NMBR .GE. II) THEN
			DA1_CHAN(II) = DA_CHNL(1,II).CHAN_NUM
			DA1_DEV(II)  = DA_CHNL(1,II).CHAN_DEVICE
			DA1_FRM(II)  = DA_CHNL(1,II).CHAN_FROM
			AD1_SET = .TRUE.
		ENDIF

		IF (DA2_NMBR .GE. II) THEN
			DA2_CHAN(II) = DA_CHNL(2,II).CHAN_NUM
			DA2_DEV(II)  = DA_CHNL(2,II).CHAN_DEVICE
			DA2_FRM(II)  = DA_CHNL(2,II).CHAN_FROM
			AD2_SET = .TRUE.
		ENDIF

	ENDDO
C
	RETURN
	END
