	SUBROUTINE ADDA_SLEEP( OPTION )
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  PLACES PROGRAM IN WAIT STATE TILL READY TO START.
C **                        
C
C **  SLEEP
C     -----------------------
C
	CHARACTER*10	ADDA_START
C
	INTEGER*2	AD_CHAN
	INTEGER*4	OPTION, AD_LUN, STATUS
C
	ADDA_START = 'ADDA_START'
C
	STATUS = SYS$CREMBX( %VAL(1), AD_CHAN, , , , , ADDA_START )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	STATUS = LIB$GET_LUN( AD_LUN )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	OPEN( UNIT = AD_LUN, FILE=ADDA_START,
     &		CARRIAGECONTROL = 'LIST', STATUS = 'NEW' )
C
	TYPE *, 'OPEN CHANNEL ON MAILBOX (SLEEP), READY TO READ COMMAND...'
C
	READ(AD_LUN,50) OPTION
50	FORMAT(I1)
C
	TYPE *, 'MAILBOX (SLEEP) READ, VALUE = ',OPTION
C
	CLOSE(UNIT=AD_LUN)
C
	STATUS = SYS$DELMBX( %VAL(AD_CHAN) )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	STATUS = SYS$DASSGN( %VAL(AD_CHAN) )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	RETURN
	END
C
	SUBROUTINE FILE_DATA( AD_DEV, PRV_PNTR, OPTION )
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  TELLS FILE MANAGER PROGRAM TO COPY AND SAVE DATA.
C **                        
C
C **  FILE_DATA
C     -----------------------
C
	INTEGER*2	AD_CHAN
	INTEGER*4	OPTION, AD_LUN, STATUS, AD_DEV
	CHARACTER*9	ADDA_FILE
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	ADDA_FILE = DEVICE(AD_DEV)(1:4)//'_FILER'
	TYPE *, ADDA_FILE
C
C	STATUS = SYS$CREMBX( , AD_CHAN, , , , , ADDA_FILE )
C		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	STATUS = LIB$GET_LUN( AD_LUN )
		IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
	OPEN( UNIT = AD_LUN, FILE=ADDA_FILE,
     &		CARRIAGECONTROL = 'LIST', STATUS = 'OLD' )
C
	TYPE *, 'OPEN CHANNEL ON MAILBOX (FILER), READY TO READ COMMAND...'
C
	WRITE(AD_LUN,50) PRV_PNTR, OPTION
50	FORMAT(2I1)
C
	READ(AD_LUN,50) OPTION
C
	CLOSE(UNIT=AD_LUN)
C
	RETURN
	END
