	SUBROUTINE	POPAD( IDV, AD_DATA, INTIME )
C
	INTEGER*4	IDV, INTIME, LOC_PNTR, IPNT
C
	INTEGER*2	AD_DATA(16)
C
	INCLUDE		'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	TYPE *, 'AD1_PNTR = ',AD1_PNTR
	TYPE *, 'AD2_PNTR = ',AD2_PNTR
	TYPE *, 'CUR_PNTR1 = ',CUR_PNTR1
	TYPE *, 'CUR_PNTR2 = ',CUR_PNTR2
C
	IF (IDV .EQ. 0) THEN
		LOC_PNTR = CUR_PNTR1
		IPNT     = AD1_PNTR
		IF (AD1_PNTR .EQ. 0) THEN
			IPNT = 120
			IF (LOC_PNTR .EQ. 1) THEN
				LOC_PNTR = 2
			ELSE
				LOC_PNTR = 1
			ENDIF
		ENDIF
C
		IF (LOC_PNTR .EQ. 1) THEN
			DO II = 1,16
				AD_DATA(II) = AD1_DATA1(IPNT,II)
			ENDDO
			INTIME	    = AD1_TIME1(IPNT)
		ELSE
			DO II = 1,16
				AD_DATA(II) = AD1_DATA2(IPNT,II)
			ENDDO
			INTIME	    = AD1_TIME1(IPNT)
		ENDIF
C		
	ELSE
C
		LOC_PNTR = CUR_PNTR2
		IPNT     = AD2_PNTR
		IF (AD2_PNTR .EQ. 0) THEN
			IPNT = 120
			IF (LOC_PNTR .EQ. 1) THEN
				LOC_PNTR = 2
			ELSE
				LOC_PNTR = 1
			ENDIF
		ENDIF
C
		IF (LOC_PNTR .EQ. 1) THEN
			DO II = 1,16
				AD_DATA(II) = AD2_DATA1(IPNT,II)
			ENDDO
			INTIME	    = AD2_TIME1(IPNT)
		ELSE
			DO II = 1,16
				AD_DATA(II) = AD2_DATA2(IPNT,II)
			ENDDO
			INTIME	    = AD2_TIME1(IPNT)
		ENDIF
C		
	ENDIF
	RETURN
	END

	SUBROUTINE	PUSHDA( IDEV, LOC_PNTR, IOUTDAT )
C
	INTEGER*4	IDV, LOC_PNTR
C
	INTEGER*2	IOUTDAT
C
	INCLUDE		'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	IF (IDEV .EQ. 0) THEN
C
		DA1_BUFFER(LOC_PNTR) = IOUTDAT
C
	ELSE IF (IDEV .EQ. 1) THEN
C
		DA2_BUFFER(LOC_PNTR) = IOUTDAT
C
	ENDIF
C
	RETURN
	END

	SUBROUTINE	IO_CONTROL( IOPT )
C
	INTEGER*2	AD_CHAN
	INTEGER*4	AD_LUN, STATUS, IOPT
	CHARACTER*10	ADDA_START
C
	INCLUDE		'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	TYPE *, 'FIGURE OUT MECHANISM FOR START/STOP...'
C
	IF (AD1_CLK) THEN
		TYPE *,'AD1_CLK = TRUE'
	ELSE
		TYPE *,'AD1_CLK = FALSE'
	ENDIF
C
	IF (AD2_CLK) THEN
		TYPE *,'AD2_CLK = TRUE'
	ELSE
		TYPE *,'AD2_CLK = FALSE'
	ENDIF
C
	   IF (( .NOT. USE_LOGICAL ) .OR. (IOPT .LE. 1)) THEN
C
	TYPE *,'USE MAILBOX...'
C
		ADDA_START = 'ADDA_START'
C
		STATUS = LIB$GET_LUN( AD_LUN )
			IF (.NOT. STATUS) CALL LIB$SIGNAL(%VAL(STATUS))
C
		OPEN( UNIT = AD_LUN, FILE=ADDA_START,
     &			CARRIAGECONTROL = 'LIST', STATUS = 'OLD' )
C
		WRITE(AD_LUN,50) IOPT
50		FORMAT(I1)
C
		CLOSE(UNIT=AD_LUN)
C
	   ELSE
C
		TYPE *, 'USE LOGICAL MECHANISM...'
		NEWOPT	   = IOPT
		START_STOP = .TRUE.
C
	   ENDIF
C
	RETURN
	END

	SUBROUTINE WAITABIT( SECS )
C
	REAL*4		SECS, RSEC
	INTEGER*4	STATUS_H, DELTA(2)
	CHARACTER	SECONDS*5, MINUTE*2
C
	INCLUDE		'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	IF (SECS .EQ. 0) THEN
		RSEC = 1/(CLK_RATE*1.1)
	ELSE
		RSEC = SECS
	ENDIF
C
	IF (RSEC .LT. 1.0) THEN
		ENCODE(4,8000,SECONDS) RSEC
8000		FORMAT(F4.2)
		STATUS_H = SYS$BINTIM('0 00:00:'//SECONDS,DELTA)
	ELSE IF (RSEC .LT. 60.0) THEN
		ENCODE(5,8010,SECONDS) RSEC
8010		FORMAT(F5.2)
		STATUS_H = SYS$BINTIM('0 00:00:'//SECONDS,DELTA)
	ELSE 
		IMINUTE = RSEC/60
		RSEC    = RSEC - (IMINUTE * 60.0)
		ENCODE(5,8020,SECONDS) RSEC
8020		FORMAT(F5.2)
		ENCODE(2,8030,MINUTE) IMINUTE
8030		FORMAT(I2)
		STATUS_H = SYS$BINTIM('0 00:'//MINUTE//':'//SECONDS,DELTA)
	ENDIF
	DELTA(1) = -DELTA(1)
	STATUS_H = SYS$SETIMR(%VAL(TIMER_EF),DELTA,,)
	STATUS_H = SYS$WAITFR(%VAL(TIMER_EF))
C
	RETURN
	END
