      OPTIONS/EXTEND
      PROGRAM WHOIS
C
      INCLUDE '($JPIDEF)'
      INCLUDE '($SSDEF)'
C
C DEFINE JPI STRUCTURE
C
      STRUCTURE /ITMLIST/			! JPI ITEM LIST
         UNION					! WE WILL HAVE 11 ITEMS
            MAP					! TO PROMPT FOR.
               INTEGER*2 BUFLEN			! 
               INTEGER*2 CODE			! THE TWELFTH ITEM IS THE
               INTEGER*4 BUFADR			! END CODE.
               INTEGER*4 RETLENADR		!
            END MAP
            MAP
               INTEGER*4 END_LIST
            END MAP
         END UNION
      END STRUCTURE
      RECORD /ITMLIST/ JPILIST(2)
C
C DEFINE THE JPI DATA AREA WHICH IS RETURNED
C
      CHARACTER*8     INFO_ACCOUNT
      INTEGER*4       INFO_ACCOUNT_LENGTH
C
C DEFINE MISCELLANEOUS VARIABLES
C
      CHARACTER*8     CLD_ACCOUNT, ACCOUNT, FIELD2
      CHARACTER*50    FIELD1
      CHARACTER*11    FIELD3
      CHARACTER*22    FIELD4
      CHARACTER*91    FULL
      CHARACTER*20    INSTRNG
      INTEGER*4       JPIPID /JPI$_CHAIN/, SYS$GETJPIW
      CHARACTER*26    UCASE /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      CHARACTER*26    LCASE /'abcdefghijklmnopqrstuvwxyz'/
C
C-----------------------------------------------------------------------
C
C FORMAT STATEMENTS
C
C
C-----------------------------------------------------------------------
C
C SETUP JPI BUFFER
C
      JPILIST(01).BUFLEN      = 8
      JPILIST(01).CODE        = (JPI$_ACCOUNT)
      JPILIST(01).BUFADR      = %LOC(INFO_ACCOUNT)
      JPILIST(01).RETLENADR   = %LOC(INFO_ACCOUNT_LENGTH)
C
      JPILIST(02).END_LIST   = 0
C
C-----------------------------------------------------------------------
C
C GET ACCOUNT
C
100      JPI_RETCODE = SYS$GETJPIW (,,,JPILIST,,,)
C
         IF (JPI_RETCODE.NE.SS$_NORMAL)
     *      CALL SYS$EXIT(%VAL(JPI_RETCODE))
C
      CALL LIB$GET_FOREIGN(INSTRNG, '  String:  ', LenStr)
      CALL STR$TRIM(INSTRNG, INSTRNG(1:LenStr), LenStr)
C
      LenAcc = INFO_ACCOUNT_LENGTH
C
      CALL STR$TRIM(INFO_ACCOUNT, INFO_ACCOUNT(1:LenAcc), LenAcc)
C
      IF ((INDEX(INFO_ACCOUNT(1:LenAcc),'NASA') .EQ. 1) .OR.
     *	  (INFO_ACCOUNT(1:LenAcc) .EQ. 'FORD')          .OR.
     *	  (INFO_ACCOUNT(1:LenAcc) .EQ. 'SYSTEM')) LOOK = 1
C
      WRITE(6,200) INFO_ACCOUNT
200   FORMAT('  WHOIS For Account:  ',A8)
C
      OPEN(UNIT=10, TYPE='OLD', FILE='SYS$SYSTEM:SYSUAF.LIS',
     *     CARRIAGECONTROL = 'LIST', READONLY)
C
      LCNT = 0
      KCNT = 0
C
      IF (LenStr .EQ. 0) THEN
	READ(10,500,IOSTAT=IERR) FIELD1, FIELD2, FIELD3, FIELD4
500     FORMAT(A50, A8, A11, A22)
	DO WHILE (IERR .EQ. 0)
C
	   KCNT = KCNT + 1
C
	   IF ((LOOK.EQ.1).OR.
     *         (INFO_ACCOUNT(1:4).EQ.FIELD2(1:4)).OR.
     *	       (FIELD2(1:4).EQ.'NASA')) THEN
	      WRITE(6,600) FIELD1, FIELD2, FIELD4
600	      FORMAT(1X, A49, A8, 1X, A22)
	      LCNT = LCNT + 1
	   ENDIF
C
	   READ(10,500,IOSTAT=IERR) FIELD1, FIELD2, FIELD3, FIELD4
	ENDDO
C
      ELSE
C
	WRITE(6,300)
300	FORMAT('       Owner         Username           UIC',
     *         '       Account  Directory')
	READ(10,550,IOSTAT=IERR) FULL
550	FORMAT(A91)
C
	DO WHILE (IERR .EQ. 0)
C
	   KCNT = KCNT + 1
C
	   IF (INDEX(FULL(1:91),INSTRNG(1:LenStr)) .NE. 0) THEN
C
		FIELD1 = FULL(1:50)
		FIELD2 = FULL(51:58)
		FIELD3 = FULL(59:69)
		FIELD4 = FULL(70:91)
C
		IF ((LOOK.EQ.1).OR.
     *              (INFO_ACCOUNT(1:4).EQ.FIELD2(1:4)).OR.
     *		    (FIELD2(1:4).EQ.'NASA')) THEN
		   WRITE(6,600) FIELD1, FIELD2, FIELD4
		   LCNT = LCNT + 1
		ENDIF
C
	   ENDIF
C
	   READ(10,550,IOSTAT=IERR) FULL
C
	ENDDO
C
      ENDIF
C
      WRITE(6,700) KCNT, LCNT
700   FORMAT(' %WHOIS-I, ', I3, ' Records scanned.  ', I3, 
     *       ' Accessible Records Found.')
      END
